<?php

// проверка пользователя на существование и его пароля на правильность
function verification($id, $password)
{
	$password = encrypt_user_password($password);
	$sql = 'select count(*) from users where id = ? and password = ? limit 1';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$id, $password]);
	$is = $sth->fetch(PDO::FETCH_NUM)[0];
	if ($is > 0) {
		return true;
	}
	return false;
}

// запись пароля и id в куки, для последующего автовхода
function id_in_cookies($id, $hash)
{
	setcookie('id', $id, time() + 86400 * 365);
	setcookie('hash', $hash, time() + 86400 * 365);
}

// обновить hash в базе
function user_hash_update($id_user, $hash)
{
	$sql = 'update users set hash = ? where id = ? limit 1';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$hash, $id_user]);
}

function auto_authn($id_user)
{
	$hash = hash_generate();
	id_in_cookies($id_user, $hash);
	user_hash_update($id_user, $hash);
}

// генерировать hash
function hash_generate()
{
	return md5(uniqid(microtime(true) . mt_rand(1, 1000)));
}

// функция делает полноценную проверку: может ли пользователь совершить авто-аутентификацию
function token_correct()
{
	$c_id = filter_input(INPUT_COOKIE, 'id');
	$c_hash = filter_input(INPUT_COOKIE, 'hash');
	if ($c_id && $c_hash) {
		$sql = 'select count(*) from users where id = ? and hash = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$c_id, $c_hash]);
		if ($sth->fetch(PDO::FETCH_NUM)[0] > 0) {
			return true;
		}
	}
	return false;
}

// зашифровать пароль пользователя
function encrypt_user_password($password)
{
	return md5($password);
}
