<?php

namespace admin_panel;

/* вход в админ панель */
class admin_panel_entrance
{
	const SECRET_KEY = 'dc5d32a62568da114d97dd31c971be90'; // ключ к админке (пароль), шифровка в md5
	
	public $user_id;
	public $key;
	
	private $entered = false; // true - вошедший
	
	public function __construct($user_id)
	{
		$this->user_id = $user_id;
		if ($this->memorized()) { // если запомненный
			$this->entered = true;
		}
	}
	
	/* вошел? */
	public function is_entered()
	{
		return $this->entered;
	}
	
	/* ввести ключ */
	public function key_enter($key)
	{
		$this->key = $key;
	}
	
	/* войти */
	public function to_com_in()
	{
		if ( ! $this->is_entered()) { // если не вошедший
			if ($this->authn()) { // попытка аутентификации (успешно)
				$this->entered = true;
				$this->remember(); // запомнить
			}
		}
		return false;
	}
	
	/* выйти */
	public function go_out()
	{
		$this->entered = false;
		$this->forget(); // забыть
	}
	
	/* аутентификация */
	private function authn()
	{
		if (md5($this->key) == self::SECRET_KEY) {
			return true;
		} return false;
	}
	
	/* запомнить */
	private function remember()
	{
		$sql = 'insert into admin_panel_users_remember set id_user = ?';
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([$this->user_id]);
		
		return true;
	}
	
	/* запомненный? */
	private function memorized()
	{
		$sql = 'select count(*) from admin_panel_users_remember where id_user = ? limit 1';
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([$this->user_id]);
		
		if ($sth->fetchColumn() > 0) {
			return true;
		} return false;
	}
	
	/* забыть */
	private function forget()
	{
		$sql = 'delete from admin_panel_users_remember where id_user = ?';
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([$this->user_id]);
		
		return true;
	}
}