<?php

class advent_mutagen
{
	const MUTAGEN_PARAM_SUM = 35; //   MUTAGEN_PARAM_SUM  ,       MUTAGEN_NUM
	const MUTAGEN_NUM = 1;
	
	public static function gather($user_id)
	{
		$mutagen_max = self::user_mutagen_max($user_id);
		$mutagen_collected = db\users_advent::mutagen_collected_get($user_id);
		if ($mutagen_collected >= $mutagen_max) {
			return;
		}
		$mutagen_gather = (int) floor(percentage($mutagen_max, 16));
		$mutagen_gather = ($mutagen_gather < 1) ? 1 : $mutagen_gather;
		$mutagen_gather = (($mutagen_collected + $mutagen_gather) > $mutagen_max) ? $mutagen_max - $mutagen_collected : $mutagen_gather;
		db\users_advent::mutagen_collected_increase($mutagen_gather, $user_id);
		user_currency::update_mutagen($mutagen_gather, $user_id);
		$user_statistic = new \user_statistic($user_id);
		$user_statistic->increase_statistic('advent_mutagen', $mutagen_gather);
	}
	
	public static function mutagen_update($user_id)
	{
		if ( ! day_new(db\users_advent::mutagen_collected_timestamp_get($user_id))) {
			return;
		}
		db\users_advent::mutagen_collected_set(0, $user_id);
		db\users_advent::mutagen_collected_timestamp_set(false, $user_id);
	}
	
	public static function mutagen_pack_get()
	{
		return package('advent-mutagen');
	}
	
	/*  - ,     */
	public static function user_mutagen_max($user_id)
	{
		$sum = uc::get_param_sum($user_id);
		$za_kazh = self::MUTAGEN_PARAM_SUM; //   [ ]
		$modf = 1 + $sum / 10000;
		$za_kazh *= $modf;
		$base = 10;
		$mutagen = $sum / $za_kazh + $base;
		$mutagen = (int) round($mutagen);
		return $mutagen + user_cards::collected_bonus_get($user_id, 'mutagen_advent');
	}
}