<?php

namespace balance\prices;

/* шаги тренировки */
class training_steps
{
	/* степенное увеличение цен */
	const POWER = 2.5;
	
	public $step_min = 0;
	public $step_max = 100;
	private $prices;
	
	public function __construct()
	{
		$this->step_max = \training::get_training_limit_max();
		$this->prices = $this->calculate();
	}
	
	public function calculate()
	{
		$step_min = $this->step_min;
		$step_max = $this->step_max;
		$prices = [];
		for ($i = $step_min; $i <= $step_max; $i++) {
			$base = $i + 13;
			$price_bucks = pow($base, self::POWER);
			$price_bucks = (int) round($price_bucks);
			if ($i == $step_max) {
				$price_bucks = 0;
			}
			$prices[] = $price_bucks;
		}
		$this->prices = $prices;
		return $prices;
	}
	
	public function save()
	{
		$sql = 'truncate table _training_steps';
		\db::$pdo->exec($sql);
		
		$prices = $this->prices;
		foreach ($prices as $step => $price) {
			$price_bucks = $price;
			$sql = 'insert into _training_steps set step = ?, price_bucks = ?';
			$sth = \db::$pdo->prepare($sql);
			$sth->execute([$step, $price_bucks]);
		}
	}
}

/* лимиты тренировки */
class training_limit
{
	/* степенное увеличение цен */
	const POWER = 1.9;
	
	public $limit_min = 0;
	public $limit_max = 50;
	
	private $prices;
	
	public function __construct()
	{
		$this->prices = $this->calculate();
	}
	
	public function calculate()
	{
		$limit_min = $this->limit_min;
		$limit_max = $this->limit_max;
		$prices = [];
		$base = self::POWER;
		for ($i = $limit_min; $i <= $limit_max; $i++) {
			$exp = $i + 2;
			$price_mutagen = pow($exp, $base);
			$price_mutagen = (int) round($price_mutagen);
			$prices[] = [
				'level' => $i,
				'limit' => 5 * ($i + 1),
				'price_mutagen' => $price_mutagen
			];
		}
		return $this->prices = $prices;
	}
	
	public function save()
	{
		$sql = 'truncate table _training_limits';
		\db::$pdo->exec($sql);
		
		$prices = $this->prices;
		foreach ($prices as $val) {
			$val = (object) $val;
			$level = $val->level;
			$limit = $val->limit;
			$price_mutagen = $val->price_mutagen;
			$sql = 'insert into _training_limits set level = ?, scope = ?, price_mutagen = ?';
			$sth = \db::$pdo->prepare($sql);
			$sth->execute([$level, $limit, $price_mutagen]);
		}
		
	}
}

/* ампулы */
class ampoule
{
	const POWER = 1.54;
	
	public $level_min = 0;
	public $level_max = 50;
	
	private $prices;
	
	public function __construct()
	{
		$this->prices = $this->calculate();
	}
	
	public function calculate()
	{
		$level_min = $this->level_min;
		$level_max = $this->level_max;
		$prices = [];
		$base = self::POWER;
		for ($i = $level_min; $i <= $level_max; $i++) {
			$exp = $i + 2;
			$price_mutagen = pow($exp, $base);
			$price_mutagen = (int) round($price_mutagen);
			$health = (int) ceil($i / 10);
			$power = (int) ceil($i / 10);
			$agil = (int) ceil($i / 10);
			$intell = (int) ceil($i / 10);
			if ($health < 1) $health = 1;
			if ($power < 1) $power = 1;
			if ($agil < 1) $agil = 1;
			if ($intell < 1) $intell = 1;
			$prices[] = [
				'red' => [
					'level' => $i,
					'price_mutagen' => $price_mutagen,
					'health' => $health + 2,
					'power' => $power + 1,
					'agil' => $agil,
					'intell' => $intell
				],
				'yellow' => [
					'level' => $i,
					'price_mutagen' => $price_mutagen,
					'health' => $health + 1,
					'power' => $power + 2,
					'agil' => $agil,
					'intell' => $intell
				],
				'blue' => [
					'level' => $i,
					'price_mutagen' => $price_mutagen,
					'health' => $health,
					'power' => $power,
					'agil' => $agil + 2,
					'intell' => $intell + 1
				],
				'green' => [
					'level' => $i,
					'price_mutagen' => $price_mutagen,
					'health' => $health,
					'power' => $power,
					'agil' => $agil + 1,
					'intell' => $intell + 2
				]
			];
		}
		return $this->prices = $prices;
	}
	
	public function save()
	{
		$sql = 'truncate table _ampoule';
		\db::$pdo->exec($sql);
		
		$prices = $this->prices;
		foreach ($prices as $val) {
			$val = (object) $val;
			$sql = 'insert into _ampoule set type = ?, level = ?, price_mutagen = ?, health = ?, power = ?, agil = ?, intell = ?';
			$sth = \db::$pdo->prepare($sql);
			
			$sth->execute([
				'red',
				$val->red['level'],
				$val->red['price_mutagen'],
				$val->red['health'],
				$val->red['power'],
				$val->red['agil'],
				$val->red['intell']
			]);
			
			$sth->execute([
				'yellow',
				$val->yellow['level'],
				$val->yellow['price_mutagen'],
				$val->yellow['health'],
				$val->yellow['power'],
				$val->yellow['agil'],
				$val->yellow['intell']
			]);
			
			$sth->execute([
				'blue',
				$val->blue['level'],
				$val->blue['price_mutagen'],
				$val->blue['health'],
				$val->blue['power'],
				$val->blue['agil'],
				$val->blue['intell']
			]);
			
			$sth->execute([
				'green',
				$val->green['level'],
				$val->green['price_mutagen'],
				$val->green['health'],
				$val->green['power'],
				$val->green['agil'],
				$val->green['intell']
			]);
		}
		
	}
}

/* магазинные бонусы */
class bonuses
{
	
}

class clan_building
{
	public $level_min = 0;
	public $level_max = 50;
	private $prices;
	
	public function __construct()
	{
		$this->prices = $this->calculate();
	}
	
	public function calculate()
	{
		$level_min = $this->level_min;
		$level_max = $this->level_max;
		$prices = [];
		$exp = 2;
		for ($i = $level_min; $i <= $level_max; $i++) {
			$price_bucks = 0;
			$price_metal = 0;
			$price_mutagen = 0;
			if ($i % 5 == 0 && $i != 0) {
				$price_mutagen = 2000 + pow($i, 3);
			} else {
				$price_bucks = 100000 + pow(($i * 150), $exp);
				$price_metal = 100000 + pow(($i * 110), $exp);
			}
			$prices[] = [
				'residence' => [
					'level' => $i,
					'price_bucks' => $price_bucks,
					'price_metal' => $price_metal,
					'price_mutagen' => $price_mutagen,
					'bonus' => 0
				],
				'scientific_complex' => [
					'level' => $i,
					'price_bucks' => $price_bucks,
					'price_metal' => $price_metal,
					'price_mutagen' => $price_mutagen,
					'bonus' => $i
				],
				'repository' => [
					'level' => $i,
					'price_bucks' => $price_bucks,
					'price_metal' => $price_metal,
					'price_mutagen' => $price_mutagen,
					'bonus' => $i
				],
				'metal_warehouse' => [
					'level' => $i,
					'price_bucks' => $price_bucks,
					'price_metal' => $price_metal,
					'price_mutagen' => $price_mutagen,
					'bonus' => $i
				],
				'training_hall' => [
					'level' => $i,
					'price_bucks' => $price_bucks,
					'price_metal' => $price_metal,
					'price_mutagen' => $price_mutagen,
					'bonus' => $i
				]
			];
		}
		return $prices;
	}
	
	public function save()
	{
		$sql = 'truncate table _clan_buildings_levels';
		\db::$pdo->exec($sql);
		
		$prices = $this->prices;
		foreach ($prices as $val) {
			$val = (object) $val;
			$sql = 'insert into _clan_buildings_levels set building = ?, level = ?, price_bucks = ?, price_metal = ?, price_mutagen = ?, bonus = ?';
			$sth = \db::$pdo->prepare($sql);
			
			$sth->execute([
				'residence',
				$val->residence['level'],
				$val->residence['price_bucks'],
				$val->residence['price_metal'],
				$val->residence['price_mutagen'],
				$val->residence['bonus']
			]);
			
			$sth->execute([
				'scientific_complex',
				$val->scientific_complex['level'],
				$val->scientific_complex['price_bucks'],
				$val->scientific_complex['price_metal'],
				$val->scientific_complex['price_mutagen'],
				$val->scientific_complex['bonus']
			]);
			
			$sth->execute([
				'repository',
				$val->repository['level'],
				$val->repository['price_bucks'],
				$val->repository['price_metal'],
				$val->repository['price_mutagen'],
				$val->repository['bonus']
			]);
			
			$sth->execute([
				'metal_warehouse',
				$val->metal_warehouse['level'],
				$val->metal_warehouse['price_bucks'],
				$val->metal_warehouse['price_metal'],
				$val->metal_warehouse['price_mutagen'],
				$val->metal_warehouse['bonus']
			]);
			
			$sth->execute([
				'training_hall',
				$val->training_hall['level'],
				$val->training_hall['price_bucks'],
				$val->training_hall['price_metal'],
				$val->training_hall['price_mutagen'],
				$val->training_hall['bonus']
			]);
		}
	}
}

class robbery_rewards
{
	public function calculate()
	{
		$rewards = [];
		$prev_score = 0;
		$prev_mutagen = 4;
		$prev_bucks = 9000;
		for ($i = 1; $i <= 25; $i++) {
			$base = 1000;
			$score = ($prev_score + $base) * 1.3;
			$modf = ceil($i / 5);
			
			$mutagen = 0;
			$bucks = 0;
			if ($i % 2 == 0) {
				$mutagen = $prev_mutagen = $prev_mutagen + 2;
			} else {
				$bucks = $prev_bucks = $prev_bucks + 2000;
			}
			
			$rewards[] = [
				'score' => $score,
				'mutagen' => $mutagen,
				'bucks' => $bucks
			];
			$prev_score = $score;
		}
		return $rewards;
	}
	
	public function save()
	{
		$sql = 'truncate table _robbery_reward_etaps';
		\db::$pdo->exec($sql);
		
		$rewards = $this->calculate();
		foreach ($rewards as $reward) {
			$reward = (object) $reward;
			$sql = 'insert into _robbery_reward_etaps set score = ?, mutagen = ?, bucks = ?';
			$sth = \db::$pdo->prepare($sql);
			$sth->execute([
				$reward->score,
				$reward->mutagen,
				$reward->bucks
			]);
		}
	}
}

class lab
{
	public function __construct()
	{
		
	}
	
	public function calculate()
	{
		$level_min = 1;
		$level_max = 30;
		$prices = [];
		for ($i = 1; $i <= $level_max; $i++) {
			$bucks = 1000 + pow($i * 90, 2);
			$metal = 700 + pow($i * 60, 2);
			$b = ceil($i / 10);
			$bonus_mutagen = 4 + $i + $b;
			$prices[] = [
				'level' => $i,
				'price_bucks' => $bucks,
				'price_metal' => $metal,
				'bonus_mutagen' => $bonus_mutagen
			];
		}
		
		return $prices;
	}
	
	public function save()
	{
		$sql = 'truncate table _levels_lab';
		\db::$pdo->exec($sql);
		
		$prices = $this->calculate();
		foreach ($prices as $val) {
			$val = (object) $val;
			$sql = 'insert into _levels_lab set level = ?, price_bucks = ?, price_metal = ?, bonus_mutagen = ?';
			$sth = \db::$pdo->prepare($sql);
			$sth->execute([
				$val->level,
				$val->price_bucks,
				$val->price_metal,
				$val->bonus_mutagen
			]);
		}
	}
}

class user_levels
{
	public function calculate()
	{
		$level_min = 1;
		$level_max = 50;
		$levels = [];
		$exp_prev = 0;
		for ($i = 1; $i <= $level_max; $i++) {
			$level = $i + 1;
			$ten = (int) ceil($i / 10);
			$bucks = $i * 1000 * $ten;
			$mutagen = $level * $ten;
			if ($level > $level_max) {
				$level = $level_max;
			}
			if ($i < 10) {
				$exp = 500 * $i * 1.4;
				$exp += $exp_prev;
				$exp_prev = $exp;
			} else {
				$pow_plus = (float) "0.$ten";
				$pow_plus /= 2.2;
				$pow = 4.63 + $pow_plus;
				$exp = pow($i, $pow);
			}
			$exp = (int) round($exp);
			
			$levels[] = [
				'level' => $level,
				'expr' => $exp,
				'bucks' => $bucks,
				'mutagen' => $mutagen
			];
		}
		array_unshift($levels, [
			'level' => 1,
			'expr' => 0,
			'bucks' => 0,
			'mutagen' => 0
		]);
		array_pop($levels);
		
		return $levels;
	}
	
	public function save()
	{
		\db::$pdo->exec('truncate table _levels_user');
		
		$levels = $this->calculate();
		$sql = 'insert into _levels_user set level = ?, exp_need = ?, bonus_bucks = ?, bonus_mutagen = ?';
		$sth = \db::$pdo->prepare($sql);
		foreach ($levels as $level) {
			$level = (object) $level;
			$sth->execute([
				$level->level,
				$level->expr,
				$level->bucks,
				$level->mutagen
			]);
		}
	}
}

class clan_levels
{
	public function calculate()
	{
		$level_min = 1;
		$level_max = 50;
		$levels = [];
		$exp_prev = 0;
		for ($i = 1; $i <= $level_max; $i++) {
			$level = $i + 1;
			$ten = (int) ceil($i / 10);
			$bucks = $i * 1000 * $ten;
			$mutagen = $level * $ten;
			if ($level > $level_max) {
				$level = $level_max;
			}
			if ($i <= 10) {
				$exp = 5000 * $i * 4;
				$exp += $exp_prev;
				$exp_prev = $exp;
			} else {
				$exp = pow(50, 5.5);
			}
			$exp = (int) round($exp);
			
			$levels[] = [
				'level' => $level,
				'expr' => $exp,
				'bucks' => $bucks,
				'mutagen' => $mutagen
			];
		}
		array_unshift($levels, [
			'level' => 1,
			'expr' => 0,
			'bucks' => 0,
			'mutagen' => 0
		]);
		
		return $levels;
	}
	
	public function save()
	{
		\db::$pdo->exec('truncate table _levels_user');
		
		$levels = $this->calculate();
		$sql = 'insert into _levels_user set level = ?, exp_need = ?, bonus_bucks = ?, bonus_mutagen = ?';
		$sth = \db::$pdo->prepare($sql);
		foreach ($levels as $level) {
			$level = (object) $level;
			$sth->execute([
				$level->level,
				$level->expr,
				$level->bucks,
				$level->mutagen
			]);
		}
	}
}