<?php

namespace db;

class users_bonuses
{
	public $user_id;
	private $table = 'users_bonuses';
	
	public function __construct()
	{
		if ( ! $this->user_id) {
			$this->user_id = ID;
		}
	}
	
	/* достать рядок */
	public function get()
	{
		$sth = \db::$pdo->query("select * from $this->table where id_user = $this->user_id limit 1");
		return $sth->fetch(\PDO::FETCH_ASSOC);
	}
	
	/* получить уровень бонуса */
	public function get_level($bonus)
	{
		$sql = "select level_$bonus from $this->table where id_user = ? limit 1";
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([$this->user_id]);
		return $sth->fetchColumn();
	}
	
	/* получить текущие бонусы игрока в % */
	public function get_bonuses()
	{
		$user_bonuses = $this->get();
		$obj_tbl_bonuses = new \db\_bonuses;
		$obj_tbl_bonuses->bonus = 'expr';
		$obj_tbl_bonuses->level = $user_bonuses["level_expr"];
		$expr = $obj_tbl_bonuses->get_bonus();
		$obj_tbl_bonuses->bonus = 'bucks';
		$obj_tbl_bonuses->level = $user_bonuses["level_bucks"];
		$bucks = $obj_tbl_bonuses->get_bonus();
		$obj_tbl_bonuses->bonus = 'metal';
		$obj_tbl_bonuses->level = $user_bonuses["level_metal"];
		$metal = $obj_tbl_bonuses->get_bonus();
		return [
			'expr' => $expr,
			'bucks' => $bucks,
			'metal' => $metal
		];
	}
	
	/* получить бонус след. уровня в % */
	public function get_bonuses_next()
	{
		$user_bonuses = $this->get();
		$obj_tbl_bonuses = new \db\_bonuses;
		
		$obj_tbl_bonuses->bonus = 'expr';
		if ($user_bonuses['level_expr'] < $obj_tbl_bonuses->get_bonus_level_max()) {
			$obj_tbl_bonuses->level = $user_bonuses["level_expr"] + 1;
			$expr = $obj_tbl_bonuses->get_bonus();
		}
		else {
			$expr = null;
		}
		
		$obj_tbl_bonuses->bonus = 'bucks';
		if ($user_bonuses['level_bucks'] < $obj_tbl_bonuses->get_bonus_level_max()) {
			$obj_tbl_bonuses->level = $user_bonuses["level_bucks"] + 1;
			$bucks = $obj_tbl_bonuses->get_bonus();
		}
		else {
			$bucks = null;
		}
		
		$obj_tbl_bonuses->bonus = 'metal';
		if ($user_bonuses['level_metal'] < $obj_tbl_bonuses->get_bonus_level_max()) {
			$obj_tbl_bonuses->level = $user_bonuses["level_metal"] + 1;
			$metal = $obj_tbl_bonuses->get_bonus();
		}
		else {
			$metal = null;
		}
		
		return [
			'expr' => $expr,
			'bucks' => $bucks,
			'metal' => $metal
		];
	}
	
	/* получить цены */
	public function get_prices()
	{
		$user_bonuses = $this->get();
		$obj_tbl_bonuses = new \db\_bonuses;
		$obj_tbl_bonuses->bonus = 'expr';
		$obj_tbl_bonuses->level = $user_bonuses['level_expr'];
		$expr = $obj_tbl_bonuses->get_price();
		
		$obj_tbl_bonuses->bonus = 'bucks';
		$obj_tbl_bonuses->level = $user_bonuses['level_bucks'];
		$bucks = $obj_tbl_bonuses->get_price();
		
		$obj_tbl_bonuses->bonus = 'metal';
		$obj_tbl_bonuses->level = $user_bonuses['level_metal'];
		$metal = $obj_tbl_bonuses->get_price();
		return [
			'expr' => $expr,
			'bucks' => $bucks,
			'metal' => $metal
		];
	}
	
	/* увеличить уровень игрока */
	public function level_up($bonus)
	{
		if ( ! $this->is_bonus($bonus)) {
			throw new exception("Тип бонуса '$bonus', не существует.");
		}
		return \db::$pdo->exec("update $this->table set level_$bonus = level_$bonus + 1 where id_user = $this->user_id limit 1");
	}
	
	/* проверка, существует ли такой бонус */
	private function is_bonus($bonus)
	{
		$bonuses = [
			'expr',
			'bucks',
			'metal'
		];
		if (in_array($bonus, $bonuses)) {
			return true;
		} return false;
	}
	
}