<?php

namespace db
{
	class chat extends \_tbl_line
	{
		protected static $table = 'chat';
		
		public static function table_get()	
		{
			return self::$table;
		}
		
		public static function count()
		{
			return self::get('count(*)');
		}
		
		/* посчитать все сообщения кроме скрытых */
		public static function count_not_hide()
		{
			return self::get('count(*)', 'where hide != 1');
		}
		
		public static function timestamp_get($id)
		{
			return self::get('timestamp', 'where id = ?', [$id]);
		}
		
		public static function is_message($id)
		{
			if (self::get('count(*)', 'where id = ?', [$id]) > 0) {
				return true;
			} return false;
		}
		
		public static function is_hide($id)
		{
			if (self::get('hide', 'where id = ?', [$id]) == 1) {
				return true;
			} return false;
		}
		
		public static function hide_set($id, $hide)
		{
			return self::set('hide = ?', 'where id = ?', [$hide, $id]);
		}
	}
	
	class chat_clan extends \_tbl_line
	{
		protected static $table = 'chat_clan';
		
		public static function table_get()	
		{
			return self::$table;
		}
		
		public static function count($clan_id)
		{
			return self::get('count(*)', 'where id_clan = ?', [$clan_id]);
		}
		
		public static function timestamp_get($id)
		{
			return self::get('timestamp', 'where id = ?', [$id]);
		}
	}
}

namespace
{
	class chat
	{
		public static function message_seconds_left_get($id)
		{
			return time() - db\chat::timestamp_get($id);
		}
		
		public static function ban_isset($user_id)
		{
			if ( ! db\users_ban::ban_isset($user_id)) {
				return false;
			}
			if (db\users_ban::ban_type_get($user_id) == 1) {
				return true;
			} return false;
		}
		
		public static function message_add($text, $user_id, $user_adress_id = null)
		{
			if (self::ban_isset($user_id)) {
				return;
			}
			$table = db\chat::table_get();
			$sql = "insert into $table set id_user = ?, id_user_adress = ?, text = ?, timestamp = ?";
			$sth = db::$pdo->prepare($sql);
			$sth->execute([$user_id, $user_adress_id, $text, time()]);
			if ( ! is_null($user_adress_id)) {
				$title = '<a href="' . subord_url('profile', "id_user=$user_id") . '">' . user::login_get($user_id) . '</a> ответил(/а) вам в общем чате';
				$text .= '<br><a href="%s">Ответить</a>';
				$text = sprintf($text, subord_url('chat', "id_user_adress=$user_id"));
				journal::record_add(['title' => $title, 'text' => $text], $user_adress_id);
			}
		}
		
		public static function clan_message_add($clan_id, $text, $user_id, $user_adress_id = null)
		{
			$table = db\chat_clan::table_get();
			$sql = "insert into $table set id_clan = ?, id_user = ?, id_user_adress = ?, text = ?, timestamp = ?";
			$sth = db::$pdo->prepare($sql);
			$sth->execute([$clan_id, $user_id, $user_adress_id, $text, time()]);
			if ( ! is_null($user_adress_id)) {
				$title = '<a href="' . subord_url('profile', "id_user=$user_id") . '">' . user::login_get($user_id) . '</a> ответил(/а) вам в клановом чате';
				$text .= '<br><a href="%s">Ответить</a>';
				$text = sprintf($text, subord_url('chat_clan', "id_user_adress=$user_id"));
				journal::record_add(['title' => $title, 'text' => $text], $user_adress_id);
			}
			$sql = 'update clan_part set chat_new = 1 where id_clan = ?';
			$sth = db::$pdo->prepare($sql);
			$sth->execute([$clan_id]);
		}
		
		public static function user_clan_chat_new_reset($user_id)
		{
			$sql = 'update clan_part set chat_new = 0 where id_user = ? limit 1';
			$sth = db::$pdo->prepare($sql);
			return $sth->execute([$user_id]);
		}
		
		/* есть ли в чате клана новые непрочитанные сообщения */
		public static function is_clan_chat_new($user_id)
		{
			$sql = "select chat_new from clan_part where id_user = $user_id limit 1";
			$sth = \db::$pdo->query($sql);
			if ($sth->fetchColumn() > 0) {
				return true;
			} return false;
		}
		
		/* есть ли у игрока привилегии скрывать сообщения в общем чате */
		public static function is_user_privilege_chat_message_hide($user_id)
		{
			if (\user::position_get($user_id) > 1) {
				return true;
			} return false;
		}
		
		/* скрыть сообщение (общий чат) */
		public static function chat_message_hide($user_id, $id)
		{
			if ( ! self::is_user_privilege_chat_message_hide($user_id)) {
				return false;
			}
			\db\chat::hide_set($id, 1);
		}
		
		/* открыть сообщение (общий чат) */
		public static function chat_message_rehide($user_id, $id)
		{
			if ( ! self::is_user_privilege_chat_message_hide($user_id)) {
				return false;
			}
			\db\chat::hide_set($id, 0);
		}
	}
	
	class chat_model
	{
		public function chat($user_adress_id)
		{
			$user_adress_login = null;
			if ( ! is_null($user_adress_id)) {
				$user_adress_login = user::login_get($user_adress_id);
			}
			$id_user = ID; $ban = null;
			if (db\users_ban::ban_isset($id_user)) {
				$ban = ban_model::ban($id_user);
			}
			
			$user_privilege_message_hide = chat::is_user_privilege_chat_message_hide($id_user);
			
			$table = db\chat::table_get();
			$pag = new pagination;
			
			$rows_num = ($user_privilege_message_hide) ? db\chat::count() : db\chat::count_not_hide();
			$limit = $pag->start($rows_num, 10);
			$where = ($user_privilege_message_hide) ? '' : 'where hide != 1';
			$sql =  "select * from $table $where order by id desc limit $limit[start], $limit[limit]";
			$sth = db::$pdo->query($sql);
			$chat = $sth->fetchAll(PDO::FETCH_ASSOC);
			foreach ($chat as $key => $val) {
				$chat[$key]['user_login'] = user::login_get($val['id_user']);
				$chat[$key]['user_adress_login'] = user::login_get($val['id_user_adress']);
				$chat[$key]['user_icon'] = html::turtle_icon_get($val['id_user']);
				$chat[$key]['message_seconds_left'] = chat::message_seconds_left_get($val['id']);
			}
			
			return [
				'pag' => $pag,
				'chat' => $chat,
				'user_id' => ID,
				'user_adress_id' => $user_adress_id,
				'user_adress_login' => $user_adress_login,
				'ban' => $ban,
				'user_privilege_message_hide' => $user_privilege_message_hide
			];
		}
		
		public function chat_clan($clan_id, $user_adress_id)
		{
			$res = $this->chat_clan_get($clan_id);
			$user_adress_login = null;
			if ( ! is_null($user_adress_id)) {
				$user_adress_login = user::login_get($user_adress_id);
			}
			return [
				'pag' => $res['pag'],
				'chat' => $res['chat'],
				'user_id' => ID,
				'user_adress_id' => $user_adress_id,
				'user_adress_login' => $user_adress_login
				
			];
		}
		
		public function chat_clan_get($clan_id)
		{
			$table = db\chat_clan::table_get();
			$rows_num = db\chat_clan::count($clan_id);
			$pag = new pagination;
			$limit = $pag->start($rows_num, 10);
			$sql = "select * from $table where id_clan = ? order by id desc limit $limit[start], $limit[limit]";
			$sth = db::$pdo->prepare($sql);
			$sth->execute([$clan_id]);
			$chat = $sth->fetchAll(PDO::FETCH_ASSOC);
			foreach ($chat as $key => $val) {
				$chat[$key]['user_login'] = user::login_get($val['id_user']);
				$chat[$key]['user_adress_login'] = user::login_get($val['id_user_adress']);
				$chat[$key]['user_icon'] = html::turtle_icon_get($val['id_user']);
				$chat[$key]['message_seconds_left'] = time() - $val['timestamp'];
			}
			return [
				'pag' => $pag,
				'chat' => $chat
			];
		}
	}
}