<?php

namespace clan;

class app
{
	/* есть ли заявка игрока в опр. клан */
	public static function is_app($user_id, $clan_id)
	{
		$sql = "select count(*) from clan_app where id_user = $user_id and id_clan = $clan_id limit 1";
		$sth = \db::$pdo->query($sql);
		if ($sth->fetchColumn() > 0) {
			return true;
		} return false;
	}
	
	/* может ли игрок принимать по заявкам */
	public static function is_app_avail($user_id)
	{
		if ( ! \clan::is_user_clan($user_id)) {
			return false;
		}
		$rank = \clan::get_user_clan_rank($user_id);
		if (\package('clan-privilege-accept')[$rank]) {
			return true;
		} return false;
	}
	
	/* посчитать количество заявок в клан */
	public static function count($clan_id)
	{
		$sql = "select count(*) from clan_app where id_clan = $clan_id limit 1";
		$sth = \db::$pdo->query($sql);
		return $sth->fetchColumn();
	}
	
	/* удалить все заявки определенного игрока */
	public static function delete_apps($user_id)
	{
		$sql = "delete from clan_app where id_user = ?";
		$sth = \db::$pdo->prepare($sql);
		return $sth->execute([$user_id]);
	}
}

/* создание заявки в клан */
class app_retain
{
	/* кто оставляет */
	public $user_id;
	
	/* в какой клан */
	public $clan_id;
	
	public function __construct()
	{
		if ( ! $this->user_id) {
			$this->user_id = ID;
		}
	}
	
	public function execute()
	{
		if ( ! $this->is_avail()) {
			return false;
		}
		$this->create();
		\notf::$user_id = $this->user_id;
		\notf::set_notf('Заявка подана.', 'default');
		\notf::reset();
	}
	
	/* true если игрок может оставить заявку в клан */
	public function is_avail()
	{
		// если нужный уровень не достигнут
		if ( ! $this->is_user_enter_clan_need_level()) {
			return false;
		}
		// если игрок уже в клане
		if (\clan::is_user_clan($this->user_id)) {
			return false;
		}
		// если в клане недостаточно места
		if ( ! \clan::is_clan_seats($this->clan_id)) {
			return false;
		}
		// если заявка уже есть
		if (app::is_app($this->user_id, $this->clan_id)) {
			return false;
		}
		return true;
	}
	
	/* достиг ли игрок нужного уровня чтоб мочь вступить в клан */
	public function is_user_enter_clan_need_level()
	{
		$config = require ROOT . 'project/internal/config/main.config.php';
		$need_level = $config['user_enter_clan_need_level'];
		$user_level = \user::level_get($this->user_id);
		if ($user_level < $need_level) {
			return false;
		} return true;
	}
	
	private function create()
	{
		return \db::$pdo->exec("insert into clan_app set id_user = $this->user_id, id_clan = $this->clan_id, app_timestamp = " . time());
	}
}

/* принятие в клан по заявке */
class app_accept
{
	/* кто принимает */
	public $user_id;
	
	/* кого принимает */
	public $user_id_accept;
	
	private $clan_id;
	
	public function __construct()
	{
		if ( ! $this->user_id) {
			$this->user_id = ID;
		}
		if (\clan::is_user_clan($this->user_id)) {
			$this->clan_id = \clan::get_id_clan_by_id_user($this->user_id);
		}
		else {
			$this->clan_id = null;
		}
	}
	
	public function execute()
	{
		if ( ! $this->is_app_user()) {
			return false;
		}
		// удалить заявку
		$sql = "delete from clan_app where id_user = $this->user_id_accept and id_clan = $this->clan_id limit 1";
		\db::$pdo->exec($sql);
		
		// завести его в клан !
		\clan::user_clan_enable($this->user_id_accept, $this->clan_id);
		
		// это надо!
		\dyn_set_to_zero_clan_invite_new($this->user_id_accept, 0);
		
		$user_link = '<a href="%s">%s</a>';
		$user_link = sprintf($user_link, subord_url('profile', "id_user=$this->user_id"), \user::login_get($this->user_id));
		$user_accept_link = '<a href="%s">%s</a>';
		$user_accept_link = sprintf($user_accept_link, subord_url('profile', "id_user=$this->user_id_accept"), \user::login_get($this->user_id_accept));
		$jrnl_text =  "$user_link принял(/а) по заявке $user_accept_link";
		\clan_journal::record_add($jrnl_text, $this->clan_id);
		
		\notf::set_notf('Игрок принят.');
		
		$clan_name = \clan::get_clan_name_by_id_clan($this->clan_id);
		$clan_link = '<a href="%s">%s</a>';
		$clan_link = sprintf($clan_link, subord_url('clan', "id_clan=$this->clan_id"), $clan_name);
		$text = "Клан «{$clan_link}» принял вас в свои ряды";
		\journal::record_add(['text' => $text], $this->user_id_accept);
	}
	
	/* может ли игрок принять другого игрока */
	public function is_app_user()
	{
		// нет идентификатора клана
		if ( ! $this->clan_id) {
			return false;
		}
		// тот кого принимают в клане
		if (\clan::is_user_clan($this->user_id_accept)) {
			return false;
		}
		// этот игрок не подавал заявку
		if ( ! app::is_app($this->user_id_accept, $this->clan_id)) {
			return false;
		}
		// может ли игрок принимать по заявкам
		if ( ! app::is_app_avail($this->user_id)) {
			return false;
		}
		// если в клане нет места
		if ( ! \clan::is_clan_seats($this->clan_id)) {
			return false;
		}
		return true;
	}
}