<?php

namespace db
{
	class clan_journal extends \_tbl_line
	{
		protected static $table = 'clan_journal';
		
		public static function table_get()
		{
			return self::$table;
		}
		
		public static function count($clan_id)
		{
			return self::get('count(*)', 'where id_clan = ?', [$clan_id]);
		}
		
		public static function record_add($text, $clan_id)
		{
			self::add('id_clan = ?, text = ?, timestamp = ?', [$clan_id, $text, time()]);
		}
	}
}

namespace
{
	class clan_journal
	{
		public static function record_add($text, $clan_id)
		{
			db\clan_journal::record_add($text, $clan_id);
		}
	}
	
	class clan_journal_model
	{
		public function clan_journal($clan_id)
		{
			$res = $this->clan_journal_get($clan_id);
			// v($res);
			return [
				'pag' => $res['pag'],
				'journal' => $res['journal']
			];
		}
		
		public function clan_journal_get($clan_id)
		{
			$table = db\clan_journal::table_get();
			$pag = new pagination;
			$journal_row_num = db\clan_journal::count($clan_id);
			$limit = $pag->start($journal_row_num, 10);
			$sql = "select * from $table where id_clan = ? order by id desc limit $limit[start], $limit[limit]";
			$sth = db::$pdo->prepare($sql);
			$sth->execute([$clan_id]);
			$journal = $sth->fetchAll(PDO::FETCH_ASSOC);
			/* $time = time();
			foreach ($journal as $key => $val) {
				$journal[$key]['seconds_left'] = $time - $val['timestamp'];
			} */
			return [
				'pag' => $pag,
				'journal' => $journal
			];
		}
	}
}