<?php

namespace indrat
{
	class levels_clan extends \_tbl_line
	{
		protected static $table = '_levels_clan';
		
		public static function exp_need_get($level)
		{
			return self::get('exp_need', 'where level = ?', [$level]);
		}
		
		public static function max()
		{
			return self::get('max(level)');
		}
		
		public static function min()
		{
			return self::get('min(level)');
		}
	}
	
	class clan_level extends \_tbl_line
	{
		protected static $table = 'clan';
		public $clan_id, $level = 1, $increase = true;
		
		public function save()
		{
			if ($this->level) {
				($this->increase)
				? self::set('level = level + ?', 'where id = ?', [$this->level, $this->clan_id])
				: self::set('level = ?', 'where id = ?', [$this->level, $this->clan_id]);
			}
		}
		
		public static function level_get($clan_id)
		{
			return self::get('level', 'where id = ?', [$clan_id]);
		}
	}
}

namespace
{
	class levels_clan extends \indrat\levels_clan
	{
		
	}
	
	class clan_level extends \indrat\clan_level
	{
		// регулятор уровня клана
		public static function regulator_ctrl($clan_id)
		{
			$clan_level = self::level_get($clan_id);
			$clan_exp = clan_exp::exp_get($clan_id);
			static::up_ctrl($clan_id, $clan_level, $clan_exp);
		}
		
		public static function up_ctrl($clan_id, $clan_level, $clan_exp)
		{
			$level_max = levels_clan::max();
			if ($clan_level >= $level_max) {
				return;
			}
			$level_up = 0;
			while (($clan_level + $level_up) < $level_max && $clan_exp >= levels_clan::exp_need_get($clan_level + 1 + $level_up)) {
				$level_up++;
				$level_new = $clan_level + $level_up;
				// начислить награду за уровень
				$sql = 'select reward_mutagen as mutagen, reward_bucks as bucks, reward_metal as metal from _levels_clan where level = ? limit 1';
				$sth = \db::$pdo->prepare($sql);
				$sth->execute([$level_new]);
				$reward = $sth->fetch(\PDO::FETCH_OBJ);
				\clan_coffers::mutagen_refill($clan_id, $reward->mutagen);
				\clan_coffers::bucks_refill($clan_id, $reward->bucks);
				\clan_coffers::metal_refill($clan_id, $reward->metal);
				
				$cjtext = "Уровень клана вырос до <b>%s</b>. В казну начислено: <span class='mutagen-color'>мутаген x%s</span>, <span class='bucks-color'>баксы x%s</span> и <span class='metal-color'>металлолом x%s</span>";
				$cjtext = sprintf($cjtext, $level_new, number_format($reward->mutagen), number_format($reward->bucks), number_format($reward->metal));
				\clan_journal::record_add($cjtext, $clan_id);
			}
			if ($level_up < 1) {
				return;
			}
			$clan_level_obj = new clan_level;
			$clan_level_obj->clan_id = $clan_id;
			$clan_level_obj->level = $level_up;
			$clan_level_obj->save();
			return true;
		}
		
		public static function down_ctrl($clan_id, $clan_level, $clan_exp)
		{
			$level_min = levels_clan::min();
			if ($clan_level <= $level_min) {
				return;
			}
			$level_down = 0;
			while (($clan_level - $level_down) >= $level_min && $clan_exp < levels_clan::exp_need_get($clan_level - $level_down)) {
				$level_down++;
			}
			$clan_level_obj = new clan_level;
			$clan_level_obj->clan_id = $clan_id;
			$clan_level_obj->level = -$level_down;
			$clan_level_obj->save();
			return true;
		}
	}
}