<?php

class_alias('uc', 'users_combat');
class_alias('uc', 'user_combat');

class uc
{
	// получить сумму параметров
	public static function get_param_sum($id_user)
	{
		return array_sum(self::get_param_all($id_user));
	}
	
	// достать какой-то параметр
	public static function get_param($id_user, $param_name)
	{
		if ($param_name != 'health' && $param_name != 'power' && $param_name != 'agil' && $param_name != 'intell') {
			return false;
		}
		
		$sql = "select $param_name from users_combat where id_user = ? limit 1";
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user]);
		
		return $sth->fetch(PDO::FETCH_NUM)[0];
	}
	
	// достать все параметры
	public static function get_param_all($id_user)
	{
		$sql = "select health, power, agil, intell from users_combat where id_user = ? limit 1";
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user]);
		return $sth->fetch(PDO::FETCH_ASSOC);
	}
	
	// изменить параметр
	public static function update_param($id_user, $param_name, $param_num)
	{
		$sql = "update users_combat set $param_name = $param_name + ? where id_user = ? limit 1";
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$param_num, $id_user]);
		
		$sql = "update users_dyn set new_$param_name = new_$param_name + ? where id_user = ? limit 1";
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$param_num, $id_user]);
	}
	
	// изменить все четыре параметра
	/**образец массива [
			'health' => 10,
			'power' => 10,
			...
		]
	*/
	public static function update_param_all($id_user, $param_array, $minus = false)
	{
		$sample = "
			%s = %s %s,
			%s = %s %s,
			%s = %s %s,
			%s = %s %s
		";
		if ($minus) {
			$field = sprintf($sample,
			'health', 'health', '- ?',
			'power', 'power', '- ?',
			'agil', 'agil', '- ?',
			'intell', 'intell', '- ?'
			);
			$nfield = sprintf($sample,
			'new_health', 'new_health', '- ?',
			'new_power', 'new_power', '- ?',
			'new_agil', 'new_agil', '- ?',
			'new_intell', 'new_intell', '- ?'
			);
		}
		else {
			$field = sprintf($sample,
			'health', 'health', '+ ?',
			'power', 'power', '+ ?',
			'agil', 'agil', '+ ?',
			'intell', 'intell', '+ ?'
			);
			$nfield = sprintf($sample,
			'new_health', 'new_health', '+ ?',
			'new_power', 'new_power', '+ ?',
			'new_agil', 'new_agil', '+ ?',
			'new_intell', 'new_intell', '+ ?'
			);
		}
		$sql = "update users_combat set $field where id_user = ? limit 1";
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$param_array['health'], $param_array['power'], $param_array['agil'], $param_array['intell'], $id_user]);
		
		$sql = "update users_dyn set $nfield where id_user = ? limit 1";
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$param_array['health'], $param_array['power'], $param_array['agil'], $param_array['intell'], $id_user]);
	}
	
	/* // изменить параметры игрокам определенного клана
	// (!) только для улучшений резиденции
	public static function clan_parts_update_param_all($id_clan, $param_array)
	{
		$ids = clan::get_clan_part_id_by_id_clan($id_clan);
		if ($ids) {
			$sql = 'update users_combat set health = health + ?, power = power + ?, agil = agil + ?, intell = intell + ? where id_user = ? limit 1';
			$param = (object) $param_array;
			$clan_name = clan::get_clan_name_by_id_clan($id_clan);
			$clan_link = subord_url('clan', "id_clan=$id_clan");
			$jtitle = 'Клан: «%s»';
			$jtitle = sprintf($jtitle, "<a href='$clan_link'>$clan_name</a>");
			$jtext = 'Постройка «%s» была улучшена. Ваши параметры увеличились: +%s выносливости, +%s силы, +%s ловкости и +%s интеллекта';
			$jtext = sprintf($jtext, 'Резиденция', $param->health, $param->power, $param->agil, $param->intell);
			foreach ($ids as $k) {
				$id_user = $k[0];
				$sth = \db::$pdo->prepare($sql);
				$sth->execute([$param->health, $param->power, $param->agil, $param->intell, $id_user]);
				// записать в личный журнал
				\journal::record_add(['title' => $jtitle, 'text' => $jtext], $id_user);
			}
		}
	} */
	
	// узнать насколько изменился определенный параметр
	public static function get_new_param_by_id($id_user, $param_name)
	{
		$sql = "select new_$param_name from users_dyn where id_user = ? limit 1";
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user]);
		return $sth->fetch(PDO::FETCH_NUM)[0];
	}
	
	// узнать насколько изменился все параметры
	public static function get_new_param_all_by_id($user_id = false)
	{
		user_id($user_id);
		return user_dyn::field_get('new_health as health, new_power as power, new_agil as agil, new_intell as intell : assoc', $user_id);
	}
	
	// здоровье игрока в соответствии с его характеристиками
	public static function get_user_combat_health($id_user)
	{
		$sql = 'select health, power, agil, intell from users_combat where id_user = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user]);
		$st = $sth->fetch(PDO::FETCH_ASSOC);
		
		$sum = array_sum($st);
		// $health = (int) floor($st['health'] * 1.2);
		// $health += (int) floor($st['agil'] / 2);
		// $health += (int) floor($st['intell'] / 5);
		return (int) floor($sum / 1.3);
	}

	// урон игрока в соответствии с его характеристиками
	public static function get_user_combat_damage($id_user)
	{
		$sql = 'select health, power, agil, intell from users_combat where id_user = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user]);
		$st = $sth->fetch(PDO::FETCH_ASSOC);
		
		$sum = array_sum($st);
		// $damage = (int) floor($st['power'] / 2.4);
		// $damage += (int) floor($st['agil'] / 5);
		// $damage += (int) floor($st['intell'] / 10);
		return (int) floor($sum / 5.2);
	}
}