<?php

class dump
{
	// получить инф. по всем местам свалки
	// если указан параметр $key, то достает конкретное место
	public static function get_dump_place($key = false)
	{
		$dp = package('dump-place');
		if ($key === false) {
			return $dp;
		}
		else {
			return $dp[$key];
		}
	}
	
	// достать время свалки игрока (конкретной или всех вместе, зависит от параметра $dump)
	public static function get_dump_time($id_user, $dump = false)
	{
		if ($dump === false) {
			$field = 'metal_1_time, metal_2_time, metal_3_time, metal_4_time, metal_5_time';
		}
		else {
			$field = "metal_{$dump}_time";
		}
		$sql = "select $field from users_dump where id_user = ? limit 1";
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user]);
		return $sth->fetch(PDO::FETCH_NUM);
	}
	
	// сколько осталось секунд до завершения поиска на всей свалке или на определенной точке
	public static function get_dump_seconds_left($id_user, $dump = false)
	{
		$time = self::get_dump_time($id_user, $dump);
		$place = self::get_dump_place($dump);
		if ($dump === false) {
			return [
				1 => ($time[0] + $place[1]['searching_time']) - time(),
				2 => ($time[1] + $place[2]['searching_time']) - time(),
				3 => ($time[2] + $place[3]['searching_time']) - time(),
				4 => ($time[3] + $place[4]['searching_time']) - time(),
				5 => ($time[4] + $place[5]['searching_time']) - time()
			];
		}
		else {
			return ($time[0] + $place['searching_time']) - time();
		}
	}
	
	// узнать можно ли начислять награду
	public static function is_reward($id_user, $dump_place)
	{
		$time = self::get_dump_time($id_user, $dump_place)[0];
		if (is_null($time)) {
			return false;
		}
		$sec_left = self::get_dump_seconds_left($id_user, $dump_place);
		if ($sec_left < 1) {
			return true;
		} return false;
	}
	
	// узнать количество металлолома
	public static function get_dump_metal($id_user, $dump = false)
	{
		if ($dump === false) {
			$field = 'metal_1, metal_2, metal_3, metal_4, metal_5';
		}
		else {
			$field = "metal_{$dump}";
		}
		$sql = "select $field from users_dump where id_user = ? limit 1";
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user]);
		if ($dump === false) {
			return $sth->fetch(PDO::FETCH_NUM);
		}
		return $sth->fetch(PDO::FETCH_NUM)[0];
	}
	
	// узнать количество опыта
	public static function get_dump_exp($id_user, $dump = false)
	{
		if ($dump === false) {
			$field = 'exp_1, exp_2, exp_3, exp_4, exp_5';
		}
		else {
			$field = "exp_{$dump}";
		}
		$sql = "select $field from users_dump where id_user = ? limit 1";
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user]);
		if ($dump === false) {
			return $sth->fetch(PDO::FETCH_NUM);
		}
		return $sth->fetch(PDO::FETCH_NUM)[0];
	}
	
	// узнать есть ли точки на которых можно искать (открытые)
	public static function is_place_open($id_user)
	{
		$sql = 'select metal_1_time, metal_2_time, metal_3_time, metal_4_time, metal_5_time from users_dump where id_user = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user]);
		$m = $sth->fetch(PDO::FETCH_NUM);
		$dp = self::get_dump_place();
		$user_level = user_level::get($id_user);
		if (is_null($m[0]) && $user_level >= $dp[1]['level_need']) {
			return true;
		}
		if (is_null($m[1]) && $user_level >= $dp[2]['level_need']) {
			return true;
		}
		if (is_null($m[2]) && $user_level >= $dp[3]['level_need']) {
			return true;
		}
		if (is_null($m[3]) && $user_level >= $dp[4]['level_need']) {
			return true;
		}
		if (is_null($m[4]) && $user_level >= $dp[5]['level_need']) {
			return true;
		} return false;
	}
	
	
	
	
	
	// записать время сбор мет.
	public static function metal_time_update($id_user, $place, $time = false)
	{
		if ($time === false) {
			$time = time();
		}
		$sql = "update users_dump set metal_{$place}_time = ? where id_user = ? limit 1";
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$time, $id_user]);
	}
	
	// изменить количество метала
	public static function metal_num_update($id_user, $place, $num)
	{
		$sql = "update users_dump set metal_{$place} = metal_{$place} + ? where id_user = ? limit 1";
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$num, $id_user]);
	}
	
	// изменить количество опыта
	public static function exp_num_update($id_user, $place, $num)
	{
		$sql = "update users_dump set exp_{$place} = exp_{$place} + ? where id_user = ? limit 1";
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$num, $id_user]);
	}
	
	
	
	
	// контроллер начала поиска
	public static function search_start_ctrl($place)
	{
		$id_user = ID;
		$user_level = user_level::get($id_user);
		if ($user_level < self::get_dump_place($place)['level_need']) { // если уровень игрока меньше, чем нужен
			return;
		}
		$metal = self::get_dump_metal($id_user, $place);
		$exp = self::get_dump_exp($id_user, $place);
		if ($metal > 0 && $exp > 0) { // если металла и опыт еще не собран
			return;
		}
		$sec_left = self::get_dump_seconds_left($id_user, $place);
		if ($sec_left > 0) { // если поиск еще идёт
			return;
		}
		self::metal_time_update($id_user, $place); // начать поиск сменив время
	}
	
	// контроллер начисления награды (ту которую нужно забирать)
	public static function reward_calc_ctrl()
	{
		$id_user = ID;
		$reward[1] = self::is_reward($id_user, 1);
		$reward[2] = self::is_reward($id_user, 2);
		$reward[3] = self::is_reward($id_user, 3);
		$reward[4] = self::is_reward($id_user, 4);
		$reward[5] = self::is_reward($id_user, 5);
		if ( ! $reward[1] && ! $reward[2] && ! $reward[3] && ! $reward[4] && ! $reward[5]) {  // если награда не доступна
			return false;
		}
		
		/**
		 * начисление награды
		 */
		$gdp = self::get_dump_place();
		// $user_level = user_level::get($id_user);
		/* $reward_bonus_user_level = [
			'metal' => [
				1 => 25,
				2 => 40,
				3 => 65,
				4 => 90,
				5 => 115
			],
			'exp' => [
				1 => 5,
				2 => 15,
				3 => 30,
				4 => 45,
				5 => 60
			]
		]; */
		
		foreach ($reward as $key => $val)
		{
			if ($val) {
				/* $metal_bonus_user_level = ($user_level * $reward_bonus_user_level['metal'][$key]);
				$exp_bonus_user_level = ($user_level * $reward_bonus_user_level['exp'][$key]); */
				$metal_min = floor($gdp[$key]['metal'] / 1.1);
				$metal_max = ceil($gdp[$key]['metal'] * 1.1);
				$metal = mt_rand($metal_min, $metal_max);
				$exp_min = floor($gdp[$key]['exp'] / 1.1);
				$exp_max = ceil($gdp[$key]['exp'] * 1.1);
				$exp = mt_rand($exp_min, $exp_max);
				self::metal_num_update($id_user, $key, $metal);
				self::exp_num_update($id_user, $key, $exp);
				self::metal_time_update($id_user, $key, null);
			}
		}
	}
	
	// контроллер сбора награды
	public static function reward_get_ctrl($place)
	{
		$id_user = ID;
		$metal = self::get_dump_metal($id_user, $place);
		$exp = self::get_dump_exp($id_user, $place);
		if ($metal > 0) { // есть что собирать
			self::metal_num_update($id_user, $place, -$metal);
			set_metal($metal, $id_user);
		}
		if ($exp > 0) {
			self::exp_num_update($id_user, $place, -$exp);
			user_exp::exp_set($exp, $id_user);
		}
	}
}

class dump_model
{
	public function dump()
	{
		$id_user = ID;
		$user_level = user_level::get($id_user);
		$dump_place = dump::get_dump_place();
		$dump_metal = dump::get_dump_metal($id_user);
		$dump_exp = dump::get_dump_exp($id_user);
		foreach ($dump_metal as $k => $v) {
			$dump_metal[$k] = user_currency::finnaly_metal($v);
		}
		foreach ($dump_exp as $k => $v) {
			$dump_exp[$k] = user_exp::exp_finnaly($v);
		}
		$dump_seconds_left = dump::get_dump_seconds_left($id_user);
		// v($dump_seconds_left);
		return [
			'user_level' => $user_level,
			'dump_place' => $dump_place,
			'dump_metal' => $dump_metal,
			'dump_exp' => $dump_exp,
			'dump_seconds_left' => $dump_seconds_left
		];
	}
}