<?php

class expr
{
	public $notf = true; // 
	public $bonuses = true; //  
	public $at_clan = true; //      
	public $user_id;
	public $base;
	
	public function __construct($user_id = false)
	{
		if ($user_id) {
			$this->user_id = $user_id;
		} else $this->user_id = ID;
	}
	
	public function private_generate()
	{
		if ( ! $this->bonuses) {
			return $this->base;
		}
		
		/*    " " */
		$bonus = percentage($this->base, user_clan_building::get_training_hall_bonus_exp_percent($this->user_id));
		
		/*    */
		$bonus += percentage($this->base, user_cards::collected_bonus_get($this->user_id, 'expr'));
		
		/*   */
		$obj_user_prem = new \db\users_premium;
		$obj_user_prem->user_id = $this->user_id;
		if ($obj_user_prem->is_premium()) {
			$obj_prem_bonuses = new \premium\bonuses;
			$bonus += percentage($this->base, $obj_prem_bonuses->get()['expr_percent']);
		}
		
		/*     */
		$db_users_bonuses = new \db\users_bonuses;
		$db_users_bonuses->user_id = $this->user_id;
		$bonus += percentage($this->base, $db_users_bonuses->get_bonuses()['expr']);
		
		/*   */
		$stock = new \stock\stock();
		$bonus_expr_percent = $stock->get_bonus_expr();
		$bonus_expr = (int) floor(percentage($this->base, $bonus_expr_percent));
		$bonus += $bonus_expr;
		
		return $this->base + $bonus;
	}
	
	public function clan_generate()
	{
		if ( ! $this->bonuses) {
			return $this->base;
		}
		if ( ! clan::is_user_clan($this->user_id)) {
			return $this->base;
		}
		
		$bonus = percentage($this->base, user_clan_building::get_training_hall_bonus_exp_percent($this->user_id));
		$bonus += percentage($this->base, user_cards::collected_bonus_get($this->user_id, 'expr'));
		$obj_user_prem = new \db\users_premium;
		$obj_user_prem->user_id = $this->user_id;
		if ($obj_user_prem->is_premium()) {
			$obj_prem_bonuses = new \premium\bonuses;
			$bonus += percentage($this->base, $obj_prem_bonuses->get()['expr_percent']);
		}
		
		$db_users_bonuses = new \db\users_bonuses;
		$db_users_bonuses->user_id = $this->user_id;
		$bonus += percentage($this->base, $db_users_bonuses->get_bonuses()['expr']);
		
		return $this->base + $bonus;
	}
	
	public function add()
	{
		$config = require(ROOT . 'project/internal/config/main.config.php');
		$user_avail_levels = $config['user_avail_levels'];
		$user_level = \user::level_get($this->user_id);
		
		$exp_private = $this->private_generate();
		if ($user_level < $user_avail_levels) {
			self::increase($this->user_id, $exp_private);
		}
		
		indrat\user_exp::exp_new_set($exp_private, $this->user_id);
		$user_statistic = new \user_statistic($this->user_id);
		$user_statistic->increase_statistic('expr', $exp_private);
		
		if ($this->at_clan && clan::is_user_clan($this->user_id)) {
			$exp_clan = $this->clan_generate();
			$clan_exp_obj = new clan_exp;
			$clan_exp_obj->clan_id = clan::get_id_clan_by_id_user($this->user_id);
			$clan_exp_obj->exp = $exp_clan;
			$clan_exp_obj->save();
			clan::clan_part_exp_set($this->user_id, $exp_clan);
			$user_statistic = new \user_statistic($this->user_id);
			$user_statistic->increase_statistic('clan_expr', $exp_clan);
		}
	}
	
	public static function increase($user_id, $exp)
	{
		user::exp_set($exp, $user_id);
	}
	
	public static function set($user_id, $exp)
	{
		$sql = 'update users set exp = ? where id = ? limit 1';
		$sth = \db::$pdo->prepare($sql);
		return $sth->execute([$exp, $user_id]);
	}
}