<?php

class filter
{
	public static function login_check($login)
	{
		if ( ! $login) {
			return 2;
		}
		$len = mb_strlen($login);
		if ($len < game::LOGIN_LEN_MIN || $len > game::LOGIN_LEN_MAX) {
			return 4;
		}
		// киррилица, латиница, цифры, тире, подчеркивания, пробелы, точки
		$pattern = "/^[а-яА-ЯёЁa-zA-z0-9\-_\. ]+$/iu";
		if ( ! preg_match($pattern, $login)) {
			return 8;
		}
		
		// есть тире, подч. точки или пробелы в начале строки или в конце
		$pattern_2 = '/^[\-_\. ]/';
		$pattern_3 = '/[\-_\. ]$/';
		if (preg_match($pattern_2, $login) || preg_match($pattern_3, $login)) {
			return 8;
		}
		
		// 1 если есть более одного пробела, тире и н. подчеркивания или точки подрят
		$pattern = '/([-_\. ])\1/';
		if (preg_match($pattern, $login)) {
			return 8;
		}
		return 2020;
	}
	
	public static function password_check($password)
	{
		if ( ! $password) {
			return 2;
		}
		$len = mb_strlen($password);
		if ($len < game::PASSWORD_LEN_MIN || $len > game::PASSWORD_LEN_MAX) {
			return 4;
		}
		return 2020;
	}
	
	public static function email_check($email)
	{
		if ( ! filter_var($email, FILTER_VALIDATE_EMAIL)) {
			return 2;
		}
		return 2020;
	}
	
	public static function clan_name_check($clan_name)
	{
		if ( ! $clan_name) {
			return 2;
		}
		$len = mb_strlen($clan_name);
		if ($len < game::CLAN_NAME_LEN_MIN || $len > game::CLAN_NAME_LEN_MAX) {
			return 4;
		}
		
		$pattern = '/[<>&]/';
		if (preg_match($pattern, $clan_name)) {
			return 8;
		}
		
		/* $pattern = '/[]/';
		if (preg_match($pattern, $clan_name)) {
			return 16;
		} */
		return 2020;
	}
}