<?php

namespace indrat
{
	class log_battle extends \_tbl_line
	{
		protected static $table = '_log_battle';
		
		public static function text_get($id)
		{
			return self::get('text', 'where id = ?', [$id]);
		}
		
		// $some - массив идентификаторов тексты которых нужно взять
		public static function text_some_get($some)
		{
			$some = implode(',', $some);
			return self::all_get('id, text : keypair', ["where id IN($some)", '']);
		}
	}
	
	class user_log_battle extends \_tbl_line
	{
		protected static $table = 'users_log_battle';
		
		public static function text_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('text', 'where id_user = ?', [$user_id]);
		}
		
		public static function text_add($text_id, $text, $user_id = false)
		{
			\user_id($user_id);
			return self::add('id_user = ?, id_text = ?, text = ?', [$user_id, $text_id, $text]);
		}
		
		public static function text_all_get($num, $sort_column, $sort_order, $user_id = false)
		{
			\user_id($user_id);
			return self::all_get('text', ["where id_user = ? order by $sort_column $sort_order", "limit $num"], [$user_id]);
		}
	}
}

namespace
{
	class log_battle_getter
	{
		public $user_id; // id-игрока
		public $num = 6; // количество сообщений в логе
		public $sort_column = 'id';
		public $sort_order = 'desc'; // в каком порядке сортировать
		
		public function get()
		{
			return indrat\user_log_battle::text_all_get($this->num, $this->sort_column, $this->sort_order, $this->user_id);
		}
	}
	
	// функция на основе класса log_battle_setter
	function log_battle_set($text_id, $modf, $user_id)
	{
		$log = new log_battle_setter;
		$log->user_id = $user_id;
		$log->text_id = $text_id;
		$log->modf = $modf;
		$log->mod();
		$log->set();
	}
	
	class log_battle_setter
	{
		public $user_id;
		public $text_id; // массив с идентификаторами текстов (то же что и свойство text, только без необходимости указывать сами тексты)
		public $text; // текст в первозданном виде, [id текста => 'текст', id текста => 'текст']
		public $modf; // модификаторы для меток в тексте, [id текста => ['модификатор1', 'модификатор2']]
		public $result = []; // результ работы метода mod()
		
		public function set()
		{
			$text = $this->result;
			foreach ($text as $key => $val) {
				indrat\user_log_battle::text_add($key, $val, $this->user_id);
			}
		}
		
		public function mod()
		{
			$text = $this->text = $this->text_some_get($this->text_id);
			$modf = $this->modf;
			foreach ($text as $key => $val) {
				if ($key == 1) {
					$this->result[$key] = $this->t_user_hit_inficted($val, $modf[$key]);
				}
				if ($key == 2) {
					$this->result[$key] = $this->t_user_hit_got($val, $modf[$key]);
				}
				if ($key == 3) {
					$this->result[$key] = $this->t_user_killed($val, $modf[$key]);
				}
				if ($key == 4) {
					$this->result[$key] = $this->t_user_died($val, $modf[$key]);
				}
				if ($key == 5) {
					$this->result[$key] = $this->t_user_bloomer($val);
				}
				if ($key == 6) {
					$this->result[$key] = $this->t_user_pancer_fell($val);
				}
				if ($key == 7) {
					
				}
				if ($key == 8) {
					$this->result[$key] = $this->t_user_bloomer_2($val);
				}
			}
		}
		
		// $id - идентификатор текста (int) или нумерованный массив таких идентификаторов (array)
		private function text_some_get($id)
		{
			if ( ! is_array($id)) {
				$id[] = $id;
			}
			return indrat\log_battle::text_some_get($id);
		}
		
		public function result()
		{
			return $this->result;
		}
		
		// игрок нанёс удар
		// modf (array) [0] - количество урона (int)
		public function t_user_hit_inficted($text, $modf)
		{
			return sprintf($text, $modf[0]);
		}
		
		// игрок получил удар
		// modf (array) [0] - имя игрока, который нанёс урон; [1] - количество урона (int)
		public function t_user_hit_got($text, $modf)
		{
			return sprintf($text, $modf[0], $modf[1]);
		}
		
		// игрок убил другого
		// modf (array) [0] - имя игрока (которого убили)
		public function t_user_killed($text, $modf)
		{
			return sprintf($text, $modf[0]);
		}
		
		// игрок умер от рук другого
		// modf (array) [0] - имя игрока (который убил)
		public function t_user_died($text, $modf)
		{
			return sprintf($text, $modf[0]);
		}
		
		// вы бьёте слишком часто (промах)
		public function t_user_bloomer($text)
		{
			return $text;
		}
		
		// вы получили панцырь
		public function t_user_pancer_fell($text)
		{
			return $text;
		}
		
		// вы получили панцырь
		public function t_user_bloomer_2($text)
		{
			return $text;
		}
	}
	
	class log_battle_clean
	{
		public $user_id;
		
		public function start()
		{
			\db::$pdo->query("delete from users_log_battle where id_user = $this->user_id");
		}
	}
	
	class log_battle_model
	{
		public $num;
		
		public function log_battle()
		{
			$user_id = ID;
			$log = new log_battle_getter;
			if ($this->num) $log->num = $this->num;
			$log->user_id = $user_id;

			$text = $log->get();
			return [
				'log' => $text
			];
		}
	}

}