<?php

namespace indrat
{
	class ml1
	{
		// узнать статус
		public static function status_get()
		{
			$sql = 'select status from ml1 limit 1';
			$sth = \db::$pdo->query($sql);
			return $sth->fetchColumn();
		}
		
		// записать статус
		public static function status_set($status)
		{
			$sql = 'update ml1 set status = ? limit 1';
			$sth = \db::$pdo->prepare($sql);
			return $sth->execute([$status]);
		}
		
		// получить статус награды
		public static function reward_received_get()
		{
			$sql = 'select reward_received from ml1 limit 1';
			$sth = \db::$pdo->query($sql);
			return $sth->fetchColumn();
		}
		
		// сменить статус награды
		public static function reward_received_set($status)
		{
			$sql = 'update ml1 set reward_received = ? limit 1';
			$sth = \db::$pdo->prepare($sql);
			$sth->execute([$status]);
		}
		
		// должен ли идти (идет) бой
		public static function battle_is()
		{
			// return true;
			return \front_of(5);
		}
		
		// сколько секунд осталось до следующей битвы
		public static function battle_white_seconds()
		{
			$toh = getdate()['hours'] + 1;
			return strtotime("$toh:00") - time();
		}
		
		// сколько осталось до конца сражения
		public static function battle_end_seconds_left()
		{
			$toh = getdate()['hours'];
			return strtotime("$toh:05") - time();
		}
	}
	
	class ml1_part extends \_tbl_line
	{
		const ROSE_SECONDS_BASE = 6; // базовое время воскрешения
		const DODGE_RECOVERY_SECONDS_BASE = 15; // базовое время восстановления уворота
		static protected $table = 'ml1_part';
		
		// существует ли такой участник (был ли уже записан)
		public static function part_isset($user_id = false)
		{
			\user_id($user_id);
			if (self::get('count(*)', 'where id_user = ?', [$user_id]) > 0) {
				return true;
			} return false;
		}
		
		// создать участника
		public static function part_create($health, $status, $user_id = false)
		{
			\user_id($user_id);
			self::add("id_user = ?, health = ?, status = ?", [$user_id, $health, $status]);
		}
		
		// удалить участника
		public static function part_delete($user_id = false)
		{
			$sql = 'delete from ' . self::$table . ' where id_user = ? limit 1';
			$sth = \db::$pdo->prepare($sql);
			$sth->execute([$user_id]);
		}
		
		// удалить всех участников
		public static function part_truncate()
		{
			\db::$pdo->exec('truncate ml1_part');
		}
		
		// посчитать участников
		public static function part_count()
		{
			return self::get('count(*)');
		}
		
		// получить здоровье участника
		public static function part_health_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('health', 'where id_user = ?', [$user_id]);
		}
		
		// записать здоровье участника
		public static function part_health_set($health, $user_id = false)
		{
			\user_id($user_id);
			return self::set('health = ?', 'where id_user = ?', [$health, $user_id]);
		}
		
		// отминусовать здоровье участника
		public static function part_health_minus($health, $user_id = false)
		{
			\user_id($user_id);
			return self::set('health = health - ?', 'where id_user = ?', [$health, $user_id]);
		}
		
		// получить урон участника
		public static function part_damage_get($user_id = false)
		{
			\user_id($user_id);
			return \uc::get_user_combat_damage($user_id);
		}
		
		// узнать статус участника (жив, мёртв...)
		public static function part_status_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('status', 'where id_user = ?', [$user_id]);
		}
		
		// записать статус участника (жив, мёртв...)
		public static function part_status_set($status, $user_id = false)
		{
			\user_id($user_id);
			return self::set('status = ?', 'where id_user = ?', [$status, $user_id]);
		}
		
		// получить метку времени статуса
		public static function part_status_timestamp_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('status_timestamp', 'where id_user = ?', [$user_id]);
		}
		
		// записать метку времени статуса
		public static function part_status_timestamp_set($status_timestamp = false, $user_id = false)
		{
			\user_id($user_id);
			if ($status_timestamp === false) {
				$status_timestamp = time();
			}
			return self::set('status_timestamp = ?', 'where id_user = ?', [$status_timestamp, $user_id]);
		}
		
		// узнать сколько осталось до воскрешения
		public static function part_rose_seconds_left($user_id = false)
		{
			\user_id($user_id);
			$status_timestamp = self::part_status_timestamp_get($user_id);
			return ($status_timestamp + self::ROSE_SECONDS_BASE) - time();
		}
		
		// узнать прошло ли время воскрешения
		public static function part_rose_seconds_gone($user_id = false)
		{
			\user_id($user_id);
			if (static::part_rose_seconds_left($user_id) < 1) {
				return true;
			} return false;
		}
		
		// узнать цель участника (id игрока)
		public static function part_target_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('target', 'where id_user = ?', [$user_id]);
		}
		
		// записать новую цель участника
		public static function part_target_set($target_id, $user_id = false)
		{
			\user_id($user_id);
			return self::set('target = ?', 'where id_user = ?', [$target_id, $user_id]);
		}
		
		
		
		
		// узнать статус уворота
		public static function part_dodge_status_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('dodge_status', 'where id_user = ?', [$user_id]);
		}
		
		// записать новый статус уворота цель
		public static function part_dodge_status_set($dodge_status, $user_id = false)
		{
			\user_id($user_id);
			return self::set('dodge_status = ?', 'where id_user = ?', [$dodge_status, $user_id]);
		}
		
		// получить временную метку статуса уворота
		public static function part_dodge_status_timestamp_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('dodge_status_timestamp', 'where id_user = ?', [$user_id]);
		}
		
		// изменить временную метку статуса уворота
		public static function part_dodge_status_timestamp_set($dodge_status_timestamp = false, $user_id = false)
		{
			\user_id($user_id);
			if ($dodge_status_timestamp === false) {
				$dodge_status_timestamp = time();
			}
			return self::set('dodge_status_timestamp = ?', 'where id_user = ?', [$dodge_status_timestamp, $user_id]);
		}
		
		// сколько осталось до возобновления уворота
		public static function part_dodge_seconds_left($user_id = false)
		{
			\user_id($user_id);
			$dodge_status_timestamp = self::part_dodge_status_timestamp_get($user_id);
			return ($dodge_status_timestamp + self::DODGE_RECOVERY_SECONDS_BASE) - time();
		}
		
		// узнать прошло ли время возобновления уворота (true, false)
		public static function part_dodge_seconds_gone($user_id = false)
		{
			\user_id($user_id);
			if (self::part_dodge_seconds_left($user_id) < 1) {
				return true;
			} return false;
		}
		
		
		
		
		
		// узнать статус удара
		public static function part_hit_status_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('hit_status', 'where id_user = ?', [$user_id]);
		}
		
		// записать новый статус удара цель
		public static function part_hit_status_set($hit_status, $user_id = false)
		{
			\user_id($user_id);
			return self::set('hit_status = ?', 'where id_user = ?', [$hit_status, $user_id]);
		}
		
		// получить временную метку статуса удара
		public static function part_hit_status_timestamp_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('hit_status_timestamp', 'where id_user = ?', [$user_id]);
		}
		
		// изменить временную метку статуса удара
		public static function part_hit_status_timestamp_set($hit_status_timestamp = false, $user_id = false)
		{
			\user_id($user_id);
			if ($hit_status_timestamp === false) {
				$hit_status_timestamp = time();
			}
			return self::set('hit_status_timestamp = ?', 'where id_user = ?', [$hit_status_timestamp, $user_id]);
		}
		
		// сколько осталось до возобновления удара
		public static function part_hit_seconds_left($user_id = false)
		{
			\user_id($user_id);
			$hit_status_timestamp = self::part_hit_status_timestamp_get($user_id);
			return ($hit_status_timestamp + \game::PVP_HIT_DELAY) - time();
		}
		
		// узнать прошло ли время возобновления удара (true, false)
		public static function part_hit_seconds_gone($user_id = false)
		{
			\user_id($user_id);
			if (self::part_hit_seconds_left($user_id) < 1) {
				return true;
			} return false;
		}
		
		
		
		
		// сбросить цель с игрока (у всех остальных участников)
		public static function part_target_reset($user_id = false)
		{
			\user_id($user_id);
			self::set('target = default', ['where id_user != ?', ''], [$user_id]);
		}
		
		// получить id всех участников
		public static function part_id_live_all_get()
		{
			$sql = 'select id_user from ' . self::$table . 'where status = 1';
			$sth = \db::$pdo->query($sql);
			return $sth->fetchAll(\PDO::FETCH_NUM);
		}
		
		// получить id всех участников, при этом исключив некоторые из массива, который передается в первом аргументе
		// параметр live указывает что нужно выбирать только живих участников
		public static function part_id_deleted_all_get($part_id_deleted, $live = true)
		{
			$part_id_deleted = implode(',', $part_id_deleted);
			$add = " where id_user NOT IN($part_id_deleted)";
			$ladd = '';
			if ($live) {
				$ladd = ($add) ? ' and status = 1' : ' where status = 1';
			}
			$sql = 'select id_user from ' . self::$table . $add . $ladd;
			$sth = \db::$pdo->query($sql);
			return $sth->fetchAll(\PDO::FETCH_NUM);
		}
		
		// получить случайный id участника
		// $part_id_deleted - исключить другие id (но если кроме этих id больше никаких не будет, то в качестве возврата выберет один из них)
		public static function target_id_random($part_id_deleted)
		{
			$part_id_all = self::part_id_deleted_all_get($part_id_deleted);
			if ( ! $part_id_all) {
				return null;
			}
			$key_target_id = array_rand($part_id_all);
			if (is_null($key_target_id)) {
				return null;
			} return $part_id_all[$key_target_id][0];
		}
		
		// полученный урон, узнать
		public static function part_damage_received_get($user_id)
		{
			return self::get('damage_received', 'where id_user = ?', [$user_id]);
		}
		
		// полученный урон, увеличить
		public static function part_damage_received_increase($user_id, $damage)
		{
			return self::set('damage_received = damage_received + ?', 'where id_user = ?', [$damage, $user_id]);
		}
		
		// полученный урон, обнулить
		public static function part_damage_received_reset($user_id)
		{
			return self::set('damage_received = 0', 'where id_user = ?', [$user_id]);
		}
		
		// нанесенный урон, узнать
		public static function part_damage_applied_get($user_id)
		{
			return self::get('damage_applied', 'where id_user = ?', [$user_id]);
		}
		
		// нанесенный урон, увеличить
		public static function part_damage_applied_increase($user_id, $damage)
		{
			return self::set('damage_applied = damage_applied + ?', 'where id_user = ?', [$damage, $user_id]);
		}
		
		// нанесенный урон, обнулить
		public static function part_damage_applied_reset($user_id)
		{
			return self::set('damage_applied = 0', 'where id_user = ?', [$user_id]);
		}
	}
	
	class ml1_statistic extends \_tbl_line
	{
		protected static $table = 'ml1_statistic';
		
		// существует ли запись с таким игроком
		public static function user_is($user_id = false)
		{
			\user_id($user_id);
			if (self::get('count(*)', 'where id_user = ?', [$user_id]) > 0) {
				return true;
			} return false;
		}
		
		// создать запись с игроком
		public static function user_create($user_id = false)
		{
			\user_id($user_id);
			self::add('id_user = ?', [$user_id]);
		}
		
		// получить урон
		public static function damage_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('damage', 'where id_user = ?', [$user_id]);
		}
		
		// получить кол-во убийств
		public static function killed_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('killed', 'where id_user = ?', [$user_id]);
		}
		
		// записать/увеличить урон
		public static function damage_set($damage, $increase = true, $user_id = false)
		{
			\user_id($user_id);
			if ($increase) {
				return self::set('damage = damage + ?', 'where id_user = ?', [$damage, $user_id]);
			} self::set('damage = ?', 'where id_user = ?', [$damage, $user_id]);
		}
		
		// записать/увеличить кол-во убийств
		public static function killed_set($killed, $increase = true, $user_id = false)
		{
			\user_id($user_id);
			if ($increase) {
				return self::set('killed = killed + ?', 'where id_user = ?', [$killed, $user_id]);
			} self::set('killed = ?', 'where id_user = ?', [$killed, $user_id]);
		}
		
		// очистить статистику
		public static function truncate()
		{
			\db::$pdo->exec('truncate ml1_statistic');
		}
		
		// посчитать кол-во игроков в статистике
		public static function user_count()
		{
			return self::get('count(*)');
		}
	}
	
	class ml1_reward extends \_tbl_line
	{
		protected static $table = 'ml1_reward';
		
		// получить кол-во мутагена игрока
		public static function mutagen_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('mutagen', 'where id_user = ?', [$user_id]);
		}
		
		// записать/увеличить мутаген игрока
		public static function mutagen_set($mutagen, $increase = true, $user_id = false)
		{
			\user_id($user_id);
			if ($increase) {
				return self::set('mutagen = mutagen + ?', 'where id_user = ?', [$mutagen, $user_id]);
			} self::set('mutagen = ?', 'where id_user = ?', [$mutagen, $user_id]);
		}
		
		// забрана ли награда
		public static function part_reward_took($user_id = false)
		{
			\user_id($user_id);
			if (self::get('reward_took', 'where id_user = ?', [$user_id]) == 1) {
				return true;
			} return false;
		}
		
		// сменить статус награды
		public static function part_reward_took_set($took, $user_id = false)
		{
			\user_id($user_id);
			self::set('reward_took = ?', 'where id_user = ?', [$took, $user_id]);
		}
		
		// есть ли награда
		public static function reward_is($user_id)
		{
			if (self::mutagen_get($user_id) > 0) {
				return true;
			} return false;
		}
	}
}

namespace
{
	class ml1 extends indrat\ml1
	{
		// контроллер статуса
		// статус 1 - ожидание, 3 - бой
		public static function ctrl_battle_status()
		{
			$status = $status_old = self::status_get();
			if ($status == 1) { // статус 1 - ожидание (не бой и не подготовка)
				if (self::battle_is()) { // если настало время для боя
					$status = 3; // перекинуть на статус 3 (бой)
					ml1_part::part_truncate(); // и удалить всех старых участников
					ml1_statistic::truncate(); // очистить старую статистику
				}
			}
			if ($status == 3) { // если бой
				if ( ! self::battle_is()) { // не время для боя
					/**
					 * поставить всем участникам метку о возможности начисления награды
					 */
					$sql = 'update ml1_reward mr set mr.reward_took = 0 where mr.id_user = (select mp.id_user from ml1_part mp where mp.id_user = mr.id_user)';
					db::$pdo->exec($sql);
					
					$status = 1; // перекинуть на статус 1 (ожидание)
				}
			}
			if ($status != $status_old) { // статус поменялся
				self::status_set($status);
			}
		}
		
		// контроллер награды
		public static function ctrl_reward()
		{
			$reward_received = ml1::reward_received_get();
			$battle_is = ml1::battle_is();
			
			// если бой идет, и награда получена
			if ($battle_is && $reward_received != 0) {
				ml1::reward_received_set(0);
				return;
			}
			
			// далее проверяем если бой уже не идет и награды не начислены, то начисляем награды и меняем reward_received на 1
			if ( ! $battle_is && $reward_received == 0) {
				
				// получить всех участников с уроном > 0
				$sql = 'select id_user from ml1_statistic where damage > 0';
				$sth = \db::$pdo->query($sql);
				$part = $sth->fetchAll(\PDO::FETCH_NUM);
				if ($part) {
					foreach ($part as $p) {
						$user_id = $p[0];
						$damage = ml1_statistic::damage_get($user_id);
						$killed = ml1_statistic::killed_get($user_id);
						$mutagen_killed = percentage($killed, 30);
						$mutagen_killed = (int) floor($mutagen_killed);
						if ($mutagen_killed > 15) {
							$mutagen_killed = 15;
						}
						
						$mutagen_damage = floor(sqrt($damage) / 15);
						
						$mutagen = $mutagen_killed + $mutagen_damage;
						if ($mutagen > 25) $mutagen = 25;
						
						ml1_reward::mutagen_set($mutagen, true, $user_id);
					}
				}
				
				ml1::reward_received_set(1); // отметка о том что награды начислены
			}
		}
	}
	
	class ml1_part extends indrat\ml1_part
	{
		// узнать сколько осталось до воскрешения
		public static function part_rose_seconds_left($user_id = false)
		{
			\user_id($user_id);
			$fine = (int) floor(\uc::get_user_combat_damage($user_id) / 300); // штраф (+1 секунда за 500 урона, но не более 10 сек.)
			if ($fine > 10) {
				$fine = 10;
			}
			return parent::part_rose_seconds_left($user_id) + $fine;
		}
		
		// контроллер создания участника
		public static function part_create_ctrl()
		{
			$user_id = ID;
			if (self::part_isset($user_id)) { // такой участник уже существует
				return;
			}
			$health = uc::get_user_combat_health($user_id);
			self::part_create($health, 1, $user_id);
		}
		
		// контроллер удаления участника
		public static function part_delete_ctrl()
		{
			$user_id = ID;
			if ( ! self::part_isset($user_id)) { // такой участник уже существует
				return;
			}
			self::part_delete($user_id);
		}
		
		// контроллер автовыбора цели игрока
		public static function user_target_ctrl()
		{
			$user_id = ID;
			$target_need = false; // нужна ли новая цель
			$target_id = ml1_part::part_target_get($user_id); // узнать цель игрока
			$target_status = ml1_part::part_status_get($target_id); // узнать статус этой цели
			if (is_null($target_id)) { // если цели нет вообще
				$target_need = true; // цель нужна
			}
			elseif ($target_status == 2) { // если текущая цель уже умерла
				$target_need = true;
			}
			if ( ! $target_need) { // новая цель не нужна
				return;
			}
			
			if (is_null(ml1_part::target_change($user_id, [$user_id]))) {
				return false;
			} return true;
		}
		
		// смена цели
		// user_id - какому игроку сменить цель
		// part_id_deleted - каких игроков исключить в качестве новой цели
		public static function target_change($user_id, $part_id_deleted)
		{
			$target_id_new = self::target_id_random($part_id_deleted);
			if ( ! $target_id_new) {
				$target_id_new = null;
			}
			ml1_part::part_target_set($target_id_new, $user_id);
			return $target_id_new;
		}
		
		// контроллер удара
		public static function user_hit_ctrl()
		{
			$user_id = ID;
			$user_status = ml1_part::part_status_get($user_id);
			if ($user_status == 2) { // нельзя бить при статусе 2 (ранен)
				return;
			}
			
			$target_id = ml1_part::part_target_get($user_id);
			if (is_null($target_id)) { // цели нет
				$is = static::user_target_ctrl(); // попробовать поставить игроку новую цель
				if ( ! $is) {
					return;
				}
			}
			
			$target_status = ml1_part::part_status_get($target_id);
			if ($target_status == 2) { // если цель мертва
				ml1_part::part_target_set(null, $user_id);
				$is = static::user_target_ctrl(); // попробовать поставить игроку новую цель
				if ( ! $is) {
					return;
				}
			}
			
			if (ml1_part::part_hit_status_get($user_id) == 2) { // удар еще не восстановился
				log_battle_set([5], null, $user_id); // сброс сообщения в лог (о промахе)
				return;
			}
			
			$target_health = ml1_part::part_health_get($target_id);
			$user_damage = ml1_part::part_damage_get($user_id);
			$user_damage = (new \damage)->pvp_generate($user_damage);
			$damage_inficted = $user_damage; // нанесенный урон
			$target_health_new = ($target_health - $user_damage);
			$pancer_fell = false;
			if ($target_health_new < 1) { // цель была убита этим ударом
				$damage_inficted = $target_health; // записать оставшееся здоровье врага (а не полный нанесенный урон игроком, как ожидается)
				$pancer_chance = 25;
				$obj_user_prem = new \db\users_premium;
				$obj_user_prem->user_id = $user_id;
				if ($obj_user_prem->is_premium()) {
					$obj_prem_bonuses = new \premium\bonuses;
					$pancer_chance = $obj_prem_bonuses->get()['ml1_pancer_chance'];
				}
				if (mt_rand(1, 100) <= $pancer_chance) { // шанс 15%
					user_currency::update_pancers(1, $user_id);
					$pancer_fell = true;
				}
				ml1_part::part_status_set(2, $target_id); // умертвить сменой статуса
				ml1_part::part_status_timestamp_set(false, $target_id); // записать время
				ml1_statistic::killed_set(1, true, $user_id);
				$user_statistic = new \user_statistic($user_id);
				$user_statistic->increase_statistic('ml1_killed_enemies', 1);
			}
			else { // цель не была убита
				ml1_part::part_damage_applied_increase($user_id, $user_damage); // нанесенный урон, увеличить для игрока, который бьёт
				ml1_part::part_damage_received_increase($target_id, $user_damage); // полученный урон, увеличить для цели
			}
			ml1_statistic::damage_set($damage_inficted, true, $user_id);
			
			$user_name = user::login_get($user_id);
			$target_name = user::login_get($target_id);
			if ($target_health_new > 0) {
				log_battle_set([1], [1 => [$user_damage]], $user_id);
				log_battle_set([2], [2 => [$user_name, $user_damage]], $target_id);
			}
			else {
				log_battle_set([3], [3 => [$target_name]], $user_id);
				log_battle_set([4], [4 => [$user_name]], $target_id);
			}
			if ($pancer_fell) {
				log_battle_set([6], null, $user_id);
			}
			
			
			ml1_part::part_health_set($target_health_new, $target_id);
			ml1_part::user_hit_delay_ctrl($user_id);
		}
		
		// возвращение в бой после ранения
		public static function user_rose_ctrl()
		{
			$user_id = ID;
			$user_status = ml1_part::part_status_get($user_id);
			if ($user_status != 2) { // если игрок не мёртв
				return;
			}
			if ( ! ml1_part::part_rose_seconds_gone($user_id)) { // время не прошло
				return;
			}
			ml1_part::part_status_set(1, $user_id);
			ml1_part::part_health_set(uc::get_user_combat_health($user_id), $user_id);
		}
		
		// контроллер уворота игрока
		public static function user_dodge_ctrl()
		{
			$user_id = ID;
			if (ml1_part::part_dodge_status_get($user_id) == 2) { // уворот еще не восстановился
				return;
			}
			
			ml1_part::part_target_reset($user_id); // сбросить с цели
			ml1_part::part_dodge_status_set(2, $user_id); // установить статус уворота 2 (заблокировать уворот на определенное время)
			ml1_part::part_dodge_status_timestamp_set(false, $user_id); // установить временную метку
		}
		
		// контроллер восстановления уворота игрока
		public static function user_dodge_recovery_ctrl()
		{
			$user_id = ID;
			if (ml1_part::part_dodge_status_get($user_id) == 1) { // уворот итак восстановлен
				return;
			}
			if ( ! ml1_part::part_dodge_seconds_gone($user_id)) { // время еще не прошло
				return;
			}
			ml1_part::part_dodge_status_set(1, $user_id); // восстановить уворот
		}
		
		// контроллер удара игрока
		public static function user_hit_delay_ctrl()
		{
			$user_id = ID;
			ml1_part::part_hit_status_set(2, $user_id); // установить статус удара 2 (заблокировать удар на определенное время)
			ml1_part::part_hit_status_timestamp_set(false, $user_id); // установить временную метку
		}
		
		// контроллер восстановления удара игрока
		public static function user_hit_delay_recovery_ctrl()
		{
			$user_id = ID;
			if (ml1_part::part_hit_status_get($user_id) == 1) { // удар итак восстановлен
				return;
			}
			if ( ! ml1_part::part_hit_seconds_gone($user_id)) { // время еще не прошло
				return;
			}
			ml1_part::part_hit_status_set(1, $user_id); // восстановить удар
		}
		
		// контроллер смены цели
		public static function user_change_ctrl()
		{
			$user_id = ID;
			$target_id_current = ml1_part::part_target_get($user_id);
			$target_id = null;
			if ( ! is_null($target_id_current)) {
				$target_id = ml1_part::target_id_random([$user_id, $target_id_current]);
			}
			if (is_null($target_id)) {
				$target_id = ml1_part::target_id_random([$user_id]);
			}
			ml1_part::part_target_set($target_id, $user_id);
		}
	}
	
	class ml1_statistic extends indrat\ml1_statistic
	{
		// контроллер статистики игрока
		public static function user_statistic_ctrl()
		{
			$user_id = ID;
			if (self::user_is($user_id)) { // если запись уже существует
				return;
			}
			self::user_create($user_id);
		}
	}
	
	class ml1_reward extends indrat\ml1_reward
	{
		// контроллер сбора награды
		public static function reward_gather_ctrl()
		{
			$user_id = ID;
			if (0 >= $mutagen = self::mutagen_get($user_id)) {
				return;
			}
			self::mutagen_set(0, false, $user_id); // обнулить награду
			user_currency::update_mutagen($mutagen, $user_id);
		}
	}
	
	class ml1_model
	{
		// ожидание
		public function expect()
		{
			$user_id = ID;
			
			$part_num = ml1_part::part_count();
			$battle_white_seconds = ml1::battle_white_seconds();
			$reward_mutagen = ml1_reward::mutagen_get($user_id);
			$part_isset = ml1_part::part_isset($user_id);
			return [
				'part_num' => $part_num,
				'battle_white_seconds' => $battle_white_seconds,
				'reward_mutagen' => $reward_mutagen,
				'part_isset' => $part_isset
			];
		}
		
		// бой
		public function battle()
		{
			$user_id = ID;
			$user_status = ml1_part::part_status_get($user_id);
			$dodge_status = ml1_part::part_dodge_status_get($user_id);
			$target_id = ml1_part::part_target_get($user_id);
			
			$user = [];
			$target = [];
			$user_rose_seconds_left = null;
			if ($user_status == 1) {
				$user['name'] = user::login_get($user_id);
				$user['health'] = ml1_part::part_health_get($user_id);
				$user['health_max'] = uc::get_user_combat_health($user_id);
				$user['damage'] = ml1_part::part_damage_get($user_id);
			}
			elseif ($user_status == 2) {
				$user_rose_seconds_left = ml1_part::part_rose_seconds_left($user_id);
			}
			
			$target = [
				'name' => null,
				'health' => null,
				'health_max' => null,
				'damage' => null,
			];
			if ( ! is_null($target_id)) {
				$target['name'] = user::login_get($target_id);
				$target['health'] = ml1_part::part_health_get($target_id);
				$target['health_max'] = uc::get_user_combat_health($target_id);
				$target['damage'] = ml1_part::part_damage_get($target_id);
			}
			
			$hit_access = true;
			$dodge_access = true;
			$change_access = true;
			if ($user_status == 2 || ! $target_id) {
				$hit_access = false;
				$dodge_access = false;
				$change_access = false;
			}
			if ($dodge_status == 2) {
				$dodge_access = false;
			}
			$dodge_seconds_left = ml1_part::part_dodge_seconds_left($user_id);
			
			$panel_battle = new model\panel_battle;
			$panel_battle->target_is_real_player = true;
			$panel_battle->target_id = $target_id;
			$panel_battle->target_name = $target['name'];
			$panel_battle->target_health = $target['health'];
			$panel_battle->target_health_max = $target['health_max'];
			$panel_battle->target_damage = $target['damage'];
			$panel_battle->user_damage_applied = ml1_part::part_damage_applied_get($user_id);
			$panel_battle->hit_access = $hit_access;
			$panel_battle->dodge_access = $dodge_access;
			$panel_battle->dodge_seconds_left = $dodge_seconds_left;
			$panel_battle->change_access = $change_access;
			$panel_battle = $panel_battle->get();
			
			$user_damage_received = ml1_part::part_damage_received_get($user_id);
			
			$battle_end_seconds_left = ml1::battle_end_seconds_left();
			return [
				'user_id' => $user_id,
				'user_status' => $user_status,
				'user' => $user,
				'user_rose_seconds_left' => $user_rose_seconds_left,
				'battle_end_seconds_left' => $battle_end_seconds_left,
				'panel_battle' => $panel_battle,
				'user_damage_received' => $user_damage_received
			];
		}
		
		// статистика
		// type: damage, killed
		public function statistic($type)
		{
			$pag = new pagination;
			$limit = $pag->start(ml1_statistic::user_count());
			$sql = "select id_user, $type as value, (select u.login from users u where u.id = id_user limit 1) as username from ml1_statistic order by $type desc limit $limit[start], $limit[limit]";
			$sth = db::$pdo->query($sql);
			$sttstc = $sth->fetchAll(PDO::FETCH_ASSOC);
			return [
				'pag' => $pag,
				'sttstc' => $sttstc,
				'type' => $type
			];
		}
	}
}