<?php

namespace ml1;

class pending
{
	const PLAYER_LIFE_TIME = 15; // время жизни игрока в секундах
	private $user_id;
	private $timestamp;
	
	public function __construct()
	{
		$this->user_id = ID;
		$this->timestamp = time();
	}
	
	public function start()
	{
		if ($this->player_isset()) {
			$this->player_time_update();
		} else {
			$this->player_record_create();
		}
		
		$this->ctrl_cleaning();
	}
	
	// контроллер очистки
	private function ctrl_cleaning()
	{
		$time_min = $this->timestamp - self::PLAYER_LIFE_TIME;
		$sql = "delete from ml1_pending where timestamp < $time_min";
		return \db::$pdo->exec($sql);
	}
	
	// проверить существует ли игрок
	private function player_isset()
	{
		$sql = 'select count(*) from ml1_pending where id_user = ? limit 1';
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([$this->user_id]);
		if ($sth->fetchColumn()) return true;
		return false;
	}
	
	// обновить время игроку
	private function player_time_update()
	{
		$sql = 'update ml1_pending set timestamp = ? where id_user = ? limit 1';
		$sth = \db::$pdo->prepare($sql);
		return $sth->execute([$this->timestamp, $this->user_id]);
	}
	
	// создать запись с игроком
	private function player_record_create()
	{
		$sql = 'insert into ml1_pending set id_user = ?, timestamp = ?';
		$sth = \db::$pdo->prepare($sql);
		return $sth->execute([$this->user_id, $this->timestamp]);
	}
}