<?php

namespace ml2;

class command_chat
{
	public $command_id;
	private $table = 'ml2_commands_chat';
	
	public function __construct($command_id)
	{
		$this->command_id = $command_id;
	}
	
	/* добавить сообщение */
	public function add_message($user_id, $message)
	{
		$command_id = $this->command_id;
		$sql = 'insert into %s set id_command = ?, id_user = ?, text = ?, timestamp = ?';
		$sql = sprintf($sql, $this->table);
		$sth = \db::$pdo->prepare($sql);
		return $sth->execute([$command_id, $user_id, $message, time()]);
	}
	
	/* получить все сообщения */
	public function get_messages()
	{
		$sql = 'select * from %s where id_command = ? order by id desc limit 6';
		$sql = sprintf($sql, $this->table);
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([$this->command_id]);
		$chat = $sth->fetchAll(\PDO::FETCH_OBJ);
		foreach ($chat as $key => $message) {
			$chat[$key]->user_name = \user::login_get($message->id_user);
			$chat[$key]->user_gender = \user::gender_get($message->id_user);
		}
		return $chat;
	}
	
	/* удалить чат */
	public function delete_chat()
	{
		$sql = 'delete from %s where id_command = ?';
		$sql = sprintf($sql, $this->table);
		$sth = \db::$pdo->prepare($sql);
		return $sth->execute([$this->command_id]);
	}
}