<?php

namespace ml2;

class battle
{
	const PART_TYPE_USER = 1;
	const PART_TYPE_BOT = 2;
	const BOT_HIT_INTERVAL = 4; //   n 
	
	public $battle_id;
	public $users_id;
	
	//  
	public function create()
	{
		$sql = 'insert into ml2_part set id_battle = ?, part_type = ?, id_part = ?, health = ?, damage = ?';
		$sth = \db::$pdo->prepare($sql);
		foreach ($this->users_id as $user_id) {
			$health = \uc::get_user_combat_health($user_id);
			$damage = \uc::get_user_combat_damage($user_id);
			$sth->execute([$this->battle_id, self::PART_TYPE_USER, $user_id, $health, $damage]);
		}
	}
	
	// 
	public function wave($user_id)
	{
		$command_id = \db\ml2_commands::command_id_get($user_id);
		$location_id = \db\ml2_commands::location_id_get($command_id);
		$battle_id = \db\ml2_commands::battle_id_get($command_id);
		$wave = \db\ml2_commands::wave_get($command_id);
		$wave_max = \db\_sewerage::wave_max_get($location_id);
		if ($wave >= $wave_max) {
			return false;
		}
		$battle_id = \db\ml2_commands::battle_id_get($command_id);
		if (\db\ml2_part::is_enemies($battle_id)) {
			return false;
		}
		
		$wave++;
		\db\ml2_commands::wave_set($wave, $command_id);
		
		$enemies = \db\_sewerage::wave_enemies_get($location_id, $wave);
		$sql = "insert into ml2_part set id_battle = $battle_id, part_type = " . self::PART_TYPE_BOT . ", id_part = ?, health = ?, damage = ?, hit_timestamp = ?";
		$sth = \db::$pdo->prepare($sql);
		$time = time();
		foreach ($enemies as $enemy_id => $num) {
			$enemy_health = \db\_sewerage_enemies::health_get($enemy_id);
			$enemy_damage = \db\_sewerage_enemies::damage_get($enemy_id);
			for ($i = 0; $i < $num; $i++) {
				$sth->execute([$enemy_id, $enemy_health, $enemy_damage, $time]);
			}
		}
	}
	
	//  
	public function target($user_id)
	{
		$user_battle_id = \db\ml2_part::user_battle_id_by_real_user_id_get($user_id);
		if (\db\ml2_part::is_target($user_battle_id)) {
			$target_id = \db\ml2_part::target_get($user_battle_id);
			if ( ! \db\ml2_part::part_is_dead($target_id)) {
				return;
			}
		}
		$user_target = new user_target;
		$user_target->user_battle_id = $user_battle_id;
		$user_target->tap();
	}
	
	//  
	public function enemies($battle_id)
	{
		$id = \db\ml2_part::enemies_live_get($battle_id);
		$users_live_num = \db\ml2_part::users_live_count($battle_id);
		if ($users_live_num < 1) {
			return;
		}
		foreach ($id as $key => $val) {
			$val = $val[0];
			if (is_null(\db\ml2_part::target_get_by_id($val))
			or \db\ml2_part::part_is_dead(\db\ml2_part::target_get_by_id($val))) {
				$enemy_target = new enemy_target;
				$enemy_target->id = $val;
				$enemy_target->find();
			}
			
			if ( ! \db\ml2_part::is_target($val)) {
				continue;
			}
			$hit_rec_sec_left = (\db\ml2_part::hit_timestamp_get($val) + \db\ml2_part::hit_delay_seconds_get($val)) - time();
			if ($hit_rec_sec_left > 0) {
				continue;
			}
			$target = \db\ml2_part::target_get_by_id($val);
			$target_health = \db\ml2_part::health_get($target);
			if ($target_health < 1) {
				continue;
			}
			$damage = \db\ml2_part::damage_get($val);
			$damage_min = floor($damage / 1.2);
			$damage_max = ceil($damage * 1.2);
			$damage = mt_rand($damage_min, $damage_max);
			
			$target_health_new = $target_health - $damage;
			
			$enemy_real_id = \db\ml2_part::part_real_id_get($val);
			$enemy_name = \db\_sewerage_enemies::name_get($enemy_real_id);
			$target_real_id = \db\ml2_part::part_real_id_get($target);
			if ($target_health_new <= 0) {
				$target_health_new = 0;
				log_battle_set([4], [4 => [$enemy_name]], $target_real_id);
			}
			else {
				log_battle_set([2], [2 => [$enemy_name, $damage]], $target_real_id);
			}
			\db\ml2_part::health_set($target_health_new, $target);
			\db\ml2_part::hit_timestamp_set($val);
			$hit_delay_seconds = mt_rand(2, 6);
			\db\ml2_part::hit_delay_seconds_set($val, $hit_delay_seconds);
			
			\db\ml2_part::damage_received_increase($target, $damage);
		}
	}
	
	//  
	public static function hit($user_id)
	{
		$user_battle_id = \db\ml2_part::user_battle_id_by_real_user_id_get($user_id);
		if (\db\ml2_part::part_is_dead($user_battle_id)) {
			return;
		}
		if ( ! \db\ml2_part::is_target($user_battle_id)) {
			return;
		}
		if ( ! \battle\action::av_hit($user_id)) {
			log_battle_set([8], null, $user_id);
			return;
		}
		\battle\action::hit_act($user_id);
		
		$command_id = \db\ml2_commands::command_id_get($user_id);
		
		$user_damage = \db\ml2_part::damage_get($user_battle_id);
		$user_damage = (new \damage)->generate($user_damage);
		
		$target_id = \db\ml2_part::target_get_by_id($user_battle_id);
		$target_real_id = \db\ml2_part::part_real_id_get($target_id);
		$target_health = \db\ml2_part::health_get($target_id);
		
		$target_health_new = $target_health - $user_damage;
		\db\ml2_part::health_set($target_health_new, $target_id);
		\db\ml2_statistic::damage_increase($user_id, $command_id, $user_damage);
		if ($target_health_new < 1) {
			\db\ml2_part::part_delete($target_id);
			$target_name = \db\_sewerage_enemies::name_get($target_real_id);
			log_battle_set([3], [3 => [$target_name]], $user_id);
		}
		else {
			log_battle_set([1], [1 => [$user_damage]], $user_id);
			\db\ml2_part::damage_applied_increase($user_battle_id, $user_damage);
		}
	}
	
	public static function dodge($user_id)
	{
		$user_battle_id = \db\ml2_part::user_battle_id_by_real_user_id_get($user_id);
		if (\db\ml2_part::part_is_dead($user_battle_id)) {
			return;
		}
		if ( ! \battle\action::av_dodge($user_id)) {
			return;
		}
		$enemy_target = new enemy_target;
		$enemies = $enemy_target->enemies_target_beat_get($user_battle_id);
		foreach ($enemies as $key => $enemy_battle_id) {
			$enemy_target->id = $enemy_battle_id[0];
			$enemy_target->deleted_id = [$user_battle_id];
			$enemy_target->find();
		}
		\battle\action::dodge_act($user_id);
	}
	
	public static function change($user_id)
	{
		$user_battle_id = \db\ml2_part::user_battle_id_by_real_user_id_get($user_id);
		if (\db\ml2_part::part_is_dead($user_battle_id)) {
			return;
		}
		if ( ! \battle\action::av_change($user_id)) {
			return;
		}
		$target_current = \db\ml2_part::target_get($user_battle_id);
		if ( ! is_null($target_current)) {
			$user_target = new user_target;
			$user_target->user_battle_id = $user_battle_id;
			$user_target->deleted_id = [$target_current];
			$user_target->tap();
			\battle\action::change_act($user_id);
		}
	}
}

class enemy_target
{
	public $id; // id 
	public $deleted_id = []; // id   
	
	public function find()
	{
		$battle_id = \db\ml2_part::battle_id_get($this->id);
		$users_live_num = \db\ml2_part::users_live_count($battle_id);
		if ($users_live_num < 1) {
			return;
		}
		$users_live = \db\ml2_part::users_live_get($battle_id);
		$users_deleted = [];
		if ($this->deleted_id) {
			foreach ($users_live as $key => $val) {
				$val = $val[0];
				if (in_array($val, $this->deleted_id)) {
					$users_deleted[] = [$val];
					unset($users_live[$key]);
				}
			}
		}
		if ( ! $users_live) {
			if ($users_deleted) {
				$users_live = $users_deleted;
			}
			else {
				return;
			}
		}
		$target_new = $users_live[array_rand($users_live)][0];
		\db\ml2_part::target_set_by_id($target_new, $this->id);
	}
	
	/*  id      
		$id - id 
	*/
	public function enemies_target_beat_get($id)
	{
		$sql = 'select id from ml2_part where part_type = ? and target = ?';
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([battle::PART_TYPE_BOT, $id]);
		return $sth->fetchAll(\PDO::FETCH_NUM);
	}
}

class user_target
{
	public $user_battle_id; // id   !
	public $deleted_id = []; // id   
	private $battle_id, $enemies_live_num;
	
	private function organize()
	{
		$this->battle_id = \db\ml2_part::battle_id_get($this->user_battle_id);
		$this->enemies_live_num = \db\ml2_part::enemies_live_count($this->battle_id);
	}
	
	public function tap()
	{
		$this->organize();
		if ($this->enemies_live_num < 1) return;
		if ($this->deleted_id) $target = $this->choose_no_in_list();
		else $target = $this->choose();
		\db\ml2_part::target_set($target, $this->user_battle_id);
	}
	
	/*     ( id) */
	private function choose()
	{
		$start = mt_rand(0, $this->enemies_live_num - 1);
		$sql = "select id from ml2_part where id_battle = ? and part_type = ? and health > 0 limit $start, 1";
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([$this->battle_id, \ml2\battle::PART_TYPE_BOT]);
		$target = $sth->fetch(\PDO::FETCH_NUM);
		if ($target) return $target[0];
		else return null;
	}
	
	/*   ,      ($this->deleted_id) ( id) */
	private function choose_no_in_list()
	{
		$start = mt_rand(0, $this->enemies_live_num - 1);
		$in = implode(',', $this->deleted_id);
		$sql = "select id from ml2_part where id not in($in) and id_battle = ? and part_type = ? and health > 0 limit $start, 1";
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([$this->battle_id, \ml2\battle::PART_TYPE_BOT]);
		$target = $sth->fetch(\PDO::FETCH_NUM);
		if ($target) return $target[0];
		else return null;
	}
}