<?php

namespace db;

class ml2_commands extends \_tbl_line
{
	protected static $table = 'ml2_commands';
	
	public static function in_command($user_id)
	{
		if (self::get('count(*)', 'where id_leader = ? or id_user_1 = ? or id_user_2 = ? or id_user_3 = ?', [$user_id, $user_id, $user_id, $user_id]) > 0) {
			return true;
		} return false;
	}
	
	/*            */
	public static function in_one_command($array_users_id)
	{
		$command_ids = [];
		foreach ($array_users_id as $user_id) {
			$command_id = self::command_id_get($user_id);
			$command_ids[] = $command_id;
		}
		if ( ! $command_ids) {
			return false;
		}
		$command_id_any = $command_ids[0];
		$in_command = true;
		$result = true;
		foreach ($command_ids as $id) {
			if (is_null($id)) {
				$in_command = false;
			} else $in_command = true;
			
			if ($id != $command_id_any) {
				$result = false;
			}
		}
		if ( ! $in_command) return false;
		if ( ! $result) return false;
		return true;
	}
	
	/*     */
	public static function at_command($command_id, $user_id, $place)
	{
		self::set("id_user_$place = ?", 'where id = ?', [$user_id, $command_id]);
	}
	
	public static function is_command($id)
	{
		if (self::get('count(*)', 'where id = ?', [$id]) > 0) {
			return true;
		} return false;
	}
	
	public static function delete($id)
	{
		$sth = \db::$pdo->prepare('delete from ' . self::$table . ' where id = ? limit 1');
		$sth->execute([$id]);
	}
	
	public static function is_leader($user_id)
	{
		if (self::get('count(*)', 'where id_leader = ?', [$user_id]) > 0) {
			return true;
		} return false;
	}
	
	public static function command_id_get($user_id)
	{
		return self::get('id', 'where id_leader = ? or id_user_1 = ? or id_user_2 = ? or id_user_3 = ?', [$user_id, $user_id, $user_id, $user_id]);
	}
	
	public static function location_id_get($command_id)
	{
		return self::get('id_location', 'where id = ?', [$command_id]);
	}
	
	/*     */
	public static function seats_num_get($command_id)
	{
		$row = self::get('id_leader, id_user_1, id_user_2, id_user_3 : assoc', 'where id = ?', [$command_id]);
		$seats = 0;
		if ( ! is_null($row['id_leader'])) $seats++;
		if ( ! is_null($row['id_user_1'])) $seats++;
		if ( ! is_null($row['id_user_2'])) $seats++;
		if ( ! is_null($row['id_user_3'])) $seats++;
		return $seats;
	}
	
	/*      */
	public static function is_seat($command_id)
	{
		if (self::seats_num_get($command_id) < \ml2\command::PART_MAX) {
			return true;
		} return false;
	}
	
	public static function status_get($command_id)
	{
		return self::get('status', 'where id = ?', [$command_id]);
	}
	
	public static function status_set($status, $command_id)
	{
		self::set('status = ?', 'where id = ?', [$status, $command_id]);
	}
	
	/*  true,      */
	public static function command_in_battle($command_id)
	{
		if (self::status_get($command_id) == \ml2\command::STATUS_BATTLE) {
			return true;
		} return false;
	}
	
	public static function wave_get($command_id)
	{
		return self::get('wave', 'where id = ?', [$command_id]);
	}
	
	public static function wave_set($wave, $command_id)
	{
		self::set('wave = ?', 'where id = ?', [$wave, $command_id]);
	}
	
	public static function battle_id_get($command_id)
	{
		return $command_id;
	}
	
	public static function parts_id_get($command_id)
	{
		$part = self::get('id_leader, id_user_1, id_user_2, id_user_3 : num', 'where id = ?', [$command_id]);
		foreach ($part as $key => $val) {
			if (is_null($val)) {
				unset($part[$key]);
			}
		}
		return $part;
	}
	
	/*    ( )   */
	public static function part_place_get($user_id)
	{
		$command_id = self::command_id_get($user_id);
		$places = self::get('id_leader, id_user_1, id_user_2, id_user_3 : assoc', 'where id = ?', [$command_id]);
		if ($places['id_leader'] == $user_id) {
			return 0;
		}
		if ($places['id_user_1'] == $user_id) {
			return 1;
		}
		if ($places['id_user_2'] == $user_id) {
			return 2;
		}
		if ($places['id_user_3'] == $user_id) {
			return 3;
		}
	}
	
	//   
	public static function leader_exchange($command_id, $leader_new_id)
	{
		self::set('id_leader = ?', 'where id = ?', [$leader_new_id, $command_id]);
	}
	
	//    
	public static function part_expel($user_id)
	{
		$place = self::part_place_get($user_id);
		$column = "id_user_$place";
		$column = ($place == 0) ? 'id_leader' : $column;
		$command_id = self::command_id_get($user_id);
		self::set("$column = null", 'where id = ?', [$command_id]);
	}
	
	public static function access_get($command_id)
	{
		return self::get('access', 'where id = ?', [$command_id]);
	}
	
	public static function access_set($command_id, $access)
	{
		return self::set('access = ?', 'where id = ?', [$access, $command_id]);
	}
}