<?php

namespace ml2;

class invite
{
	/* задержка между приглашениями */
	const INVITE_DELAY_SECONDS = 15;
	
	/* время жизни приглашения */
	const INVITE_LIFE_SECONDS = 300;
}

/* отправка приглашения */
class invite_send
{
	public $who_user_id; // кто отправляет
	public $whom_user_id; // кому отправляет
	private $command_id;
	
	
	public function execute()
	{
		if ( ! $this->av_invite_send()) {
			return;
		}
		if (\db\ml2_invite::is_invite($this->whom_user_id)) { // если у игрока уже имеется приглашение
			\notf::set_notf('У этого игрока уже есть приглашение в какую-то команду.', 'error');
			return;
		}
		if ( ! \db\ml2_commands::is_seat($this->command_id)) { // если в команде нет мест
			\notf::set_notf('В команде больше нет мест.', 'error');
			return;
		}
		$location_id = \db\ml2_commands::location_id_get($this->command_id);
		if ( ! \db\ml2_locations::is_open($this->whom_user_id, $location_id)) {
			\notf::set_notf('У данного игрока эта локация закрыта.', 'error');
			return;
		}
		
		\db\ml2_invite::invite_send($this->whom_user_id, $this->command_id);
		\notf::set_notf('Приглашение отправлено.', 'default');
	}
	
	/* может ли один игрок отправить приглашение другому */
	public function av_invite_send()
	{
		if ( ! \db\ml2_commands::is_leader($this->who_user_id)) {
			return false;
		}
		if ($this->who_user_id == $this->whom_user_id) {
			return false;
		}
		$this->command_id = \db\ml2_commands::command_id_get($this->who_user_id);
		if (\db\ml2_commands::status_get($this->command_id) != command::STATUS_EXPECT) {
			return false;
		}
		if (\db\ml2_commands::in_command($this->whom_user_id)) {
			return false;
		}
		if (\db\ml2_invite::is_delay($this->whom_user_id)) { // сейчас действует задержка
			return false;
		}
		/* make: если у игрока есть приглашение в эту команду, то вернуть false */
		return true;
	}
}

/* принятие приглашения */
class invite_accept
{
	public $user_id;
	
	public function execute()
	{
		if (\db\ml2_commands::in_command($this->user_id)) {
			return;
		}
		if ( ! \db\ml2_invite::is_invite($this->user_id)) {
			return;
		}
		$command_id = \db\ml2_invite::command_id_get($this->user_id);
		if ( ! \db\ml2_commands::is_seat($command_id)) {
			return;
		}
		if (\db\ml2_commands::status_get($command_id) != command::STATUS_EXPECT) {
			return;
		}
		
		$cua = new command_user_add;
		$cua->user_id = $this->user_id;
		$cua->command_id = $command_id;
		$cua->execute();
		\db\ml2_invite::invite_user_delete($this->user_id);
		return true;
	}
}

/* отклонение приглашения */
class invite_reject
{
	public $user_id;
	
	public function execute()
	{
		if ( ! \db\ml2_invite::is_invite($this->user_id)) {
			return;
		}
		\db\ml2_invite::invite_user_delete($this->user_id);
	}
}

/* просрочка приглашения */
class invite_life_time_ending
{
	public $user_id;
	
	public function execute()
	{
		if ( ! \db\ml2_invite::is_invite($this->user_id)) {
			return;
		}
		if ( ! \db\ml2_invite::is_life_time_ending($this->user_id)) {
			return;
		}
		\db\ml2_invite::invite_user_delete($this->user_id);
	}
}