<?php

namespace db;

class ml2_invite extends \_tbl_line
{
	protected static $table = 'ml2_invite';
	
	public static function is_invite($user_id)
	{
		if (self::get('count(*)', 'where id_user = ?', [$user_id]) > 0) {
			return true;
		} return false;
	}
	
	public static function command_id_get($user_id)
	{
		return self::get('id_command', 'where id_user = ?', [$user_id]);
	}
	
	public static function record_timestamp_get($user_id)
	{
		return self::get('record_timestamp', 'where id_user = ?', [$user_id]);
	}
	
	public static function seconds_gone_get($user_id)
	{
		return time() - self::record_timestamp_get($user_id);
	}
	
	public static function is_delay($user_id)
	{
		$delay = (self::record_timestamp_get($user_id) + \ml2\invite::INVITE_DELAY_SECONDS) - time();
		if ($delay > 0) {
			return true;
		} return false;
	}
	
	public static function is_life_time_ending($user_id)
	{
		if (self::seconds_gone_get($user_id) >= \ml2\invite::INVITE_LIFE_SECONDS) {
			return true;
		} return false;
	}
	
	public static function invite_send($user_id, $command_id)
	{
		$time = time();
		if (self::is_invite($user_id)) {
			self::set('id_command = ?,  record_timestamp = ?', 'where id_user = ?', [$command_id, $time, $user_id]);
		}
		else {
			self::add('id_user = ?, id_command = ?, record_timestamp = ?', [$user_id, $command_id, $time]);
		}
	}
	
	public static function invite_user_delete($user_id)
	{
		$sql = 'delete from ' . self::$table . ' where id_user = ? limit 1';
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([$user_id]);
	}
	
	/*     -  */
	public static function invite_to_command_delete($command_id)
	{
		$sql = 'delete from ' . self::$table . ' where id_command = ? limit 1';
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([$command_id]);
	}
}