<?php

namespace db;

class ml2_locations extends \_tbl_line
{
	protected static $table = 'ml2_locations';
	
	public static function is_location($user_id, $location_id)
	{
		if (self::get('count(*)', 'where id_user = ? and id_location = ?', [$user_id, $location_id]) > 0) {
			return true;
		} return false;
	}
	
	public static function completion_timestamp_get($user_id, $location_id)
	{
		return self::get('completion_timestamp', 'where id_user = ? and id_location = ?', [$user_id, $location_id]);
	}
	
	public static function completion_timestamp_set($user_id, $location_id, $time = false)
	{
		$time = ($time === false) ? time() : $time;
		return self::set('completion_timestamp = ?', 'where id_user = ? and id_location = ?', [$time, $user_id, $location_id]);
	}
	
	public static function recovery_seconds_left_get($user_id, $location_id)
	{
		return (self::completion_timestamp_get($user_id, $location_id) + _sewerage::recovery_seconds_get($location_id)) - time();
	}
	
	public static function recovery_is_gone($user_id, $location_id)
	{
		if ( ! self::is_location($user_id, $location_id)) {
			return true;
		}
		if (self::recovery_seconds_left_get($user_id, $location_id) < 1) {
			return true;
		} return false;
	}
	
	public static function is_open($user_id, $location_id)
	{
		if (\user::level_get($user_id) < _sewerage::level_need_get($location_id)) {
			return false;
		}
		if (self::recovery_is_gone($user_id, $location_id)) {
			return true;
		} return false;
	}
	
	//     (   )
	public static function sewerage_open_count($user_id)
	{
		$open_num = 0;
		$sewerage_all = _sewerage::sewerage_all_get();
		foreach ($sewerage_all as $sewerage) {
			if (self::is_open($user_id, $sewerage['id'])) {
				$open_num++;
			}
		}
		return $open_num;
	}
	
	//    
	public static function sewerage_open_is($user_id)
	{
		if (self::sewerage_open_count($user_id) > 0) {
			return true;
		} return false;
	}
	
}