<?php

namespace db;

class ml2_part extends \_tbl_line
{
	protected static $table = 'ml2_part';
	
	public static function enemies_num_get($battle_id)
	{
		return self::get('count(*)', 'where id_battle = ? and part_type = ?', [$battle_id, \ml2\battle::PART_TYPE_BOT]);
	}
	
	public static function is_enemies($battle_id)
	{
		if (self::enemies_num_get($battle_id) > 0) {
			return true;
		} return false;
	}
	
	public static function is_live($battle_id)
	{
		if (self::get('count(*)', 'where id_battle = ? and part_type = ? and health > 0', [$battle_id, \ml2\battle::PART_TYPE_USER]) > 0) {
			return true;
		} return false;
	}
	
	public static function users_live_get($battle_id)
	{
		return self::all_get('id', ['where id_battle = ? and part_type = ?', ''], [$battle_id, \ml2\battle::PART_TYPE_USER]);
	}
	
	public static function enemies_live_get($battle_id)
	{
		return self::all_get('id', ['where id_battle = ? and part_type = ?', ''], [$battle_id, \ml2\battle::PART_TYPE_BOT]);
	}
	
	public static function target_get($id)
	{
		return self::get('target', 'where id = ?', [$id]);
	}
	
	public static function target_set($target, $id)
	{
		return self::set('target = ?', 'where id = ?', [$target, $id]);
	}
	
	public static function is_target($id)
	{
		if ( ! is_null(self::target_get($id))) {
			return true;
		} return false;
	}
	
	public static function part_is_dead($id)
	{
		if (self::get('health', 'where id = ?', [$id]) < 1) {
			return true;
		} return false;
	}
	
	public static function users_live_count($battle_id)
	{
		return self::get('count(*)', 'where id_battle = ? and part_type = ? and health > 0', [$battle_id, \ml2\battle::PART_TYPE_USER]);
	}
	
	public static function enemies_live_count($battle_id)
	{
		return self::get('count(*)', 'where id_battle = ? and part_type = ? and health > 0', [$battle_id, \ml2\battle::PART_TYPE_BOT]);
	}
	
	public static function part_id_get($id)
	{
		return self::get('id_part', 'where id = ?', [$id]);
	}
	
	public static function health_get($id)
	{
		return self::get('health', 'where id = ?', [$id]);
	}
	
	public static function health_set($health, $id)
	{
		return self::set('health = ?', 'where id = ?', [$health, $id]);
	}
	
	public static function damage_get($id)
	{
		return self::get('damage', 'where id = ?', [$id]);
	}
	
	public static function hit_timestamp_get($id)
	{
		return self::get('hit_timestamp', 'where id = ?', [$id]);
	}
	
	public static function hit_timestamp_set($id)
	{
		return self::set('hit_timestamp = ?', 'where id = ?', [time(), $id]);
	}
	
	public static function target_get_by_id($id)
	{
		return self::get('target', 'where id = ?', [$id]);
	}
	
	public static function target_set_by_id($target, $id)
	{
		return self::set('target = ?', 'where id = ?', [$target, $id]);
	}
	
	public static function user_battle_id_by_real_user_id_get($user_id)
	{
		return self::get('id', 'where part_type = ? and id_part = ?', [\ml2\battle::PART_TYPE_USER, $user_id]);
	}
	
	public static function part_delete($id)
	{
		$sql = 'delete from ' . self::$table . ' where id = ? limit 1';
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([$id]);
	}
	
	public static function part_real_id_get($id)
	{
		return self::get('id_part', 'where id = ?', [$id]);
	}
	
	//    
	public static function battle_delete($id)
	{
		$sql = 'delete from ' . self::$table . ' where id_battle = ?';
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([$id]);
	}
	
	//   
	public static function user_delete($user_id)
	{
		$sql = 'delete from ' . self::$table . ' where part_type = ? and id_part = ? limit 1';
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([\ml2\battle::PART_TYPE_USER, $user_id]);
	}
	
	/* //    
	public static function target_reset_from_user($user_id)
	{
		$user_battle_id = self::user_battle_id_by_real_user_id_get($user_id);
		return self::set('target = null', 'where part_type = ? and target = ?', [\ml2\battle::PART_TYPE_BOT, $user_battle_id]);
	} */
	
	//     . 
	public static function hit_delay_seconds_get($id)
	{
		return self::get('hit_delay_seconds', 'where id = ?', [$id]);
	}
	
	public static function hit_delay_seconds_set($id, $seconds)
	{
		return self::set('hit_delay_seconds = ?', 'where id = ?', [$seconds, $id]);
	}
	
	public static function battle_id_get($id)
	{
		return self::get('id_battle', 'where id = ?', [$id]);
	}
	
	//  , 
	public static function damage_received_get($id)
	{
		return self::get('damage_received', 'where id = ?', [$id]);
	}
	
	//  , 
	public static function damage_received_increase($id, $damage)
	{
		return self::set('damage_received = damage_received + ?', 'where id = ?', [$damage, $id]);
	}
	
	//   
	public static function damage_received_reset($id)
	{
		return self::set('damage_received = 0', 'where id = ?', [$id]);
	}
	
	//  , 
	public static function damage_applied_get($id)
	{
		return self::get('damage_applied', 'where id = ?', [$id]);
	}
	
	//  , 
	public static function damage_applied_increase($id, $damage)
	{
		return self::set('damage_applied = damage_applied + ?', 'where id = ?', [$damage, $id]);
	}
	
	//   
	public static function damage_applied_reset($id)
	{
		return self::set('damage_applied = 0', 'where id = ?', [$id]);
	}
}