<?php

namespace db;

class ml2_statistic extends \_tbl_line
{
	protected static $table = 'ml2_statistic';

	public static function id_get($user_id, $battle_id)
	{
		return self::get('id', 'where id_user = ? and id_battle = ?', [$user_id, $battle_id]);
	}
	
	public static function damage_get($user_id, $battle_id)
	{
		return self::get('damage', 'where id_user = ? and id_battle = ?', [$user_id, $battle_id]);
	}
	
	public static function damage_increase($user_id, $battle_id, $damage)
	{
		return self::set('damage = damage + ?', 'where id_user = ? and id_battle = ?', [$damage, $user_id, $battle_id]);
	}
	
	/* получить общий урон одной битвы */
	public static function damage_overall_get($battle_id)
	{
		return self::get('sum(damage)', 'where id_battle = ?', [$battle_id]);
	}
	
	/* получить процент игрока по урону в битве */
	public static function user_damage_percent_get($user_id, $battle_id)
	{
		return compercent(self::damage_get($user_id, $battle_id), self::damage_overall_get($battle_id));
	}
	
	public static function delete($user_id, $battle_id)
	{
		$sql = 'delete from ml2_statistic where id_user = ? and id_battle = ? limit 1';
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([$user_id, $battle_id]);
	}
	
	public static function battle_delete($battle_id)
	{
		$sql = 'delete from ml2_statistic where id_battle = ?';
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([$battle_id]);
	}
}