<?php

class profile_model
{
	public function profile($args)
	{
		$id_user = $args['id_user'];
		$ban_shoot = $args['ban_shoot'];
		$user_position = user::position_get(ID);
		$user_invite_user = clan::is_user_invite_user(ID, $id_user);
		$user_expel_user = clan::is_user_expel_user(ID, $id_user);
		$user_increase_user = clan::is_user_increase_user(ID, $id_user);
		$user_lower_user = clan::is_user_lower_user(ID, $id_user);
		
		$username = get_username_by_id($id_user);
		$id_clan = clan::get_id_clan_by_id_user($id_user);
		$clan_name = ''; $clan_rank = ''; $in_clan_seconds = null;
		if ($id_clan) {
			$clan_name = clan::get_clan_name_by_id_clan($id_clan);
			$clan_rank = clan::rank_rus(clan::get_user_clan_rank($id_user));
			$in_clan_seconds = clan::get_clan_part_join_seconds_gone($id_user);
		}
		
		$in_game_seconds = user::reg_seconds_gone_get($id_user);
		
		$user_param = uc::get_param_all($id_user);
		$user_param_sum = array_sum($user_param);
		$user_health = uc::get_user_combat_health($id_user);
		$user_damage = uc::get_user_combat_damage($id_user);
		
		$user_currency = [
			'bucks' => user_currency::get_bucks($id_user),
			'mutagen' => user_currency::get_mutagen($id_user),
			'pancers' => user_currency::get_pancers($id_user),
			'metal' => user_currency::get_metal($id_user),
			'exp' => user_exp::exp_get($id_user)
		];
		
		$level_max = indrat\level::max();
		$user_level = indrat\user_level::get($id_user);
		$user_level_expr_need = indrat\level::exp_need_get($user_level);
		$user_expr = $user_currency['exp'] - $user_level_expr_need;
		if ($user_level == $level_max) {
			$statistic = new user_statistic($id_user);
			$statistic = $statistic->get_statistic();
			$user_expr = $statistic->expr;
		}
		$user_currency['exp'] = $user_expr;
		
		if ($user_level < $level_max) {
			$user_exp_next = indrat\level::exp_need_get($user_level + 1) - indrat\level::exp_need_get($user_level);
		} else {
			$user_exp_next = 0;
		}
		
		$user_turtle = user::turtle_get($id_user);
		$user_turtle_icon = html::turtle_icon_get($id_user);
		$user_turtle_name = translate::turtle_name($user_turtle);
		
		$position = user::position_get($id_user);
		$position_name = translate::user_position_name($position);
		
		$ban = null;
		if (db\users_ban::ban_isset($id_user)) {
			$ban = ban_model::ban($id_user);
		}
		$ban_isset = db\users_ban::ban_isset($id_user);
		$gender_type = user::gender_get($id_user);
		if ($gender_type == 0) $gender = 'Не указано';
		elseif ($gender_type == 1) $gender = 'Мужской';
		elseif ($gender_type == 2) $gender = 'Женский';
		
		$invite_send = new \ml2\invite_send;
		$invite_send->who_user_id = ID;
		$invite_send->whom_user_id = $id_user;
		$av_command_invite_send = $invite_send->av_invite_send();
		
		$is_online = user_online::is_online($id_user);
		$obj_user_prem = new \db\users_premium;
		$obj_user_prem->user_id = $id_user;
		$is_premium = $obj_user_prem->is_premium();
		$premium_seconds_end = $obj_user_prem->get_seconds_end();
		
		$user_time_last = \user_online::time_get($id_user); // метка - последнее посещение (обновление)
		$dlast = getdate($user_time_last);
		$dyesteday = getdate(strtotime('-1 day'));
		$dcurrent = getdate();
		
		if ($dcurrent['year'] == $dlast['year'] && $dcurrent['mday'] == $dlast['mday']) {
			$enter_last = 'Сегодня';
		}
		elseif ($dyesteday['year'] == $dlast['year'] && $dyesteday['mday'] == $dlast['mday']) {
			$enter_last = 'Вчера';
		} else {
			$enter_last = date('d.m.Y', $user_time_last);
		}
		
		
		return [
			'user_id' => $id_user,
			'username' => $username,
			'clan_id' => $id_clan,
			'clan_name' => $clan_name,
			'clan_rank' => $clan_rank,
			'in_clan_seconds' => $in_clan_seconds,
			'in_game_seconds' => $in_game_seconds,
			'user_invite_user' => $user_invite_user,
			'user_expel_user' => $user_expel_user,
			'user_increase_user' => $user_increase_user,
			'user_lower_user' => $user_lower_user,
			'clan_expel' => $args['clan_expel'],
			'user_param' => $user_param,
			'user_param_sum' => $user_param_sum,
			'user_health' => $user_health,
			'user_damage' => $user_damage,
			'user_currency' => $user_currency,
			'user_level' => $user_level,
			'user_exp_next' => $user_exp_next,
			'user_turtle' => $user_turtle,
			'user_turtle_icon' => $user_turtle_icon,
			'user_turtle_name' => $user_turtle_name,
			'user_position' => $user_position,
			'position' => $position,
			'position_name' => $position_name,
			'ban_isset' => $ban_isset,
			'ban' => $ban,
			'ban_shoot' => $ban_shoot,
			'gender_type' => $gender_type,
			'gender' => $gender,
			'av_command_invite_send' => $av_command_invite_send,
			'is_online' => $is_online,
			'is_premium' => $is_premium,
			'premium_seconds_end' => $premium_seconds_end,
			'enter_last' => $enter_last
		];
	}
}