<?php

class robbery
{
	const ROBBERY_RECOVERY_DAYS = 1; // время восстановения ограбления в сутках
	const ROBBERY_PASSING_DAYS = 1; // время прохождения ограбления в сутках
	const PLAYER_BATTLES_NUM_DEFAULT = 20; // базовое максимальное количество боёв для игрока
	const PLAYER_BATTLES_NUM_RECOVERY = 5; // сколько боёв восстанавливаются за один подход
	const PLAYER_BATTLES_RECOVERY_SECONDS = 900; // за сколько восстанавливаются бои
	const PLAYER_REWARD_EXP_BASE = 80; // базовое количество опыта за один бой (удар)
	const PLAYERS_NUM_ON_ONE_PAGE = 10; // число игроков в рейтинге на одной странице
	const PLAYERS_NUM_RATING_MINI = 6; // число игроков в мини-рейтинге
	
	// узнать стадию
	public static function get_stage()
	{
		$sql = 'select stage from robbery limit 1';
		return db::$pdo->query($sql)->fetch(PDO::FETCH_NUM)[0];
	}
	
	// достать время
	public static function get_time()
	{
		$sql = 'select time from robbery limit 1';
		return db::$pdo->query($sql)->fetch(PDO::FETCH_NUM)[0];
	}
	
	// прошло ли время восстановления локации
	public static function time_recovery_gone()
	{
		if (day_new(self::get_time(), self::ROBBERY_RECOVERY_DAYS)) {
			return true;
		}
		return false;
	}
	
	// прошло ли время прохождения локации
	public static function time_passing_gone()
	{
		if (day_new(self::get_time(), self::ROBBERY_PASSING_DAYS)) {
			return true;
		}
		return false;
	}
	
	// сколько осталось секунд до восстанавления ограбления
	public static function time_recovery_left()
	{
		return (left_seconds_midnight(self::ROBBERY_RECOVERY_DAYS));
	}
	
	// сколько осталось секунд до завершения ограбления
	public static function time_passing_left()
	{
		return (left_seconds_midnight(self::ROBBERY_PASSING_DAYS));
	}
	
	// проверить есть ли запись с игроком
	public static function is_player($id_user)
	{
		$sql = 'select count(*) from robbery_part where id_user = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user]);
		if ($sth->fetch(PDO::FETCH_NUM)[0] > 0) {
			return true;
		}
		return false;
	}
	
	// баллы за одно сражение
	public static function score_generate($id_user)
	{
		return fighting_score::generate($id_user);
	}
	
	// узнать счет игрока
	public static function get_score_by_id($id_user)
	{
		$sql = 'select score from robbery_part where id_user = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user]);
		return $sth->fetch(PDO::FETCH_NUM)[0];
	}
	
	// узнать последний счет игрока
	public static function get_score_last($id_user)
	{
		$sql = 'select score_last from robbery_part where id_user = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user]);
		return $sth->fetchColumn();
	}
	
	// записать последний счет игрока
	public static function set_score_last($id_user, $score)
	{
		$sql = 'update robbery_part set score_last = ? where id_user = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$score, $id_user]);
	}
	
	// узнать значение считчика проведенных боёв
	public static function get_battles_count($id_user)
	{
		$sql = 'select battles_count from robbery_part where id_user = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user]);
		return $sth->fetch(PDO::FETCH_NUM)[0];
	}
	
	// записать значение считчика проведенных боёв
	public static function set_battles_count($id_user, $num)
	{
		$sql = 'update robbery_part set battles_count = battles_count + ? where id_user = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$num, $id_user]);
	}
	
	// статус награды
	public static function get_reward_status($id_user)
	{
		$sql = 'select reward_status from robbery_part where id_user = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user]);
		return $sth->fetch(PDO::FETCH_NUM)[0];
	}
	
	// записать статус награды
	public static function set_reward_status($status, $id_user)
	{
		$sql = 'update robbery_part set reward_status = ? where id_user = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$status, $id_user]);
	}

	// узнать количество опыта
	public static function player_exp($id_user)
	{
		$sql = 'select reward_exp from robbery_part where id_user = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user]);
		return $sth->fetch(PDO::FETCH_NUM)[0];
	}
	
	// узнать количество баксов
	public static function player_bucks($id_user)
	{
		$sql = 'select reward_bucks from robbery_part where id_user = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user]);
		return $sth->fetch(PDO::FETCH_NUM)[0];
	}
	
	// узнать количество мутагена 
	public static function player_mutagen($id_user)
	{
		$sql = 'select reward_mutagen from robbery_part where id_user = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user]);
		return $sth->fetch(PDO::FETCH_NUM)[0];
	}
	
	// узнать количество боёв
	public static function player_battles($id_user)
	{
		$sql = 'select battles from robbery_part where id_user = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user]);
		return $sth->fetch(PDO::FETCH_NUM)[0];
	}
	
	// получить время боёв
	public static function player_battles_time($id_user)
	{
		$sql = 'select battles_time from robbery_part where id_user = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user]);
		return $sth->fetch(PDO::FETCH_NUM)[0];
	}
	
	// узнать остаток времени до восстанавления боёв
	public static function player_battles_time_left($id_user)
	{
		return (self::player_battles_time($id_user) + self::PLAYER_BATTLES_RECOVERY_SECONDS) - time();
	}
	
	// узнать прошло ли время восстанавления боёв
	public static function player_battles_time_recovery_gone($id_user)
	{
		$time = self::player_battles_time($id_user);
		if ((time() - $time) > self::PLAYER_BATTLES_RECOVERY_SECONDS) {
			return true;
		}
		return false;
	}
	
	// узнать весь счёт всех игроков вместе
	public static function get_score_all()
	{
		$sql = 'select sum(score) from robbery_part limit 1';
		return db::$pdo->query($sql)->fetch(PDO::FETCH_NUM)[0];
	}
	
	// получить первых $num игроков (занимающих передовые позиции)
	// $null_throw - true, отбросить нулевые значения
	public static function get_part_pack($limit, $start = false, $zero_throw = false)
	{
		$z = '';
		if ($start !== false) {
			$start = "$start,";
		}
		if ($zero_throw) {
			$z = 'where score != 0';
		}
		$sql = "select id_user, score from robbery_part $z order by score desc limit $start $limit";
		$sth = db::$pdo->query($sql);
		return $sth->fetchAll(PDO::FETCH_ASSOC);
	}
	
	// узнать общее количество участников
	// $zero_throw - отсеять всех со значением 0
	public static function get_players_num($zero_throw = false)
	{
		$z = '';
		if ($zero_throw) {
			$z = 'where score != 0';
		}
		$sql = "select count(*) from robbery_part $z limit 1";
		$sth = db::$pdo->query($sql);
		return $sth->fetch(PDO::FETCH_NUM)[0];
	}
	
	// сгенерировать опыт
	public static function exp_battle_one_generate()
	{
		$min = (int) self::PLAYER_REWARD_EXP_BASE / 1.1;
		$max = (int) self::PLAYER_REWARD_EXP_BASE * 1.1;
		return mt_rand($min, $max);
	}
	
	// сменить стадию
	public static function stage_update($stage)
	{
		$sql = 'update robbery set stage = ? limit 1';
		db::$pdo->prepare($sql)->execute([$stage]);
	}
	
	// сменить время
	public static function time_update($time = false)
	{
		if ($time === false) {
			$time = time();
		}
		$sql = 'update robbery set time = ? limit 1';
		db::$pdo->prepare($sql)->execute([$time]);
	}
	
	// почистить статистику
	public static function robbery_part_clean()
	{
		$sql = 'delete from robbery_part';
		db::$pdo->exec($sql);
	}
	
	// создать запись с игроком
	public static function player_create($id_user)
	{
		$bnum = self::PLAYER_BATTLES_NUM_DEFAULT;
		$sql = 'insert into robbery_part set id_user = ?, battles = ?, battles_time = ?';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$id_user, $bnum, null]);
	}
	
	// изменить значение score
	public static function score_update($id_user, $score)
	{
		$sql = 'update robbery_part set score = score + ? where id_user = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$score, $id_user]);
	}
	
	// изменить кол-во боёв
	public static function player_battles_update($id_user, $num, $rewrite = false)
	{
		$field = 'battles = battles + ?';
		if ($rewrite) {
			$field = 'battles = ?';
		}
		$sql = "update robbery_part set $field where id_user = ? limit 1";
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$num, $id_user]);
	}
	
	// изменить время для боёв
	public static function player_battles_time_update($id_user, $time = false)
	{
		if ($time === false) {
			$time = time();
		}
		$sql = 'update robbery_part set battles_time = ? where id_user = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([$time, $id_user]);
	}
	
	// контроллер стадии ограбления
	public static function stage_ctrl()
	{
		$stage = $stage_new = self::get_stage();
		if ($stage == 1) { // стадия 1 - восстанавление
			if (self::time_recovery_gone() && cl1::loc_get_stage() == 1) { // если время восстанавления прошло и если Битва Шредера закрыта
				$stage_new = 2;
				self::robbery_part_clean(); // онулить статистику
				self::time_update(); // сменить время
			}
		}
		elseif ($stage == 2) { // стадия 2 - бой
			if (self::time_passing_gone()) {
				$stage_new = 1;
				self::time_update(); // сменить время
			}
		}
		if ($stage != $stage_new) {
			self::stage_update($stage_new);
		}
	}
	
	// контроллер игрока
	public static function player_ctrl()
	{
		$id_user = ID;
		$stage = self::get_stage();
		if ($stage == 2) {
			if ( ! self::is_player($id_user)) { // если записи с игроком нет
				self::player_create($id_user);
			}
		}
	}
	
	// контроллер боя
	public static function battle_ctrl()
	{
		$id_user = ID;
		if (self::get_stage() == 2) { // если стадия 2 (ограбление идёт)
			if (0 < $battles = self::player_battles($id_user)) { // если бои есть
				$score = self::score_generate($id_user);
				self::player_battles_update($id_user, -1);
				self::set_battles_count($id_user, 1);
				self::score_update($id_user, $score);
				self::set_score_last($id_user, $score);
				
				$user_level = user::level_get($id_user);
				$expr = self::exp_battle_one_generate();
				$expr += $user_level * 10;
				$obj_expr = new expr($id_user);
				$obj_expr->base = $expr;
				$obj_expr->add();
				
				$user_statistic = new \user_statistic($id_user);
				$user_statistic->increase_statistic('robbery_score', $score);
			}
		}
	}
	
	// контроллер восстанавления боёв
	public static function battles_recovery_ctrl()
	{
		$id_user = ID;
		if ( ! self::is_player($id_user)) { // игрок должен существовать
			return;
		}
		if (self::is_player($id_user)) { // игрок должен существовать
			$enemies_num_max = self::PLAYER_BATTLES_NUM_DEFAULT;
			$enemies_recovery_num = self::PLAYER_BATTLES_NUM_RECOVERY;
			$enemies_recovery_seconds = self::PLAYER_BATTLES_RECOVERY_SECONDS;
		
			$enemies_num_timestamp = self::player_battles_time($id_user);
			$enemies_num = self::player_battles($id_user);
		
			$rec = new location_recovery;
			$rec->timestamp = $enemies_num_timestamp;
			$rec->num_current = $enemies_num;
			$rec->recovery_seconds = $enemies_recovery_seconds;
			$rec->recovery_num = $enemies_recovery_num;
			$rec->num_max = $enemies_num_max;
			$rec->tap();
			
			$timestamp = $rec->timestamp_new;
			$num = $rec->num_new;
			if ($timestamp != $enemies_num_timestamp) {
				self::player_battles_time_update($id_user, $timestamp);
			}
			if ($num != $enemies_num) {
				self::player_battles_update($id_user, $num, true);
			}
		}
	}
}

class robbery_model
{
	public function get()
	{
		$user_id = ID;
		$stage = robbery::get_stage();
		$score = robbery::get_score_by_id(ID);
		$score_last = robbery::get_score_last($user_id);
		$score_all = robbery::get_score_all();
		$player_battles_num = robbery::player_battles(ID);
		$player_battles_time_left = robbery::player_battles_time_left(ID);
		$statistic_small = robbery::get_part_pack(robbery::PLAYERS_NUM_RATING_MINI, false, true);
		array_renumber($statistic_small);
		$time_recovery_left = robbery::time_recovery_left();
		$time_passing_left = robbery::time_passing_left();
		
		$reward = new \robbery\reward;
		$reward->user_id = $user_id;
		$user_reward_etap = $reward->user_reward_etap_get();
		$is_score_enough = false;
		$rewards['next']['mutagen'] = null;
		$rewards['next']['bucks'] = null;
		$rewards['next']['score_need'] = null;
		if ( ! $reward->is_max()) {
			$is_score_enough = $reward->is_score_enough();
			$rewards['next']['mutagen'] = \robbery\reward::mutagen_get($user_reward_etap + 1);
			$rewards['next']['bucks'] = \robbery\reward::bucks_get($user_reward_etap + 1);
			$rewards['next']['score_need'] = \robbery\reward::score_get($user_reward_etap + 1);
		}
		$rewards['current']['mutagen'] = null;
		$rewards['current']['bucks'] = null;
		if ($is_score_enough) {
			$rewards['current']['mutagen'] = \robbery\reward::mutagen_get($user_reward_etap + 1);
			$rewards['current']['bucks'] = \robbery\reward::bucks_get($user_reward_etap + 1);
		}
		return [
			'stage' => $stage,
			'score' => $score,
			'score_last' => $score_last,
			'score_all' => $score_all,
			'reward' => $rewards,
			'player_battles_num' => $player_battles_num,
			'player_battles_time_left' => $player_battles_time_left,
			'statistic_small' => $statistic_small,
			'time_recovery_left' => $time_recovery_left,
			'time_passing_left' => $time_passing_left,
			'is_score_enough' => $is_score_enough
		];
	}
	
	public function ratings($type)
	{
		$pag = new pagin;
		$p = $pag->start(robbery::get_players_num(true), robbery::PLAYERS_NUM_ON_ONE_PAGE);
		if ($type == 'score') {
			$part = robbery::get_part_pack($p['limit'], $p['start'], true);
		}
		elseif ($type == 'activity') {
			$sql = 'select id_user, battles_count as score from robbery_part where battles_count > 0 order by battles_count desc limit %s, %s';
			$sql = sprintf($sql, $p['start'], $p['limit']);
			$sth = db::$pdo->query($sql);
			$part = $sth->fetchAll(PDO::FETCH_ASSOC);
		}
		array_renumber($part);
		$score_all = robbery::get_score_all();
		return [
			'type' => $type,
			'part' => $part,
			'pag' => $pag,
			'score_all' => $score_all
		];
	}
}