<?php

namespace db
{
	class users_scramble_enemies extends \_tbl_line
	{
		protected static $table = 'users_scramble_enemies';
		
		public static function enemies_count($user_id = false)
		{
			\user_id($user_id);
			return self::get('count(*)', 'where id_user = ?', [$user_id]);
		}
		
		public static function user_name_get($user_id = false)
		{
			\user_id($user_id);
			return user::login_get($user_id);
		}
		
		public static function user_health_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('user_health', 'where id_user = ?', [$user_id]);
		}
		
		public static function user_health_max_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('user_health_max', 'where id_user = ?', [$user_id]);
		}
		
		public static function user_health_set($health, $user_id = false)
		{
			\user_id($user_id);
			return self::set('user_health = ?', 'where id_user = ?', [$health, $user_id]);
		}
		
		public static function user_damage_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('user_damage', 'where id_user = ?', [$user_id]);
		}
		
		public static function user_damage_set($damage, $user_id = false)
		{
			\user_id($user_id);
			return self::set('user_damage = ?', 'where id_user = ?', [$damage, $user_id]);
		}
		
		public static function enemy_name_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('enemy_name', 'where id_user = ?', [$user_id]);
		}
		
		public static function enemy_health_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('enemy_health', 'where id_user = ?', [$user_id]);
		}
		
		public static function enemy_health_max_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('enemy_health_max', 'where id_user = ?', [$user_id]);
		}
		
		public static function enemy_health_set($health, $user_id = false)
		{
			\user_id($user_id);
			return self::set('enemy_health = ?', 'where id_user = ?', [$health, $user_id]);
		}
		
		public static function enemy_damage_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('enemy_damage', 'where id_user = ?', [$user_id]);
		}
		
		public static function enemy_damage_set($damage, $user_id = false)
		{
			\user_id($user_id);
			return self::set('enemy_damage = ?', 'where id_user = ?', [$damage, $user_id]);
		}
		
		public static function enemy_type_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('enemy_type', 'where id_user = ?', [$user_id]);
		}
		
		public static function enemy_delete($user_id = false)
		{
			\user_id($user_id);
			$sql = "delete from " . self::$table . ' where id_user = ? limit 1';
			$sth = \db::$pdo->prepare($sql);
			return $sth->execute([$user_id]);
		}
	}
	
	# - - - - - - - - - - - - - - - - - - - - - - - - - - #
	
	class users_scramble_detal extends \_tbl_line
	{
		protected static $table = 'users_scramble_detal';
		
		public static function enemies_num_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('enemies', 'where id_user = ?', [$user_id]);
		}
		
		public static function enemies_num_set($num, $user_id = false)
		{
			\user_id($user_id);
			return self::set('enemies = ?', 'where id_user = ?', [$num, $user_id]);
		}
		
		public static function enemies_num_increase($num, $user_id = false)
		{
			\user_id($user_id);
			return self::set('enemies = enemies + ?', 'where id_user = ?', [$num, $user_id]);
		}
		
		public static function enemies_num_timestamp_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('enemies_timestamp', 'where id_user = ?', [$user_id]);
		}
		
		public static function enemies_num_timestamp_set($time = false, $user_id = false)
		{
			\user_id($user_id);
			return self::set('enemies_timestamp = ?', 'where id_user = ?', [($time === false) ? time() : $time, $user_id]);
		}
		
		public static function combat_level_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('combat_level', 'where id_user = ?', [$user_id]);
		}
		
		public static function combat_level_up($user_id = false)
		{
			\user_id($user_id);
			return self::set('combat_level = combat_level + 1', 'where id_user = ?', [$user_id]);
		}
		
		public static function combat_expr_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('combat_expr', 'where id_user = ?', [$user_id]);
		}
		
		public static function combat_expr_increase($expr, $user_id = false)
		{
			\user_id($user_id);
			return self::set('combat_expr = combat_expr + ?', 'where id_user = ?', [$expr, $user_id]);
		}
		
		public static function auto_status_get($user_id)
		{
			return self::get('auto_status', 'where id_user = ?', [$user_id]);
		}
		
		public static function auto_status_set($status, $user_id)
		{
			return self::set('auto_status = auto_status + ?', 'where id_user = ?', [$status, $user_id]);
		}
	}
	
	# - - - - - - - - - - - - - - - - - - - - - - - - - - #
	
	class _levels_scramble_combat extends \_tbl_line
	{
		protected static $table = '_levels_scramble_combat';
		
		public static function name_get($level)
		{
			\user_id($user_id);
			return self::get('name', 'where id = ?', [$level]);
		}
		
		public static function expr_need_get($level)
		{
			\user_id($user_id);
			return self::get('expr_need', 'where id = ?', [$level]);
		}
		
		public static function level_min_get()
		{
			return self::get('min(id)');
		}
		
		public static function level_max_get()
		{
			return self::get('max(id)');
		}
		
		public static function pancer_chance_get($level)
		{
			return self::get('pancer_chance', 'where id = ?', [$level]);
		}
		
		public static function pancers_num_get($level)
		{
			return self::get('pancers_num', 'where id = ?', [$level]);
		}
		
		public static function reward_percent_get($level)
		{
			\user_id($user_id);
			return self::get('reward_percent', 'where id = ?', [$level]);
		}
	}
}












namespace
{
	class scramble_enemy
	{
		public static function enemy_isset($user_id = false)
		{
			if (db\users_scramble_enemies::enemies_count($user_id) > 0) {
				return true;
			} return false;
		}
		
		public static function enemy_param_generate($health, $damage)
		{
			$rand = mt_rand(1, 100);
			if ($rand <= 30) {
				$min_enemy_health = (int) $health * 1.5;
				$max_enemy_health = (int) $health * 1.1;
				$min_enemy_damage = (int) $damage * 1.5;
				$max_enemy_damage = (int) $damage * 1.1;
			} elseif ($rand <= 60) {
				$min_enemy_health = (int) $health / 1.1;
				$max_enemy_health = (int) $health * 1.1;
				$min_enemy_damage = (int) $damage / 1.1;
				$max_enemy_damage = (int) $damage * 1.1;
			} else {
				$min_enemy_health = (int) $health / 1.5;
				$max_enemy_health = (int) $health / 1.1;
				$min_enemy_damage = (int) $damage / 1.5;
				$max_enemy_damage = (int) $damage / 1.1;
			}
			$enemy_health = rand($min_enemy_health,$max_enemy_health);
			$enemy_damage = rand($min_enemy_damage,$max_enemy_damage);
			return [
				'health' => $enemy_health,
				'damage' => $enemy_damage
			];
		}
		
		public static function enemy_id_generate($user_id)
		{
			// посчитать кол-во игроков
			$sql = 'select count(*) from users where id != ? and password is not null limit 1';
			$sth = \db::$pdo->prepare($sql);
			$sth->execute([$user_id]);
			$num = $sth->fetchColumn();
			if ($num > 0) { 
				$rand = mt_rand(0, $num - 1);
				$sql = "select id from users where id != ? and password is not null limit $rand, 1";
				$sth = \db::$pdo->prepare($sql);
				$sth->execute([$user_id]);
				return (int) $sth->fetchColumn();
			}
			return false;
		}
		
		public static function enemy_name_generate()
		{
			return 'Враг-' . mt_rand(1, 100);
		}
		
		public static function enemy_type_generate()
		{
			$types = [
				'health', 'power', 'agil', 'intell'
			];
			return $types[array_rand($types)];
		}
		
		public static function enemy_create($user_id = false)
		{
			user_id($user_id);
			if (self::enemy_isset($user_id)) {
				return false;
			}
			
			$user_health = user_combat::get_user_combat_health($user_id);
			$user_damage = user_combat::get_user_combat_damage($user_id);
			$enemy_param = self::enemy_param_generate($user_health, $user_damage);
			
			$enemy_id = self::enemy_id_generate($user_id);
			if ($enemy_id === false) {
				$enemy_name = self::enemy_name_generate();
				$enemy_type = self::enemy_type_generate();
			} else {
				$enemy_name = user::login_get($enemy_id);
				$enemy_turtle = user::turtle_get($enemy_id);
				$enemy_type = turtle_bonus($enemy_turtle);
			}
			
			$sec = new scramble_enemy_create;
			$sec->user_id = $user_id;
			$sec->user_health = $user_health;
			$sec->user_damage = $user_damage;
			$sec->enemy_name = $enemy_name;
			$sec->enemy_type = $enemy_type;
			$sec->enemy_health = $enemy_param['health'];
			$sec->enemy_damage = $enemy_param['damage'];
			$sec->tap();
			return true;
		}
		
		public static function enemy_delete($user_id = false)
		{
			user_id($user_id);
			db\users_scramble_enemies::enemy_delete($user_id);
		}
	}
	
	class scramble_enemy_create
	{
		public $user_id;
		public $user_health;
		public $user_damage;
		public $enemy_name;
		public $enemy_health;
		public $enemy_damage;
		public $enemy_type;
		
		public function tap()
		{
			$sql = 'insert into users_scramble_enemies set id_user = ?, user_health = ?, user_health_max = ?, user_damage = ?, enemy_name = ?, enemy_health = ?, enemy_health_max = ?, enemy_damage = ?, enemy_type = ?';
			$sth = db::$pdo->prepare($sql);
			return $sth->execute([
				$this->user_id,
				$this->user_health,
				$this->user_health,
				$this->user_damage,
				$this->enemy_name,
				$this->enemy_health,
				$this->enemy_health,
				$this->enemy_damage,
				$this->enemy_type
			]);
		}
	}
	
	class scramble_battle
	{
		public static function percent_damage_get($type = false)
		{
			$arr = [
				'health' => [
					'head' => 108,
					'body' => 75,
					'legs' => 95
				],
				'power' => [
					'head' => 115,
					'body' => 87,
					'legs' => 89
				],
				'agil' => [
					'head' => 89,
					'body' => 124,
					'legs' => 78
					
				],
				'intell' => [
					'head' => 79,
					'body' => 98,
					'legs' => 133
				]
			];
			if ($type === false) {
				return $arr;
			} return $arr[$type];
		}
		
		public static function hit_type_generate()
		{
			$types = ['head', 'body', 'legs'];
			return $types[array_rand($types)];
		}
		
		public static function hit($type, $user_id = false)
		{
			\user_id($user_id);
			$enemy_health = db\users_scramble_enemies::enemy_health_get($user_id);
			$enemy_damage = db\users_scramble_enemies::enemy_damage_get($user_id);
			$enemy_damage = (new damage)->generate($enemy_damage) * 1.4;
			$enemy_type = db\users_scramble_enemies::enemy_type_get($user_id);
			
			$percent_damage = self::percent_damage_get();
			
			$user_health = db\users_scramble_enemies::user_health_get($user_id);
			$user_damage = db\users_scramble_enemies::user_damage_get($user_id);
			$user_damage = (new damage)->generate($user_damage) * 1.4;
			
			$user_type = user::turtle_type_get($user_id);
			$user_damage_new = percentage($user_damage, $percent_damage[$enemy_type][$type]);
			$enemy_health_new = $enemy_health - $user_damage_new;
			
			$enemy_hit_type = self::hit_type_generate();
			$enemy_damage_new = percentage($enemy_damage, $percent_damage[$user_type][$enemy_hit_type]);
			$user_health_new = $user_health - $enemy_damage_new;
			
			db\users_scramble_enemies::user_health_set($user_health_new, $user_id);
			db\users_scramble_enemies::enemy_health_set($enemy_health_new, $user_id);
			self::caused_damage_set($user_damage_new, $user_id);
			self::received_damage_set($enemy_damage_new, $user_id);
			
			$died_who = false;
			if ($user_health_new < 1 || $enemy_health_new < 1) {
				$died_who = $user_health_new < $enemy_health_new ? 'user' : 'enemy';
				self::battle_result_set($died_who == 'user' ? 0 : 1, $user_id);
				db\users_scramble_detal::enemies_num_increase(-1, $user_id);
			}
			if ($died_who) {
				$user_statistic = new \user_statistic($user_id);
				$user_statistic->increase_statistic('scramble', 1);
			}
			return $died_who; // вернет кто умер user/enemy или false если никто
		}
		
		public static function caused_damage_get($user_id = false)
		{
			\user_id($user_id);
			return user_dyn::field_get('scramble_caused_damage', $user_id);
		}
		
		public static function caused_damage_set($damage, $user_id = false)
		{
			\user_id($user_id);
			return user_dyn::field_set(['scramble_caused_damage = ?', $damage], $user_id);
		}
		
		public static function received_damage_get($user_id = false)
		{
			\user_id($user_id);
			return user_dyn::field_get('scramble_received_damage', $user_id);
		}
		
		public static function received_damage_set($damage, $user_id = false)
		{
			\user_id($user_id);
			return user_dyn::field_set(['scramble_received_damage = ?', $damage], $user_id);
		}
		
		public static function battle_result_get($user_id = false)
		{
			\user_id($user_id);
			return user_dyn::field_get('result_scramble', $user_id);
		}
		
		public static function battle_result_set($result, $user_id = false)
		{
			\user_id($user_id);
			return user_dyn::field_set("result_scramble = $result", $user_id);
		}
		
		/* автобой */
		public static function auto($user_id)
		{
			// если противников нет
			if (\db\users_scramble_detal::enemies_num_get($user_id) < 1) {
				return;
			}
			
			$user_mutagen = \currency::mutagen_get($user_id);
			if ($user_mutagen < game::SCRAMBLE_AUTO_PRICE_MUTAGEN) {
				notf::set_notf('Недостаточно средств', 'error');
				return;
			}
			
			$victory_chance = mt_rand(40, 80);
			$accident = mt_rand(1, 100);
			if ($accident > $victory_chance) {
				// поражение
				$exodus = 'user';
			} else {
				// победа
				$exodus = 'enemy';
			}
			
			self::battle_result_set($exodus == 'user' ? 0 : 1, $user_id);
			
			db\users_scramble_detal::enemies_num_increase(-1, $user_id);
			scramble_reward::reward_give($exodus, $user_id);
			
			$user_statistic = new \user_statistic($user_id);
			$user_statistic->increase_statistic('scramble', 1);
			
			$currency = new \currency($user_id);
			$currency->bonuses = false;
			$currency->base = -game::SCRAMBLE_AUTO_PRICE_MUTAGEN;
			$currency->mutagen_add();
			return 2020;
		}
	}
	
	class scramble_reward
	{
		public static function reward_give($battle_result, $user_id = false)
		{
			\user_id($user_id);
			$combat_level = \db\users_scramble_detal::combat_level_get($user_id);
			$weapon_level = user_weapon::level_get($user_id);
			$user_level = user::level_get($user_id);
			$currency = new \currency;
			$currency->user_id = $user_id;
			
			$obj_user_prem = new \db\users_premium;
			$obj_user_prem->user_id = $user_id;
			$is_premium = $obj_user_prem->is_premium();
			
			/* battle_result - кто погиб? */
			if ($battle_result == 'enemy') {
				$exp = mt_rand(350, 550);
				$exp += $user_level * 40;
				$bucks = mt_rand(800, 1000);
				$bucks += $user_level * 70;
				$combat_expr = 2 + weapon::bonus_scramble_combat_expr_get($weapon_level);
				
				$pancer_chance = \db\_levels_scramble_combat::pancer_chance_get($combat_level);
				$pancers_num = \db\_levels_scramble_combat::pancers_num_get($combat_level);
				
				if ($is_premium) {
					$obj_prem_bonuses = new \premium\bonuses;
					$pancer_chance += $obj_prem_bonuses->get()['scramble_pancer_chance'];
				}
				if (mt_rand(1, 100) <= $pancer_chance) {
					$currency->base = $pancers_num;
					$currency->pancers_add();
				}
				$mutagen = (mt_rand(1, 100) <= 21) ? 1 : 0; 
			}
			elseif ($battle_result == 'user') {
				$exp = mt_rand(175, 275);
				$exp += $user_level * 25;
				$bucks = mt_rand(550, 700);
				$bucks += $user_level * 50;
				$combat_expr = 1 + (floor(weapon::bonus_scramble_combat_expr_get($weapon_level) / 2));
				$mutagen = 0;
			}
			
			if ($is_premium) {
				$obj_prem_bonuses = new \premium\bonuses;
				$combat_expr += percentage($combat_expr, $obj_prem_bonuses->get()['combat_expr_percent']);
			}
			\db\users_scramble_detal::combat_expr_increase($combat_expr);
			
			$reward_percent = \db\_levels_scramble_combat::reward_percent_get($combat_level);
			$exp += (int) floor(\percentage($exp, $reward_percent));
			$bucks += (int) floor(\percentage($bucks, $reward_percent));
			
			$currency->base = $bucks;
			$currency->bucks_add();
			
			if ($mutagen > 0) {
				$currency->base = $mutagen;
				$currency->mutagen_add();
			}
			
			$expr = new \expr;
			$expr->user_id = $user_id;
			$expr->base = $exp;
			$expr->add();
		}
	}
	
	class scramble_enemies
	{
		const ENEMIES_RECOVERY_SECONDS = 1800; // время восстановления противников
		const ENEMIES_RECOVERY_NUM = 5; // количество противников которые восстанавливаются за заданный промежуток времени
		const ENEMIES_NUM_MAX = 10;
		
		// сколько прошло секунд
		public static function enemies_recovery_seconds_gone_get($user_id = false)
		{
			user_id($user_id);
			$timestamp = db\users_scramble_detal::enemies_num_timestamp_get($user_id);
			return time() - $timestamp;
		}
		
		public static function enemies_recovery_num_get($user_id = false)
		{
			return self::ENEMIES_RECOVERY_NUM;
		}
		
		public static function enemies_num_max_get($user_id)
		{
			$enemies_num_max = 0;
			$obj_user_prem = new \db\users_premium;
			$obj_user_prem->user_id = $user_id;
			if ($obj_user_prem->is_premium()) {
				$obj_prem_bonuses = new \premium\bonuses;
				$enemies_num_max = $obj_prem_bonuses->get()['scramble_battles'];
			}
			return self::ENEMIES_NUM_MAX + $enemies_num_max;
		}
		
		public static function enemies_recovery_seconds_get($user_id = false)
		{
			return self::ENEMIES_RECOVERY_SECONDS;
		}
		
		public static function enemies_recovery_seconds_left_get($user_id = false)
		{
			user_id($user_id);
			$timestamp = db\users_scramble_detal::enemies_num_timestamp_get($user_id);
			return ($timestamp + self::enemies_recovery_seconds_get($user_id)) - time();
		}
		
		// контроллер восстановления врагов
		public static function enemies_recovery($user_id = false)
		{
			user_id($user_id);
			
			$enemies_num_max = self::enemies_num_max_get($user_id);
			$enemies_recovery_seconds = self::enemies_recovery_seconds_get($user_id);
			$enemies_recovery_num = self::enemies_recovery_num_get($user_id);
			
			$enemies_num = db\users_scramble_detal::enemies_num_get($user_id);
			$enemies_num_timestamp = db\users_scramble_detal::enemies_num_timestamp_get($user_id);
			
			$rec = new location_recovery;
			$rec->timestamp = $enemies_num_timestamp;
			$rec->num_current = $enemies_num;
			$rec->recovery_seconds = $enemies_recovery_seconds;
			$rec->recovery_num = $enemies_recovery_num;
			$rec->num_max = $enemies_num_max;
			$rec->tap();
			
			$timestamp = $rec->timestamp_new;
			$num = $rec->num_new;
			if ($timestamp != $enemies_num_timestamp) {
				db\users_scramble_detal::enemies_num_timestamp_set($timestamp, $user_id); // новая метка
			}
			if ($num != $enemies_num) {
				db\users_scramble_detal::enemies_num_set($num, $user_id); // новое кол-во врагов
			}
		}
	}
	
	class scramble_combat_level
		{
			public $user_id;
			
			public function __construct()
			{
				if ( ! $this->user_id) {
					$this->user_id = ID;
				}
			} 
			
			/* контроллер боевого уровня (ранга) */
			public function ctrl()
			{
				$combat_level = \db\users_scramble_detal::combat_level_get($this->user_id);
				/* если уровень максимальный */
				if ($combat_level >= \db\_levels_scramble_combat::level_max_get()) {
					return;
				}
				/* если опыта для повышения уровня недостаточно */
				if (\db\users_scramble_detal::combat_expr_get($this->user_id) < \db\_levels_scramble_combat::expr_need_get($combat_level)) {
					return;
				}
				
				\db\users_scramble_detal::combat_level_up($this->user_id);
			}
		}
	
	class scramble_model
	{
		public $user_id;
		
		public function __construct()
		{
			if ( ! $this->user_id) {
				$this->user_id = ID;
			}
		}
		
		public function scramble()
		{
			$enemies_num = db\users_scramble_detal::enemies_num_get($this->user_id);
			$enemies_recovery_seconds_left = scramble_enemies::enemies_recovery_seconds_left_get($this->user_id);
			$battle_result = scramble_battle::battle_result_get($this->user_id);
			
			$combat_level = db\users_scramble_detal::combat_level_get($this->user_id);
			$combat_rank = db\_levels_scramble_combat::name_get($combat_level);
			$combat_expr = db\users_scramble_detal::combat_expr_get($this->user_id);
			$combat_expr_need = db\_levels_scramble_combat::expr_need_get($combat_level);
			$combat_level_max = db\_levels_scramble_combat::level_max_get();
			$combat_level_min = db\_levels_scramble_combat::level_min_get();
			
			$combat_expr_need_prev = 0;
			if ($combat_level_min < $combat_level) {
				$combat_expr_need_prev = db\_levels_scramble_combat::expr_need_get($combat_level - 1);
			}
			
			$combat_percent = ($combat_level >= $combat_level_max) ? 100 : (int) floor(compercent($combat_expr - $combat_expr_need_prev, $combat_expr_need));
			if ($combat_percent > 100) $combat_percent = 100;
			
			return [
				'enemies_num' => $enemies_num,
				'enemies_recovery_seconds_left' => $enemies_recovery_seconds_left,
				'battle_result' => $battle_result,
				'combat_level' => $combat_level,
				'combat_rank' => $combat_rank,
				'combat_percent' => $combat_percent,
				'auto_price_mutagen' => game::SCRAMBLE_AUTO_PRICE_MUTAGEN
			];
		}
		
		public function scramble_battle()
		{
			$user_id = $this->user_id;
			$enemy_name = db\users_scramble_enemies::enemy_name_get($user_id);
			$enemy_type = db\users_scramble_enemies::enemy_type_get($user_id);
			$enemy_turtles = [
				'health' => 'raf',
				'power' => 'leo',
				'agil' => 'miki',
				'intell' => 'doni'
			];
			$enemy_turtle = $enemy_turtles[$enemy_type];
			$enemy_type_rus = translate::param_name_what($enemy_type);
			$enemy_health = db\users_scramble_enemies::enemy_health_get($user_id);
			$enemy_health_max = db\users_scramble_enemies::enemy_health_max_get($user_id);
			$enemy_damage = db\users_scramble_enemies::enemy_damage_get($user_id);
			
			$user_turtle = user::turtle_get($user_id);
			$user_health = db\users_scramble_enemies::user_health_get($user_id);
			$user_health_max = db\users_scramble_enemies::user_health_max_get($user_id);
			$user_damage = db\users_scramble_enemies::user_damage_get($user_id);
			$user_caused_damage = scramble_battle::caused_damage_get($user_id);
			$user_received_damage = scramble_battle::received_damage_get($user_id);
			
			return [
				'enemy_name' => $enemy_name,
				'enemy_turtle' => $enemy_turtle,
				'enemy_type_rus' => $enemy_type_rus,
				'enemy_health' => $enemy_health,
				'enemy_health_max' => $enemy_health_max,
				'enemy_damage' => $enemy_damage,
				'user_turtle' => $user_turtle,
				'user_health' => $user_health,
				'user_health_max' => $user_health_max,
				'user_damage' => $user_damage,
				'user_caused_damage' => $user_caused_damage,
				'user_received_damage' => $user_received_damage
			];
		}
	}
}