<?php

class setting
{
	public static function login_change($user_id, $login_new)
	{
		$change_price_muragen = game::LOGIN_CHANGE_PRICE_MUTAGEN;
		if (user_currency::get_mutagen($user_id) < $change_price_muragen) {
			return;
		}
		user::login_set($login_new, $user_id);
		$currency = new currency($user_id);
		$currency->bonuses = false;
		$currency->base = -$change_price_muragen;
		$currency->mutagen_add();
		notf::set_notf('Вы сменили ник.', 'default');
	}
	
	public static function password_change($user_id, $password_old, $password_new)
	{
		$password_old = encrypt_user_password($password_old);
		if (user::password_get($user_id) != $password_old) {
			notf::set_notf('Старый пароль введен неправильно', 'error');
			return;
		}
		$password_new = encrypt_user_password($password_new);
		user::password_set($password_new, $user_id);
		notf::set_notf('Вы сменили пароль', 'default');
	}
	
	public static function gender_change($user_id, $gender)
	{
		user::gender_set($gender, $user_id);
	}
	
	public static function character_change($user_id, $character)
	{
		$character_current = user::turtle_get($user_id);
		if ($character_current == $character) {
			return;
		}
		$mutagen = user_currency::get_mutagen($user_id);
		if ($mutagen < game::CHARACTER_CHANGE_PRICE_MUTAGEN) {
			notf::set_notf('У вас недостаточно мутагена.', 'error');
			return;
		}
		user_currency_indrat::update_mutagen(-game::CHARACTER_CHANGE_PRICE_MUTAGEN, $user_id);
		user::turtle_set($character, $user_id);
		notf::set_notf('Вы сменили персонажа.', 'default');
	}
	
	public static function email_attached($user_id, $email)
	{
		$user = new user($user_id);
		if (user::search_email($email) && $user->is_confirm_email($email)) { // емей занят и подтвержден
			notf::set_notf('Этот электронный адрес уже занят.', 'error');
			return;
		}
		
		$user->set_email($email);
		self::send_confirm_code($user_id, $email);
		notf::set_notf('Код подтверждения отправлен на вашу почту.', 'default');
	}
	
	public static function confirm_email($user_id, $code)
	{
		$user = new user($user_id);
		
		/* этот блок кода отвечает за то что если мыло которое закреплено за этим пользователем уже привязано к другому персонажу */
		$user_email = $user->get_email();
		$sql = 'select id from users where id != ? and email = ? limit 1';
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([$user_id, $user_email]);
		$user_id_email = $sth->fetchColumn();
		if (is_numeric($user_id_email)) {
			$user_two = new user($user_id_email);
			if ($user_two->is_confirm_email()) {
				// сделать сброс
				$user->set_email(null);
				$user->set_email_confirm_code(null);
				notf::set_notf('К этому электронному адресу уже привязан другой персонаж.', 'error');
				return;
			}
		}
		
		$save_code = $user->get_email_confirm_code();
		if (is_null($save_code)) {
		if ($code != $save_code) {
			notf::set_notf('Ошибка!', 'error');
			return;
		}
			notf::set_notf('Неверный код подтверждения.', 'error');
			return;
		}
		$user->set_email_confirm(1);
		notf::set_notf('Email подтвержден. Персонаж привязан.', 'default');
		$currency = new currency($user_id);
		$currency->bonuses = false;
		$currency->base = game::ATTACHED_EMAIL_MUTAGEN_NUM;
		$currency->mutagen_add();
		return true;
	}
	
	// отправить на почту код подтверждения
	public static function send_confirm_code($user_id, $email)
	{
		$code = mt_rand(1000, 9999);
		$user = new user($user_id);
		$user->set_email_confirm_code($code);
		$subject = 'Браузерная игра «Черепашки Ниндзя»';
		$text = "Ваш код подтверждения: $code";
		return mail($email, $subject, $text);
	}
	
	// сбросить email и код
	public static function reset_email($user_id)
	{
		$user = new user($user_id);
		$user->set_email(null);
		$user->set_email_confirm_code(null);
		return true;
	}
}