<?php

namespace db;

class _sewerage extends \_tbl_line
{
	protected static $table = '_sewerage';
	
	public static function is($id)
	{
		if (self::get('count(*)', 'where id = ?', [$id]) > 0) {
			return true;
		} return false;
	}
	
	public static function name_get($id)
	{
		return self::get('name', 'where id = ?', [$id]);
	}
	
	public static function level_need_get($id)
	{
		return self::get('level_need', 'where id = ?', [$id]);
	}
	
	public static function recovery_seconds_get($id)
	{
		return self::get('recovery_seconds', 'where id = ?', [$id]);
	}
	
	public static function wave_max_get($location_id)
	{
		$enemies = self::enemies_unserialize_get($location_id);
		return count($enemies);
	}
	
	public static function wave_enemies_get($location_id, $wave)
	{
		$enemies = self::enemies_unserialize_get($location_id);
		$wave_enemies = $enemies[$wave];
		// v($wave_enemies);
		$temp = [];
		foreach ($wave_enemies as $key => $val) {
			if (is_array($val)) {
				$each['key'] = key($val);
				$each['value'] = $val[$each['key']];
				$temp[$each['key']] = $each['value'];
			}
			else {
				$temp[$key] = $val;
			}
		}
		return $temp;
	}
	
	private static function enemies_get($location_id)
	{
		return self::get('enemies', 'where id = ?', [$location_id]);
	}
	
	private static function enemies_unserialize_get($location_id)
	{
		return unserialize(self::enemies_get($location_id));
	}
	
	private static function reward_cards_get($location_id)
	{
		return self::get('reward_cards', 'where id = ?', [$location_id]);
	}
	
	public static function reward_cards_unserialize_get($location_id)
	{
		return unserialize(self::reward_cards_get($location_id));
	}
	
	/*  id  ,  id  */
	public static function card_random_id($location_id)
	{
		$cards = self::reward_cards_unserialize_get($location_id);
		return $cards[array_rand($cards)];
	}
	
	public static function reward_exp_get($location_id)
	{
		return self::get('reward_exp', 'where id = ?', [$location_id]);
	}
	
	public static function reward_bucks_get($location_id)
	{
		return self::get('reward_bucks', 'where id = ?', [$location_id]);
	}
	
	public static function reward_metal_get($location_id)
	{
		return self::get('reward_metal', 'where id = ?', [$location_id]);
	}
	
	public static function sewerage_all_get()
	{
		return self::all_get('* : assoc', ['', '']);
	}
}