<?php

namespace db
{
	class _shop_resources_lot extends \_tbl_line
	{
		protected static $table = '_shop_resources_lot';
		
		public static function table_get()
		{
			return self::$table;
		}
		
		public static function count()
		{
			return self::get('count(*)');
		}
		
		public static function search($lot_id)
		{
			return self::get('count(*)', 'where id = ?', [$lot_id]);
		}
		
		public static function resource_get($lot_id)
		{
			return self::get('resource', 'where id = ?', [$lot_id]);
		}
		
		public static function quantity_get($lot_id)
		{
			return self::get('quantity', 'where id = ?', [$lot_id]);
		}
		
		public static function price_mutagen_get($lot_id)
		{
			return self::get('price_mutagen', 'where id = ?', [$lot_id]);
		}
	}
}

namespace
{
	class shop_resources
	{
		const BUCKS_UNIT_PRICE_MUTAGEN = 0.001; // цена за одну единицу баксов (в мутагене)
		const METAL_UNIT_PRICE_MUTAGEN = 0.002; // цена за одну единицу металлолома (в мутагене)
		const PANCERS_UNIT_PRICE_MUTAGEN = 2; // цена за одну единицу панцирей (в мутагене)
		
		public static function lot_ecquire($lot_id, $user_id = false)
		{
			user_id($user_id);
			if (db\_shop_resources_lot::search($lot_id) == 0) {
				return;
			}
			$price_mutagen = db\_shop_resources_lot::price_mutagen_get($lot_id);
			$user_mutagen = user_currency::get_mutagen($user_id);
			if ($user_mutagen < $price_mutagen) {
				return;
			}
			$resource = db\_shop_resources_lot::resource_get($lot_id);
			$quantity = db\_shop_resources_lot::quantity_get($lot_id);
			
			$resource_function = "update_$resource";
			user_currency_indrat::$resource_function($quantity, $user_id);
			user_currency_indrat::update_mutagen(-$price_mutagen, $user_id);
			user_currency_indrat::update_new_currency($resource, $quantity, $user_id);
			user_currency_indrat::update_new_currency('mutagen', -$price_mutagen, $user_id);
		}
	}
	
	class shop_resources_model
	{
		public function shop_resources()
		{
			$res = $this->lot_all_get();
			return [
				'pag' => $res['pag'],
				'lot_all' => $res['lot_all']
			];
		}
		
		protected function lot_all_get()
		{
			$table = db\_shop_resources_lot::table_get();
			$pag = new pagination;
			$lot_num = db\_shop_resources_lot::count();
			$limit = $pag->start($lot_num, 5);
			$sql = "select * from $table order by resource asc, quantity asc limit $limit[start], $limit[limit]";
			$sth = db::$pdo->query($sql);
			$lot_all = $sth->fetchAll(PDO::FETCH_ASSOC);
			$currency_name = translate::currency_name();
			// v($currency_name);
			foreach ($lot_all as $key => $val) {
				$lot_all[$key]['resource_rus'] = $currency_name[$val['resource']];
			}
			return [
				'pag' => $pag,
				'lot_all' => $lot_all
			];
		}
	}
}