<?php

require ROOT . 'project/internal/box/sweeping/sweeping_enemies.db.php';
require ROOT . 'project/internal/box/sweeping/sweeping_users.db.php';

class sweeping_enemies extends \indrat\sweeping_enemies {}

class sweeping_users extends \indrat\sweeping_users
{
	const ENEMIES_RECOVERY_SECONDS = 60; // время восстановление противников в секундах
	const ENEMIES_NUM_RECOVERY = 1; // число врагов восстанавливаемых за время заданное в ENEMIES_RECOVERY_SECONDS
	const ENEMIES_NUM_DEFAULT = 10; // количество врагов по умолчанию
	const REWARD_BUCKS_VICTORY_BASE = 350; // базовая награда в баксах за победу
	const REWARD_BUCKS_LOSS_BASE = 275; // базовая награда в баксах за поражение
	const REWARD_EXP_VICTORY_BASE = 125; // базовая награда опыта за победу
	const REWARD_EXP_LOSS_BASE = 75; // базовая награда опыта за поражение
	const ENEMIES_LIMIT_NOT_FINE = 50; // лимит врагов без штрафа  (штраф - секунд восстановления боёв)
	
	public $user_id;
	
	public function __construct($user_id)
	{
		$this->user_id = $user_id;
	}
	
	public function get_enemies_num()
	{
		$enemies_base_num = sweeping_users::enemies_num_get($this->user_id);
		$enemies_bonus_num = sweeping_users::enemies_bonus_num_get($this->user_id);
		return $enemies_base_num + $enemies_bonus_num;
	}

	// секунд осталось до восстановления одной партии боев
	public static function enemy_recovery_seconds_left_get($user_id = false)
	{
		user_id($user_id);
		$timestamp = static::enemies_recovery_timestamp_get($user_id);
		return ($timestamp + static::enemies_recovery_seconds_get($user_id)) - time();
	}
	
	// секунд осталось до восстановления всех боёв
	public static function enemies_all_recovery_seconds_left_get($user_id = false)
	{
		user_id($user_id);
		$a_lock_of = static::enemies_max_get($user_id) - static::enemies_num_get($user_id); // сколько нехватает боёв
		$seconds_left = ($a_lock_of - 1) * static::enemies_recovery_seconds_get($user_id);
		return $seconds_left + static::enemy_recovery_seconds_left_get($user_id);
	}
	
	// максимальное количество боев у игрока
	public static function enemies_max_get($user_id = false)
	{
		\user_id($user_id);
		$enemies_num_max = 0;
		$obj_user_prem = new \db\users_premium;
		$obj_user_prem->user_id = $user_id;
		if ($obj_user_prem->is_premium()) {
			$obj_prem_bonuses = new \premium\bonuses;
			$enemies_num_max = $obj_prem_bonuses->get()['sweeping_battles'];
		}
		return static::ENEMIES_NUM_DEFAULT + $enemies_num_max;
	}
	
	// время восстановления одной партии боёв
	public static function enemies_recovery_seconds_get($user_id = false)
	{
		\user_id($user_id);
		return static::ENEMIES_RECOVERY_SECONDS + self::enemy_recovery_seconds_fine_get($user_id);
	}
	
	public static function enemies_recovery_num_get($user_id = false)
	{
		\user_id($user_id);
		return static::ENEMIES_NUM_RECOVERY;
	}
	
	// штраф секунд восстановления одного боя
	public static function enemy_recovery_seconds_fine_get($user_id)
	{
		$enemies_passed_num = self::enemies_passed_num_today_get($user_id);
		$enemies_limit_not_fine = self::enemies_limit_not_fine_get($user_id);
		if ($enemies_passed_num <= $enemies_limit_not_fine) {
			return 0;
		}
		return $enemies_passed_num - $enemies_limit_not_fine;
	}
	
	// колво восстанавливаемых боёв без штрафа
	public static function enemies_limit_not_fine_get($user_id)
	{
		return self::ENEMIES_LIMIT_NOT_FINE;
	}
	
	// генерировать статы врага
	public static function enemy_stats_generate($user_id = false)
	{
		user_id($user_id);
		$param = uc::get_param_all($user_id);
		$a = [
			'health' => [
				'min' => (int) $param['health'] / 1.2,
				'max' => $param['health'] * 1.2
			],
			'power' => [
				'min' => (int) $param['power'] / 1.2,
				'max' => $param['power'] * 1.2
			],
			'agil' => [
				'min' => (int) $param['agil'] / 1.2,
				'max' => $param['agil'] * 1.2
			],
			'intell' => [
				'min' => (int) $param['intell'] / 1.2,
				'max' => $param['intell'] * 1.2
			]
		];
		return [
			'health' => mt_rand($a['health']['min'], $a['health']['max']),
			'power' => mt_rand($a['power']['min'], $a['power']['max']),
			'agil' => mt_rand($a['agil']['min'], $a['agil']['max']),
			'intell' => mt_rand($a['intell']['min'], $a['intell']['max'])
		];
	}
	
	// генерировать награду
	public static function reward_generate($user_id = false)
	{
		user_id($user_id);
		$bucks_victory_min = (int) static::REWARD_BUCKS_VICTORY_BASE / 1.2;
		$bucks_victory_max = (int) static::REWARD_BUCKS_VICTORY_BASE * 1.2;
		$bucks_loss_min = (int) static::REWARD_BUCKS_LOSS_BASE / 1.2;
		$bucks_loss_max = (int) static::REWARD_BUCKS_LOSS_BASE * 1.2;
		
		$exp_victory_min = (int) static::REWARD_EXP_VICTORY_BASE / 1.2;
		$exp_victory_max = (int) static::REWARD_EXP_VICTORY_BASE * 1.2;
		$exp_loss_min = (int) static::REWARD_EXP_LOSS_BASE / 1.2;
		$exp_loss_max = (int) static::REWARD_EXP_LOSS_BASE * 1.2;
		
		$pancers = 0;
		if (mt_rand(1, 100) <= 20) {
			$pancers = self::pancers_generate($user_id);
		}
		
		return [
			'victory' => [
				'bucks' => mt_rand($bucks_victory_min, $bucks_victory_max),
				'exp' => mt_rand($exp_victory_min, $exp_victory_max),
				'pancers' => $pancers
			],
			'loss' => [
				'bucks' => mt_rand($bucks_loss_min, $bucks_loss_max),
				'exp' => mt_rand($exp_loss_min, $exp_loss_max),
				'pancers' => 0
			]
		];
	}
	
	public static function pancers_generate($user_id)
	{
		// на 20-ом уровне оружия игрок получает 2 панция
		// на 40-ом уровне оружия игрок получает 3 панция
		$pancers = 1;
		$weapon_level = \user_weapon::level_get($user_id);
		if ($weapon_level >= 20 && $weapon_level < 40) {
			$pancers = 2;
		} elseif ($weapon_level >= 40) {
			$pancers = 3;
		}
		return $pancers;
	}
	
	public static function enemy_new($user_id = false)
	{
		user_id($user_id);
		$id = sweeping_enemies::rand_id();
		$name = sweeping_enemies::name_get($id);
		$stats = static::enemy_stats_generate($user_id);
		parent::enemy_create($id, $name, $stats, $user_id);
	}
	
	// контроллер восстановления врагов
	public static function enemies_recovery_ctrl($user_id = false)
	{
		user_id($user_id);

		$enemies_num_max = self::enemies_max_get($user_id);
		$enemies_recovery_seconds = self::enemies_recovery_seconds_get($user_id);
		$enemies_recovery_num = self::enemies_recovery_num_get($user_id);
		
		$enemies_num = self::enemies_num_get($user_id);
		$enemies_num_timestamp = self::enemies_recovery_timestamp_get($user_id);
		
		$rec = new location_recovery;
		$rec->timestamp = $enemies_num_timestamp;
		$rec->num_current = $enemies_num;
		$rec->recovery_seconds = $enemies_recovery_seconds;
		$rec->recovery_num = $enemies_recovery_num;
		$rec->num_max = $enemies_num_max;
		$rec->tap();
		
		$timestamp = $rec->timestamp_new;
		$num = $rec->num_new;
		if ($timestamp != $enemies_num_timestamp) {
			self::enemies_recovery_timestamp_set($timestamp, $user_id); // новая метка
		}
		if ($num != $enemies_num) {
			self::enemies_num_set($num, true, $user_id); // добавить врагов
		}
	}
	
	// контроллер создания врага
	public static function enemy_create_ctrl($user_id = false)
	{
		user_id($user_id);
		if (static::enemy_isset($user_id)) { // враг существует
			return false;
		}
		static::enemy_new($user_id);
	}
	
	// контроллер боя
	public static function battle_ctrl($user_id = false)
	{
		user_id($user_id);
		
		$enemies_base_num = static::enemies_num_get($user_id);
		$enemies_bonus_num = sweeping_users::enemies_bonus_num_get($user_id);
		$enemies_overall_num = $enemies_base_num + $enemies_bonus_num;
		if ($enemies_overall_num < 1) { // если врагов нет
			return false;
		}
		
		$result = 0; // результат боя
		$victory_chance = 70;
		if (mt_rand(1, 100) <= $victory_chance) {
			$result = 1;
		}
		
		// сначала проходить базовые бои
		if ($enemies_base_num > 0) {
			static::enemies_num_set(-1, false, $user_id);
		} elseif ($enemies_bonus_num > 0) {
			sweeping_users::enemies_bonus_num_increase(-1, $user_id);
		}
		
		static::enemy_name_set(null, $user_id);
		static::battle_result_set($result, $user_id);
		static::enemies_passed_num_today_set(1, $user_id);
		$user_statistic = new \user_statistic($user_id);
		$user_statistic->increase_statistic('sweeping', 1);
		return $result;
	}
	
	// контроллер награды
	// result = победа или поражени (1/0)
	public static function reward_ctrl($result, $user_id = false)
	{
		user_id($user_id);
		$reward = static::reward_generate($user_id);
		if ($result == 1) {
			$bucks = $reward['victory']['bucks'];
			$exp = $reward['victory']['exp'];
			$pancers = $reward['victory']['pancers'];
		}
		elseif ($result == 0) {
			$bucks = $reward['loss']['bucks'];
			$exp = $reward['loss']['exp'];
			$pancers = $reward['loss']['pancers'];
		}
		
		$currency = new \currency($user_id);
		$currency->bonuses = true;
		$currency->base = $bucks;
		$currency->bucks_add();
		$currency->base = $pancers;
		$currency->pancers_add();
		
		user_currency::update_bucks($bucks, $user_id);
		user_exp::exp_set($exp, $user_id);
	}
	
	// контроллер сброса дневных накоплений зачистки
	public static function enemies_passed_num_today_reset_ctrl($user_id)
	{
		if ( ! day_new(self::enemies_passed_num_today_timestamp_get($user_id))) {
			return;
		}
		self::enemies_passed_num_today_reset($user_id);
		self::enemies_passed_num_today_timestamp_set(false, $user_id);
	}
}

/* покупка бонусных боёв */
class sweeping_battles_purchase
{
	public $user_id;
	
	private $num_purchase; // сколько купить
	private $user_num_bought; // сколько купил игрок
	
	public function __construct($user_id)
	{
		$this->user_id = $user_id;
		$this->num_purchase = $this->get_battles_num_single_purchase();
		$this->user_num_bought = sweeping_users::enemies_num_bought_get($user_id);
	}
	
	// купить
	public function buy()
	{
		$price_mutagen = $this->get_price_mutagen_purchase();
		$user_mutagen = currency::mutagen_get($this->user_id);
		if ($user_mutagen < $price_mutagen) {
			notf::set_notf('Недостаточно средств.', 'error');
			return;
		}
		
		$num_purchase = $this->get_battles_num_single_purchase();
		
		sweeping_users::enemies_num_bought_increase($num_purchase, $this->user_id);
		sweeping_users::enemies_bonus_num_increase($num_purchase, $this->user_id);
		
		$currency = new \currency($this->user_id);
		$currency->bonuses = false;
		$currency->base = -$price_mutagen;
		$currency->mutagen_add();
	}
	
	// получить число боёв одноразовой покупки
	public function get_battles_num_single_purchase()
	{
		$config = require ROOT . 'project/internal/box/sweeping/sweeping.config.php';
		return $config['battles_num_single_purchase'];
	}
	
	// узнать цену покупки
	public function get_price_mutagen_purchase()
	{
		$config = require ROOT . 'project/internal/box/sweeping/sweeping.config.php';
		$battles_num_single_purchase = $this->get_battles_num_single_purchase();
		if ($this->user_num_bought < $battles_num_single_purchase) {
			$price_mutagen_purchase = $config['battles_price_mutagen_single_purchase'];
		} else {
			// сколько раз игрок купил одноразовую партию боёв
			$num_purchase = (int) floor($this->user_num_bought / $battles_num_single_purchase);
			$price_mutagen_purchase = ($num_purchase * $config['battles_price_mutagen_single_purchase']) + $config['battles_price_mutagen_single_purchase'];
		}
		return $price_mutagen_purchase;
	}
}

/* (ежедневный) сброс купленных боёв */
class sweeping_enemies_bought_reseter
{
	public $user_id;
	
	public function __construct($user_id)
	{
		$this->user_id = $user_id;
	}
	
	public function reset()
	{
		if ( ! $this->is_need_reset()) {
			return;
		}
		$user_id = $this->user_id;
		
		sweeping_users::enemies_num_bought_set(0, $user_id);
		sweeping_users::enemies_num_bought_timestamp_set($user_id, time());
		if ($this->is_bonus_battles_need_reset()) {
			sweeping_users::enemies_bonus_num_set(0, $user_id);
		}
	}
	
	/* нужно ли сбрасывать */
	private function is_need_reset()
	{
		$user_id = $this->user_id;
		$timestamp = sweeping_users::enemies_num_bought_timestamp_get($user_id);
		if (day_new($timestamp)) {
			return true;
		} return false;
	}
	
	/* нужно ли сбрасывать все бонусные бои */
	private function is_bonus_battles_need_reset()
	{
		return true;
	}
}