<?php

namespace indrat;
class sweeping_users extends \_tbl_line
{
	static $table = 'users_sweeping';
	
	// достать id врага
	public static function enemy_id_get($user_id = false)
	{
		user_id($user_id);
		return static::get('id_enemy', 'where id_user = ?', [$user_id]);
	}
	
	// достать имя врага
	public static function enemy_name_get($user_id = false)
	{
		user_id($user_id);
		return static::get('name', 'where id_user = ?', [$user_id]);
	}
	
	// достать число пораженных противников
	public static function enemies_passed_num_today_get($user_id = false)
	{
		user_id($user_id);
		return static::get('enemies_passed_num_today', 'where id_user = ?', [$user_id]);
	}
	
	// записать число пораженных противников
	public static function enemies_passed_num_today_set($num, $user_id = false)
	{
		user_id($user_id);
		return static::set('enemies_passed_num_today = enemies_passed_num_today + ?', 'where id_user = ?', [$num, $user_id]);
	}
	
	// сбросить число пораженных противников
	public static function enemies_passed_num_today_reset($user_id = false)
	{
		user_id($user_id);
		return static::set('enemies_passed_num_today = 0', 'where id_user = ?', [$user_id]);
	}
	
	// достать метку времени отвечающую за число пройденных противников в зачистке
	public static function enemies_passed_num_today_timestamp_get($user_id = false)
	{
		user_id($user_id);
		return static::get('enemies_passed_num_today_timestamp', 'where id_user = ?', [$user_id]);
	}
	
	// записать метку времени отвечающую за число пройденных противников в зачистке
	public static function enemies_passed_num_today_timestamp_set($time = false, $user_id = false)
	{
		user_id($user_id);
		if ($time === false) $time = time();
		return static::set('enemies_passed_num_today_timestamp = ?', 'where id_user = ?', [$time, $user_id]);
	}
	
	// достать число доступных противников
	public static function enemies_num_get($user_id = false)
	{
		user_id($user_id);
		return static::get('enemies_num', 'where id_user = ?', [$user_id]);
	}
	
	// достать число доступных бонусных противников
	public static function enemies_bonus_num_get($user_id = false)
	{
		user_id($user_id);
		return static::get('enemies_bonus_num', 'where id_user = ?', [$user_id]);
	}
	
	// получить число купленных противников
	public static function enemies_num_bought_get($user_id = false)
	{
		user_id($user_id);
		return static::get('enemies_num_bought', 'where id_user = ?', [$user_id]);
	}
	
	// установить количество купленных противников
	public static function enemies_num_bought_set($num, $user_id = false)
	{
		user_id($user_id);
		return static::set('enemies_num_bought = ?', 'where id_user = ?', [$num, $user_id]);
	}
	
	// увеличить количество купленных противников
	public static function enemies_num_bought_increase($num, $user_id = false)
	{
		user_id($user_id);
		return static::set('enemies_num_bought = enemies_num_bought + ?', 'where id_user = ?', [$num, $user_id]);
	}
	
	public static function enemies_num_bought_timestamp_get($user_id = false)
	{
		user_id($user_id);
		return static::get('enemies_num_bought_timestamp', 'where id_user = ?', [$user_id]);
	}
	
	public static function enemies_num_bought_timestamp_set($user_id, $time)
	{
		user_id($user_id);
		return static::set('enemies_num_bought_timestamp = ?', 'where id_user = ?', [$time, $user_id]);
	}
	
	// есть ли враг сейчас
	public static function enemy_isset($user_id = false)
	{
		user_id($user_id);
		if (is_null(static::enemy_name_get($user_id))) {
			return false;
		} return true;
	}
	
	// достать временную метку которая отвечает за восстановление боёв игрока
	public static function enemies_recovery_timestamp_get($user_id = false)
	{
		user_id($user_id);
		return static::get('enemies_num_timestamp', 'where id_user = ?', [$user_id]);
	}
	
	// узнать результат битвы
	public static function battle_result_get($user_id = false)
	{
		user_id($user_id);
		return static::get('battle_result', 'where id_user = ?', [$user_id]);
	}
	
	// получить статы врага
	public static function enemy_stats_get($user_id = false)
	{
		user_id($user_id);
		return static::get('health, power, agil, intell : assoc', 'where id_user = ?', [$user_id]);
	}
	
	// записать результат битвы
	public static function battle_result_set($result, $user_id = false)
	{
		user_id($user_id);
		return static::set('battle_result = ?', 'where id_user = ?', [$result, $user_id]);
	}
	
	// записать временную метку которая отвечает за восстановление боёв игрока
	public static function enemies_recovery_timestamp_set($time = false, $user_id = false)
	{
		user_id($user_id);
		if ($time === false) $time = time();
		return static::set('enemies_num_timestamp = ?', 'where id_user = ?', [$time, $user_id]);
	}
	
	// записать новое количество врагов
	public static function enemies_num_set($num, $rewrite = false, $user_id = false)
	{
		user_id($user_id);
		$field = 'enemies_num = enemies_num + ?';
		if ($rewrite === true) $field = 'enemies_num = ?';
		return static::set($field, 'where id_user = ?', [$num, $user_id]);
	}
	
	// установить количество бонусных врагов
	public static function enemies_bonus_num_set($num, $user_id = false)
	{
		user_id($user_id);
		return static::set('enemies_bonus_num = ?', 'where id_user = ?', [$num, $user_id]);
	}
	
	// увеличить количество бонусных врагов
	public static function enemies_bonus_num_increase($num, $user_id = false)
	{
		user_id($user_id);
		return static::set('enemies_bonus_num = enemies_bonus_num + ?', 'where id_user = ?', [$num, $user_id]);
	}
	
	// записать новое имя
	public static function enemy_name_set($name, $user_id = false)
	{
		static::set('name = ?', 'where id_user = ?', [$name, $user_id]);
	}
	
	// создать нового врага
	public static function enemy_create($id, $name, $stats, $user_id = false)
	{
		user_id($user_id);
		$field = 'id_enemy = ?, name = ?, health = ?, power = ?, agil = ?, intell = ?';
		static::set($field, 'where id_user = ?', [$id, $name, $stats['health'], $stats['power'], $stats['agil'], $stats['intell'], $user_id]);
	}
}