<?php

namespace indrat
{
	class user extends \_tbl_line
	{
		protected static $table = 'users';
		
		// существует ли игрок с id
		public static function is_user($id_user = false)
		{
			\user_id($user_id);
			if (self::get('count(*)', 'where id = ?', [$id_user]) > 0) {
				return true;
			} return false;
		}
		
		// получить логин
		public static function login_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('login', 'where id = ?', [$user_id]);
		}
		
		// сменить логин
		public static function login_set($login, $user_id = false)
		{
			\user_id($user_id);
			return self::set('login = ?', 'where id = ?', [$login, $user_id]);
		}
		
		// получить пароль
		public static function password_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('password', 'where id = ?', [$user_id]);
		}
		
		// сменить пароль
		public static function password_set($password, $user_id = false)
		{
			\user_id($user_id);
			return self::set('password = ?', 'where id = ?', [$password, $user_id]);
		}
		
		// получить пол
		public static function gender_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('gender', 'where id = ?', [$user_id]);
		}
		
		// сменить пол
		public static function gender_set($gender, $user_id = false)
		{
			\user_id($user_id);
			return self::set('gender = ?', 'where id = ?', [$gender, $user_id]);
		}
		
		// получить уровень игрока
		public static function level_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('level', 'where id = ?', [$user_id]);
		}
		
		// записать уровень игрока
		public static function level_set($level, $user_id = false)
		{
			\user_id($user_id);
			self::set('level = ?', 'where id = ?', [$level, $user_id]);
		}
		
		// получить значение опыта
		public static function exp_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('exp', 'where id = ?', [$user_id]);
		}
		
		// записать значение опыта
		public static function exp_set($exp, $user_id = false)
		{
			\user_id($user_id);
			return self::set('exp = exp + ?', 'where id = ?', [$exp, $user_id]);
		}
		
		// узнать за какую черепашку играет игрок
		public static function turtle_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('hero', 'where id = ?', [$user_id]);
		}
		
		// сменить черепашку
		public static function turtle_set($turtle, $user_id = false)
		{
			\user_id($user_id);
			return self::set('hero = ?', 'where id = ?', [$turtle, $user_id]);
		}
		
		// узнать какой основной бонус черепашки
		public static function turtle_type_get($user_id = false)
		{
			\user_id($user_id);
			$t = [
				'leo' => 'power',
				'raf' => 'health',
				'miki' => 'agil',
				'doni' => 'intell'
			];
			return $t[self::turtle_get($user_id)];
		}
		
		public static function position_get($user_id = false)
		{
			\user_id($user_id);
			return self::get('position', 'where id = ?', [$user_id]);
		}
		
		/* получить время регистрации */
		public static function reg_timestamp_get($user_id)
		{
			return self::get('reg_timestamp', 'where id = ?', [$user_id]);
		}
		
		/* получить кол-во пройденных секунд с момента регистрации начала игры */
		public static function reg_seconds_gone_get($user_id)
		{
			return time() - self::reg_timestamp_get($user_id);
		}
	}
}

namespace
{
	class user extends \indrat\user
	{
		public $user_id;
		
		public function __construct($user_id)
		{
			$this->user_id = ($user_id);
		}
		
		// получить email
		public function get_email()
		{
			$sql = 'select email from users where id = ? limit 1';
			$sth = \db::$pdo->prepare($sql);
			$sth->execute([$this->user_id]);
			return $sth->fetchColumn();
		}
		
		// записать email
		public function set_email($email)
		{
			$sql = 'update users set email = ? where id = ? limit 1';
			$sth = \db::$pdo->prepare($sql);
			return $sth->execute([$email, $this->user_id]);
		}
		
		// true, если привязан к почте (и мыло подтверждено)
	/* 	public function is_attached_email()
		{
			if ( ! is_null($this->get_email())) {
				return true;
			} return false;
		} */
		
		// true, если мыло подтверждено
		// если email false, то проверяет подтверждено ли мыло у это юзера
		public function is_confirm_email($email = false)
		{
			if ($email) {
				$subs = $email;
				$sql = 'select email_confirm from users where email = ? limit 1';
			} else {
				$subs = $this->user_id;
				$sql = 'select email_confirm from users where id = ? limit 1';
			}
			$sth = \db::$pdo->prepare($sql);
			$sth->execute([$subs]);
			if ($sth->fetchColumn() == 1) {
				return true;
			} return false;
		}
		
		// email_confirm 0 or 1
		public function set_email_confirm($email_confirm)
		{
			$sql = 'update users set email_confirm = ? where id = ? limit 1';
			$sth = \db::$pdo->prepare($sql);
			return $sth->execute([$email_confirm, $this->user_id]);
		}
		
		// получить код подтверждения
		public function get_email_confirm_code()
		{
			$sql = 'select email_confirm_code from users where id = ? limit 1';
			$sth = \db::$pdo->prepare($sql);
			$sth->execute([$this->user_id]);
			return $sth->fetchColumn();
		}
		
		public function set_email_confirm_code($email_confirm_code)
		{
			$sql = 'update users set email_confirm_code = ? where id = ? limit 1';
			$sth = \db::$pdo->prepare($sql);
			return $sth->execute([$email_confirm_code, $this->user_id]);
		}
		
		// искать email
		public static function search_email($email)
		{
			$sql = 'select email from users where email = ? limit 1';
			$sth = \db::$pdo->prepare($sql);
			$sth->execute([$email]);
			if ($sth->fetchColumn()) {
				return true;
			} return false;
		}
		
		// получить id игрока по логину
		public static function get_id_by_login($login)
		{
			$sql = 'select id from users where login = ? limit 1';
			$sth = \db::$pdo->prepare($sql);
			$sth->execute([$login]);
			return $sth->fetchColumn();
		}
		
		// получить id игрока по мылу
		public static function get_id_by_email($email)
		{
			$sql = 'select id from users where email = ? limit 1';
			$sth = \db::$pdo->prepare($sql);
			$sth->execute([$email]);
			return $sth->fetchColumn();
		}
	}
}