<?php

namespace indrat
{
	class user_online extends \_tbl_line
	{
		protected static $table = 'users_online';
		
		public static function count()
		{
			$delay = time() - \online::ONLINE_DELAY_SECONDS;
			return self::get('count(*)', "where time >= $delay");
		}
		
		public static function not_clan_count()
		{
			$delay = time() - \online::ONLINE_DELAY_SECONDS;
			$sql = 'select count(*) from '. self::$table . " uo where (select cp.id_user from clan_part cp where cp.id_user = uo.id_user limit 1) is null and uo.time >= $delay limit 1";
			$sth = \db::$pdo->query($sql);
			return $sth->fetch(\PDO::FETCH_NUM)[0];
		}
		
		public static function time_get($user_id = false)
		{
			user_id($user_id);
			return self::get('time', 'where id_user = ?', [$user_id]);
		}
		
		public static function time_set($time = false, $user_id = false)
		{
			user_id($user_id);
			if ($time === false) $time = time();
			self::set('time = ?', 'where id_user = ?', [$time, $user_id]);
		}
		
		public static function time_day_get($user_id = false)
		{
			user_id($user_id);
			return self::get('time_day', 'where id_user = ?', [$user_id]);
		}
		
		public static function time_day_set($time = false, $user_id = false)
		{
			user_id($user_id);
			if ($time === false) $time = time();
			self::set('time_day = ?', 'where id_user = ?', [$time, $user_id]);
		}
		
		public static function is_online($user_id)
		{
			$delay = time() - \online::ONLINE_DELAY_SECONDS;
			if (self::get('count(*)', "where id_user = ? and time >= $delay", [$user_id]) > 0) {
				return true;
			} return false;
		}
	}
}

namespace
{
	class user_online extends \indrat\user_online
	{
		public static function time_ctrl($user_id = false)
		{
			user_id($user_id);
			self::time_set(false, $user_id);
		}
		
		public static function time_day_ctrl($user_id = false)
		{
			user_id($user_id);
			$time_day = self::time_day_get($user_id);
			if (day_new($time_day)) {
				$days_last = last_days($time_day);
				self::time_day_set(false, $user_id);
				return $days_last;
			} return false;
		}
	}
	
	class online
	{
		const ONLINE_DELAY_SECONDS = 3600; // задержка онлайна
	}
	
	class online_model
	{
		public function online($args)
		{
			$type = $args['type'];
			if ($type == 'online') {
				$res = $this->users_online_get();
			}
			elseif ($type == 'clan_not') {
				$res = $this->users_not_clan_get();
			}
			return [
				'type' => $type,
				'pag' => $res['pag'],
				'online' => $res['online']
			];
		}
		
		public function users_online_get()
		{
			$delay = time() - online::ONLINE_DELAY_SECONDS;
			$pag = new pagination;
			$limit = $pag->start(indrat\user_online::count(), 10);
			$sql = "select uo.id_user, (select u.login from users u where u.id = uo.id_user limit 1) as login, (select health + power + agil + intell from users_combat uc where uc.id_user = uo.id_user) as param_sum from users_online uo where uo.time >= $delay order by param_sum desc limit $limit[start], $limit[limit]";
			$sth = db::$pdo->query($sql);
			$online = $sth->fetchAll(PDO::FETCH_ASSOC);
			foreach ($online as $key => $val) {
				$online[$key]['turtle_icon'] = html::turtle_icon_get($val['id_user']);
			}
			return [
				'pag' => $pag,
				'online' => $online
			];
		}
		
		public function users_not_clan_get()
		{
			$delay = time() - online::ONLINE_DELAY_SECONDS;
			$pag = new pagination;
			$limit = $pag->start(indrat\user_online::not_clan_count(), 10);
			$sql = "select uo.id_user, (select u.login from users u where u.id = uo.id_user limit 1) as login, (select health + power + agil + intell from users_combat uc where uc.id_user = uo.id_user) as param_sum from users_online uo where (select cp.id_user from clan_part cp where cp.id_user = uo.id_user limit 1) is null and uo.time >= $delay order by param_sum desc limit $limit[start], $limit[limit]";
			$sth = db::$pdo->query($sql);
			$online = $sth->fetchAll(PDO::FETCH_ASSOC);
			foreach ($online as $key => $val) {
				$online[$key]['turtle_icon'] = html::turtle_icon_get($val['id_user']);
			}
			return [
				'pag' => $pag,
				'online' => $online
			];
		}
	}
}