<?php

namespace db;

class users_battle extends \_tbl_line
{
	protected static $table = 'users_battle';
	
	public static function hit_status_get($user_id)
	{
		return self::get('hit_status', 'where id_user = ?', [$user_id]);
	}
	
	public static function hit_status_set($status, $user_id)
	{
		return self::set('hit_status = ?', 'where id_user = ?', [$status, $user_id]);
	}
	
	public static function dodge_status_get($user_id)
	{
		return self::get('dodge_status', 'where id_user = ?', [$user_id]);
	}
	
	public static function dodge_status_set($status, $user_id)
	{
		return self::set('dodge_status = ?', 'where id_user = ?', [$status, $user_id]);
	}
	
	public static function change_status_get($user_id)
	{
		return self::get('change_status', 'where id_user = ?', [$user_id]);
	}
	
	public static function change_status_set($status, $user_id)
	{
		return self::set('change_status = ?', 'where id_user = ?', [$status, $user_id]);
	}
	
	public static function hit_status_timestamp_get($user_id)
	{
		return self::get('hit_status_timestamp', 'where id_user = ?', [$user_id]);
	}
	
	public static function hit_status_timestamp_set($user_id, $time = false)
	{
		if ($time === false) $time = time();
		return self::set('hit_status_timestamp = ?', 'where id_user = ?', [$time, $user_id]);
	}
	
	public static function dodge_status_timestamp_get($user_id)
	{
		return self::get('dodge_status_timestamp', 'where id_user = ?', [$user_id]);
	}
	
	public static function dodge_status_timestamp_set($user_id, $time = false)
	{
		if ($time === false) $time = time();
		return self::set('dodge_status_timestamp = ?', 'where id_user = ?', [$time, $user_id]);
	}
	
	public static function change_status_timestamp_get($user_id)
	{
		return self::get('change_status_timestamp', 'where id_user = ?', [$user_id]);
	}
	
	public static function change_status_timestamp_set($user_id, $time = false)
	{
		if ($time === false) $time = time();
		return self::set('change_status_timestamp = ?', 'where id_user = ?', [$time, $user_id]);
	}
}

namespace battle;

class action
{
	const HIT_STATUS_ACTIVE = 1;
	const HIT_STATUS_INACTIVE = 2;
	const DODGE_STATUS_ACTIVE = 1;
	const DODGE_STATUS_INACTIVE = 2;
	const CHANGE_STATUS_ACTIVE = 1;
	const CHANGE_STATUS_INACTIVE = 2;
	
	//   
	public static function av_hit($user_id)
	{
		if (\db\users_battle::hit_status_get($user_id) == self::HIT_STATUS_ACTIVE) {
			return true;
		} return false;
	}
	
	//   
	public static function av_dodge($user_id)
	{
		if (\db\users_battle::dodge_status_get($user_id) == self::DODGE_STATUS_ACTIVE) {
			return true;
		} return false;
	}
	
	//    
	public static function av_change($user_id)
	{
		if (\db\users_battle::change_status_get($user_id) == self::CHANGE_STATUS_ACTIVE) {
			return true;
		} return false;
	}
	
	//  
	public static function hit_act($user_id)
	{
		\db\users_battle::hit_status_set(self::HIT_STATUS_INACTIVE, $user_id);
		\db\users_battle::hit_status_timestamp_set($user_id);
	}
	
	//  
	public static function dodge_act($user_id)
	{
		\db\users_battle::dodge_status_set(self::DODGE_STATUS_INACTIVE, $user_id);
		\db\users_battle::dodge_status_timestamp_set($user_id);
	}
	
	//   
	public static function change_act($user_id)
	{
		\db\users_battle::change_status_set(self::CHANGE_STATUS_INACTIVE, $user_id);
		\db\users_battle::change_status_timestamp_set($user_id);
	}
	
	//  
	public static function hit_recovery($user_id)
	{
		if (\db\users_battle::hit_status_get($user_id) == self::HIT_STATUS_ACTIVE) {
			return;
		}
		if ( ! self::hit_recovery_is_gone($user_id)) {
			return;
		}
		\db\users_battle::hit_status_set(self::HIT_STATUS_ACTIVE, $user_id);
	}
	
	//  
	public static function dodge_recovery($user_id)
	{
		if (\db\users_battle::dodge_status_get($user_id) == self::DODGE_STATUS_ACTIVE) {
			return;
		}
		if ( ! self::dodge_recovery_is_gone($user_id)) {
			return;
		}
		\db\users_battle::dodge_status_set(self::DODGE_STATUS_ACTIVE, $user_id);
	}
	
	//   
	public static function change_recovery($user_id)
	{
		if (\db\users_battle::change_status_get($user_id) == self::CHANGE_STATUS_ACTIVE) {
			return;
		}
		if ( ! self::change_recovery_is_gone($user_id)) {
			return;
		}
		\db\users_battle::change_status_set(self::CHANGE_STATUS_ACTIVE, $user_id);
	}
	
	//   
	public static function hit_time_recovery_generate($user_id)
	{
		return \game::PVP_HIT_DELAY;
	}
	
	//   
	public static function dodge_time_recovery_generate($user_id)
	{
		return \game::PVP_DODGE_DELAY;
	}
	
	//    
	public static function change_time_recovery_generate($user_id)
	{
		return \game::PVP_CHANGE_DELAY;
	}
	
	//     
	public static function hit_recovery_seconds_left($user_id)
	{
		return \db\users_battle::hit_status_timestamp_get($user_id) + self::hit_time_recovery_generate($user_id) - time();
	}
	
	//     
	public static function dodge_recovery_seconds_left($user_id)
	{
		return \db\users_battle::dodge_status_timestamp_get($user_id) + self::dodge_time_recovery_generate($user_id) - time();
	}
	
	//      
	public static function change_recovery_seconds_left($user_id)
	{
		return \db\users_battle::change_status_timestamp_get($user_id) + self::change_time_recovery_generate($user_id) - time();
	}
	
	//     
	public static function hit_recovery_is_gone($user_id)
	{
		if (self::hit_recovery_seconds_left($user_id) < 1) {
			return true;
		} return false;
	}
	
	//     
	public static function dodge_recovery_is_gone($user_id)
	{
		if (self::dodge_recovery_seconds_left($user_id) < 1) {
			return true;
		} return false;
	}
	
	//      
	public static function change_recovery_is_gone($user_id)
	{
		if (self::change_recovery_seconds_left($user_id) < 1) {
			return true;
		} return false;
	}
}