<?php

/* компенсация для игрока */
class compensation
{
	public
		$whom_user_id = false, // кому компенсирует
		$who_user_id = false, // кто компенсирует
		$type = false,
		$num = false;
	
	public function __construct($who_user_id, $type, $num)
	{
		if ($who_user_id < 1) return;
		if ( ! \user::is_user($who_user_id)) return;
		if (\user::position_get($who_user_id) < 3) return;
		
		$type_perhaps = ['mutagen', 'pancers', 'bucks', 'metal'];
		if ( ! in_array($type, $type_perhaps)) return;
		if ($num < 1 || $num > 9999999999999999999) return;
		$this->who_user_id = $who_user_id;
		$this->type = $type;
		$this->num = $num;
	}
	
	/* отправить игроку */
	public function send_user($whom_user_id)
	{
		if ($whom_user_id < 1) return;
		if ( ! \user::is_user($whom_user_id)) return;
		
		$who_user_id = $this->who_user_id; $type = $this->type; $num = $this->num;
		if ( ! $who_user_id || ! $type || ! $num) return;
		
		$method = "{$type}_add";
		$currency = new \currency($whom_user_id);
		$currency->notf = false;
		$currency->bonuses = false;
		$currency->base = $num;
		$currency->$method();
		
		$type_rus = ['mutagen' => 'Мутаген', 'pancers' => 'Панцири', 'bucks' => 'Баксы', 'metal' => 'Металлолом'];
		$jtitle = 'Вам подарок от Администратора';
		$jtext = '%s: <b class="%s-color">%s</b>';
		$jtext = sprintf($jtext, $type_rus[$type], $type, number_format($num));
		\journal::record_add(['title' => $jtitle, 'text' => $jtext], $whom_user_id);
		
		\notf::$user_id = $who_user_id;
		\notf::set_notf('Ресурсы отправлены.', 'default');
		\notf::reset();
	}
	
	/* всем игрокам */
	public function send($title)
	{
		$who_user_id = $this->who_user_id; $type = $this->type; $num = $this->num;
		if ( ! $who_user_id || ! $type || ! $num) return;
		
		\notf::$user_id = $who_user_id;
		$title_len = mb_strlen($title);
		if ($title_len < 1 || $title_len > 200) {
			\notf::set_notf('Заголовок не соответствующей длины.', 'error');
			return;
		}
		
		$sql = 'insert into compensation set title = ?, mutagen = ?';
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([$title, $num]);
		\notf::set_notf('Успешно.', 'default');
		\notf::reset();
	}
	
	/* true если компенсация есть, иначе false */
	public static function is_exist()
	{
		$sth = \db::$pdo->query('select count(*) from compensation limit 1');
		if ($sth->fetchColumn() > 0) return true;
		return false;
	}
	
	/* получить самую первую компенсацию которую может собрать игрок 
	 вернет данные компенсации или false если такой компенсации нет
	*/
	public static function get_first($user_id)
	{
		if ( ! self::is_exist()) return false;
		$user_last_compensation_id = self::get_user_last_id_compensation($user_id);
		if (is_null($user_last_compensation_id)) {
			$sql = 'select * from compensation order by id asc limit 1';
			$sth = \db::$pdo->query($sql);
		} else {
			$sql = 'select * from compensation where id > ? order by id asc limit 1';
			$sth = \db::$pdo->prepare($sql);
			$sth->execute([$user_last_compensation_id]);
		}
		$obj = $sth->fetch(\PDO::FETCH_OBJ);
		if (is_object($obj)) return $obj;
		return false;
	}
	
	/* получить последнюю акцию 
	 вернет данные компенсации или false если такой компенсации нет
	*/
	public static function get_last()
	{
		if ( ! self::is_exist()) return false;
		$sql = 'select * from compensation order by id desc limit 1';
		$sth = \db::$pdo->query($sql);
		return $sth->fetch(\PDO::FETCH_OBJ);
	}
	
	/* получить id последней компенсации которую собирал игрок */
	public static function get_user_last_id_compensation($user_id)
	{
		$sql = 'select id_compensation_last from users where id = ? limit 1';
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([$user_id]);
		return $sth->fetchColumn();
	}
	
	/* записать id последней компенсации которую собирал игрок */
	public static function set_user_last_id_compensation($user_id, $last_id_compensation)
	{
		$sql = 'update users set id_compensation_last = ? where id = ? limit 1';
		$sth = \db::$pdo->prepare($sql);
		return $sth->execute([$last_id_compensation, $user_id]);
	}
}

class compensation_gather
{
	public $user_id;
	
	public function __construct($user_id)
	{
		$this->user_id = $user_id;
	}
	
	public function gather()
	{
		$user_id = $this->user_id;
		$compensation = \compensation::get_first($user_id);
		if ($compensation === false) return;
		
		$currency = new \currency($user_id);
		$currency->bonuses = false;
		$currency->base = $compensation->mutagen;
		$currency->mutagen_add();
		
		\compensation::set_user_last_id_compensation($user_id, $compensation->id);
	}
}

class compensation_delete
{
	public $user_id; // кто удаляет
	
	public function __construct($user_id)
	{
		$this->user_id = $user_id;
	}
	
	public function delete()
	{
		$user_id = $this->user_id;
		if (\user::position_get($user_id) < 3) return;
		\db::$pdo->exec('delete from compensation');
		\notf::$user_id = $user_id;
		\notf::set_notf('Компенсации удалены.', 'default');
		\notf::reset();
	}
}