<?php
class_alias('pagin', 'pagination');
class pagin
{
	public $total; // максимальное количество страниц
	public $var_page_name = 'p'; // название get-переменной в которой хранится номер страницы
	public $page_default; // страница по умолчанию
	protected $page = 1; // текущая страница
	protected $lines = 10; // количество строк на одной странице
	protected $left_limit = 1;
	protected $right_limit = 2;
	
	public function get_page()
	{
		return $this->page;
	}
	
	/**
	 * $quant - общее колво записей
	 * $lines - колво строк на одной странице
	 * возвращает готовый запрос
	 */
	public function start($quant, $lines = false)
	{
		if ($lines) {
			$this->lines = $lines;
		}
		
		// исходя из количества строк в базе
		// вычисляем общее кол-во страниц
		$this->total = intval(($quant - 1) / $this->lines) + 1;
		
		$options = [
			'options' => [
				'min_range' => 1,
				'max_range' => $this->total
			],
			'flags' => FILTER_FLAG_ALLOW_OCTAL,
		];
		$page = filter_input(INPUT_GET, $this->var_page_name, FILTER_VALIDATE_INT, $options);
		
		if ($this->page_default and $this->page_default >= 1 && $this->page_default <= $this->total and ! $page) {
			$page = $this->page_default;
		}
		$page = ($page < 1) ? 1 : $page;
		$this->page = $page;
		
		$start = ($this->lines * $this->page) - $this->lines;
		
		return [
			'start' => $start,
			'limit' => $this->lines
		];
	}
	
	
	public function counter($i)
	{
		$ready = $this->page * $this->lines;
		
		return $ready + $i - $this->lines;
	}
	
	
	public function nav()
	{
		$back = [];
		$go	= [];
		
		for ($i = 1; $i <= $this->left_limit; $i++) {
			
			if ($this->page - $i >= 1) {
				
				$back[] = $this->page - $i;
			}
		}
		
		for ($i = 1; $i <= $this->right_limit; $i++) {
			
			if ($this->page + $i <= $this->total) {
				
				$go[] = $this->page + $i;
			}
		}
		
		
		$arr	 = array_merge($back, $go);
		$arr[] = $this->page;
		
		asort($arr);

		return $arr;
	}
	
	
	public function last_page()
	{
		if (($this->page + $this->right_limit) < $this->total) {
			
			return $this->total;
			
		}
		
		return false;
	}
	
	
	public function first_page()
	{
		if (($this->page - $this->left_limit) > 1) {
			
			return 1;
		}
		
		return false;
	}
	
	
	public function get_page_objective_record($place)
	{
		return (int) round($place / $this->lines);
	}

}