<?php

/* класс для форматирования секунд в другие единицы времени */
// метод принимает в какие единицы времени должны форматироваться секнды, при этом можно будет выбирать любые сочетания типов единиц
/* 
если больше года, то показывать годы, месяцы и дни,
если месяцы, то показывать месяцы и дни
если дни, то показывать дни и часы,
если часы, то показывать часы и минуты,
если минуты, то показывать только минуты
если меньше 5 минут, то показывать минуты и секунды */
class seconds
{
	public $seconds;
	
	public function __construct($seconds)
	{
		$this->seconds = $seconds;
	}
	
	public function format()
	{
		$seconds = $this->seconds;
		$time = [
			'years'			=> 0,
			'months'			=> 0,
			'days'			=> 0,
			'hours'			=> 0,
			'minutes'		=> 0,
			'seconds'		=> intval($seconds % 60)
		];
		
		if ($seconds < 60) {
			return $time;
		}
		$time['minutes'] = intval($seconds % 3600 / 60);
		if ($seconds / 60 < 60) {
			return $time;
		}
		$time['hours'] = intval($seconds % 86400 / 3600);
		if ($seconds / 3600 < 24) {
			return $time;
		}
		$time['days'] = intval($seconds % (86400 * 30) / 86400);
		if ($seconds / 86400 < 30) {
			return $time;
		}
		$time['months'] = intval($seconds % (86400 * 360) / (86400 * 30));
		if ($seconds / (86400 * 30) < 12) {
			return $time;
		}
		$time['years'] = intval($seconds / (86400 * 360));
		return $time;
	}
}