<?php

class _tbl_line
{
	protected static $table; // таблица с которой работает данный класс
	
	public static function id(&$id)
	{
		if ($id === false) {
			$id = ID;
		} return $id;
	}
	
	// достать значение из бд
	// в параметре field, после записи нужных названий полей ставится двоеточие чтобы указать тип выборки PDO (FETCH_BOTH, FETCH_NUM, FETCH_ASSOC), если это не указано вернет только один столбей (самый первый) fetch(PDO::FETCH_NUM)[0]
	// sql2lot - это второй участок sql запроса т.е. всё что после from (limit добавляется автоматически, со значением 1)
	public static function get($field, $sql2lot = '', $alias_array = [])
	{
		$div = explode(':', $field);
		$field = $div[0];
		$fetch_type = (isset($div[1])) ? trim($div[1]) : '';
		$sql = 'select %s from %s %s %s';
		if (is_array($sql2lot)) {
			$sql = sprintf($sql, $field, static::$table, $sql2lot[0], $sql2lot[1]);
		}
		else { // is_string
			$sql = sprintf($sql, $field, static::$table, $sql2lot, 'limit 1');
		}
		$sth = db::$pdo->prepare($sql);
		$sth->execute($alias_array);
		if ($fetch_type == '') {
			return $sth->fetch(PDO::FETCH_NUM)[0];
		}
		if (strcasecmp($fetch_type, 'assoc') == 0) {
			return $sth->fetch(PDO::FETCH_ASSOC);
		}
		if (strcasecmp($fetch_type, 'num') == 0) {
			return $sth->fetch(PDO::FETCH_NUM);
		}
		if (strcasecmp($fetch_type, 'both') == 0) {
			return $sth->fetch(PDO::FETCH_BOTH);
		}
		if (strcasecmp($fetch_type, 'obj') == 0) {
			return $sth->fetch(PDO::FETCH_OBJ);
		}
		if (strcasecmp($fetch_type, 'keypair') == 0) {
			return $sth->fetch(PDO::FETCH_KEY_PAIR);
		}
	}
	
	public static function all_get($field, $sql2lot = '', $alias_array = [])
	{
		$div = explode(':', $field);
		$field = $div[0];
		$fetch_type = (isset($div[1])) ? trim($div[1]) : '';
		$sql = 'select %s from %s %s %s';
		if (is_array($sql2lot)) {
			$sql = sprintf($sql, $field, static::$table, $sql2lot[0], $sql2lot[1]);
		}
		else { // is_string
			$sql = sprintf($sql, $field, static::$table, $sql2lot, 'limit 1');
		}
		$sth = db::$pdo->prepare($sql);
		$sth->execute($alias_array);
		if ($fetch_type == '') {
			return $sth->fetchAll(PDO::FETCH_NUM);
		}
		if (strcasecmp($fetch_type, 'assoc') == 0) {
			return $sth->fetchAll(PDO::FETCH_ASSOC);
		}
		if (strcasecmp($fetch_type, 'num') == 0) {
			return $sth->fetchAll(PDO::FETCH_NUM);
		}
		if (strcasecmp($fetch_type, 'both') == 0) {
			return $sth->fetchAll(PDO::FETCH_BOTH);
		}
		if (strcasecmp($fetch_type, 'obj') == 0) {
			return $sth->fetchAll(PDO::FETCH_OBJ);
		}
		if (strcasecmp($fetch_type, 'keypair') == 0) {
			return $sth->fetchAll(PDO::FETCH_KEY_PAIR);
		}
	}
	
	// установка значения в бд
	public static function set($field, $sql2lot = '', $alias_array = [])
	{
		$sql = 'update %s set %s %s %s';
		if (is_array($sql2lot)) {
			$sql = sprintf($sql, static::$table, $field, $sql2lot[0], $sql2lot[1]);
		}
		else { // is_string
			$sql = sprintf($sql, static::$table, $field, $sql2lot, 'limit 1');
		}
		$sth = db::$pdo->prepare($sql);
		return $sth->execute($alias_array);
	}
	
	// добавление записи в бд
	// возвращение последнего id
	public static function add($field, $alias_array = [])
	{
		$sql = 'insert into %s set %s';
		$sql = sprintf($sql, static::$table, $field);
		$sth = db::$pdo->prepare($sql);
		$sth->execute($alias_array);
		return db::$pdo->lastInsertId();
	}
}