<?php
/* ========================= = |
 * ядро проекта
 * ========================= = */

require ROOT . 'project/internal/box/inclusion.box.php';

session_start();
register_shutdown_function(function () {
	url_in_session::set(); // установка url в сессию на каждой странице где это дозволено (url_in_session::$ban = true; отменяет такое поведение), нужно для того, чтобы знать с какой страницы пришёл пользователь (в пределах сайта)
});
define('PAGE_NAME', page_name());

class db
{
	public static $pdo;
	public static function connect()
	{
		// конфиг. базы данных для локалки
		$connect_design = [
			'dsn' => 'mysql:dbname=turtles;host=localhost;charset=utf8',
			'user' => 'root',
			'password' => '',
			'options' => [
				PDO::ATTR_ERRMODE => PDO::ERRMODE_WARNING
			]
		];
		
		// конфиг. базы данных для хоста
		$connect_game = [
			'dsn' => 'mysql:dbname=client550_turtles;host=4ba.ru;charset=utf8',
			'user' => 'client550_selexan',
			'password' => 'Selexan3531.zero',
			'options' => []
		];
		$connect = (DESIGN) ? $connect_design : $connect_game;
		try {
			self::$pdo = new PDO($connect['dsn'], $connect['user'], $connect['password'], $connect['options']);
		} catch (PDOException $e) {
			die('Ошибка подключения к Базе Данных.');
		}
	}
}
db::connect();
db::$pdo->exec("set names utf8");
db::$pdo->exec("set character set utf8");
db::$pdo->exec("set session collation_connection = utf8_general_ci");

/**
 * url в сессию
 */
if (empty($_SESSION['url'])) { // если url в сессии нету
	url_in_session::set(subord_url('home')); // установка
}

/**
 * тех. работы
 */
if (ENG_WORKS) { // игра в инженерном режиме
	if (PAGE_NAME != 'migration' && PAGE_NAME != 'eng_works') {
		redirect::go()->subord('eng_works');
	} else {
		return;
	}
}
elseif (PAGE_NAME == 'migration' || PAGE_NAME == 'eng_works')  { // игра не в инженерном режиме и пользователь пытается получить доступ к файлу миграции или к странице с закрытым доступом
	redirect_return();
}

/**
 * авто-аутентификация
 */
if ( ! isset($_SESSION['id']) && token_correct()) { // пользователя в сессии не существует и в куках присутствует id и пароль пользователя)
	$_SESSION['id'] = $_COOKIE['id']; // запись в сессию id (т.е. выдача доступа пользователю к сайту)
	auto_authn($_COOKIE['id']);
}

$not_auth_pages = package('not-auth-pages');
if ( ! isset($_SESSION['id']) && ! in_array(PAGE_NAME, $not_auth_pages)) { // если массив с сессиями пуст и если запрашиваемая страница недоступна неавторизированному пользователю (в массиве $not_auth_pages хранятся все доступные страницы для таких пользователей)
	redirect::go()->subord('start'); // выкидываем на страницу авторизации
}
elseif (isset($_SESSION['id'])) {
	$auth_pages_locked = package('auth-pages-locked'); // страницы которые недоступны авторизированному пользователю
	if (in_array(PAGE_NAME, $auth_pages_locked)) { // если текущая, запрашиваемая страница находится в списке запрещенных для авторизированных пользователей
		redirect_return();
	}
	
	define('ID', $_SESSION['id']);
	user_online::time_ctrl(ID); // установка нового времени после каждого обновления страницы
	
	if (page_name() != 'ban_character' and (db\users_ban::ban_isset(ID) && db\users_ban::ban_type_get(ID) == 2)) {
		redirect::go()->subord('ban_character');
	}
	
	user_level::up_ctrl(ID); // контроллер уровня игрока
	ml1::ctrl_battle_status(); // контроллер статуса в разборках
	ml1::ctrl_reward(); // контроллер награды в разборках
	cl1::clans_reward();
	
	/* истечение акции */
	$stock = new stock\stock();
	$stock->expire();
	
	/* истечение времени жизни приглашения в канализацию */
	$ilte = new ml2\invite_life_time_ending;
	$ilte->user_id = ID;
	$ilte->execute();
	
	/* истечение премиума */
	$prem_expiration = new premium\expiration;
	$prem_expiration->user_id = ID;
	$prem_expiration->expires();
	
	/* если игрок в клане */
	if (clan::is_user_clan(ID)) {
		$clan_id = clan::get_id_clan_by_id_user(ID);

		/* произвести еженедельную чистку кланового рейтинга (статистики)
		выполняться должен именно здесь!
		todo: поставить на крон, когда будет возможность... */
		$cr = new clan_rating;
		$cr->clan_id = $clan_id;
		$cr->week_reset();
	}
	
	/* принятие приглашения в команду */
	if ( ! is_null(filter_input(INPUT_GET, 'command_accept'))) {
		$invite_accept = new ml2\invite_accept;
		$invite_accept->user_id = ID;
		if ($invite_accept->execute()) {
			redirect::go()->subord('ml2_command');
		}
		redirect::go()->ruler_cut(['command_accept']);
	}
	/* отклоненение приглашения в команду */
	if ( ! is_null(filter_input(INPUT_GET, 'command_reject'))) {
		$invite_reject = new ml2\invite_reject;
		$invite_reject->user_id = ID;
		$invite_reject->execute();
		redirect::go()->ruler_cut(['command_reject']);
	}
}