<?php

/* function design()
{
	$design = 'yura';
	$perhaps = design_perhaps();
	$design_select = filter_input(INPUT_COOKIE, 'design');
	if (in_array($design_select, $perhaps)) {
		$design = $design_select;
	} return $design;
}

function design_perhaps()
{
	return ['yura'];
} */

function get_screen_width()
{
	if ( ! isset($_SESSION['screen_width'])) {
		return null;
	} return $_SESSION['screen_width'];
}

// загрузка файла вида
function view($view, $data = [])
{
	extract($data);
	require ROOT . "project/view/$view.view.php";
}

// загрузка пакета
// package - название пакета в директории project/internal/packages
// пакеты имеют дополнительное расширение .pack чтоб их легче было идентифицировать
function package($package)
{
	return require ROOT . "project/internal/packages/$package.pack.php";
}

// загрузка данных
// все данные имеют расширение trl (от turtle), его указывать не нужно используя данную функцию
// если unserialize true, то всё содержимое файла перед возвращением десериализируется
function data_get($data, $unserialize = false)
{
	$content = file_get_contents(ROOT . "project/internal/data/$data.trl");
	if ($unserialize === true) {
		$content = unserialize($content);
	}
	return $content;
}

function data_set($data, $content, $serialize = false)
{
	if ($serialize === true) {
		$content = serialize($content);
	}
	file_put_contents(ROOT . "project/internal/data/$data.trl", $content);
}

// записать полный url в сессию
class url_in_session
{
	static $ban = false;
	
	public static function set($url = false)
	{
		if (self::$ban === true) {
			return false;
		}
		if ($url === false) {
			$url = get_url();
		}
		$_SESSION['url'] = $url;
	}
}

// функция возвращает пользователя на предидущую страницу, при этом делает это безопасно
function redirect_return($url = false, $return = false)
{
	if ($url === false) {
		$url = $_SESSION['url'];
	}
	if ($url == get_url()) { // если url-адресс такой же какой и у страницы на которой находится пользователь
		if ($return === false) {
			$return = 'home';
		}
		redirect::go()->subord('home');
	}
	redirect($url);
}

// пронумеровать вложенный массив (добавить в каждый вложенный массив номер, начиная с 1)
function array_renumber(&$array)
{
	$a = $array;
	$i = 1;
	foreach ($a as $key => $val) {
		$array[$key]['_num'] = $i++;
	}
	return $array;
}

// убрать знаковые или безнаковые значение из массива
// если sign false, то отбросит все безнаковые числа, иначе знаковые
function array_num_filter(&$array, $sign = true)
{
	if ($sign) {
		$a = function ($elm) {
			if ($elm >= 0) {
				return true;
			}
		};
	}
	else {
		$a = function ($elm) {
			if ($elm < 0) {
				return true;
			}
		};
	}
	$array = array_filter($array, $a);
	return $array;
}

// ищет значение определенного типа в массиве и в случае успеха возвращает true else false
/** type:"boolean" 
◦  "integer"
◦  "double"  
◦  "string" 
◦  "array" 
◦  "object"  
◦  "null" **/

function in_array_type($array, $type)
{
	if ($type == 'integer') {
		$a = function ($elm) {
			if (gettype($elm) == 'integer') {
				return true;
			}
		};
	}
	elseif ($type == 'boolean') {
		$a = function ($elm) {
			if (gettype($elm) == 'boolean') {
				return true;
			}
		};
	}
	elseif ($type == 'double') {
		$a = function ($elm) {
			if (gettype($elm) == 'double') {
				return true;
			}
		};
	}
	elseif ($type == 'string') {
		$a = function ($elm) {
			if (gettype($elm) == 'string') {
				return true;
			}
		};
	}
	elseif ($type == 'array') {
		$a = function ($elm) {
			if (gettype($elm) == 'array') {
				return true;
			}
		};
	}
	elseif ($type == 'object') {
		$a = function ($elm) {
			if (gettype($elm) == 'object') {
				return true;
			}
		};
	}
	elseif ($type == 'NULL') {
		$a = function ($elm) {
			if (gettype($elm) == 'NULL') {
				return true;
			}
		};
	}
	
	$af = array_filter($array, $a);
	if ( ! empty($af)) {
		return true;
	}
	return false;
}


// выдернуть из автоматически нумерованного массива элементы в определенном диапазоне (например выдернуть из массива все элементы с ключами от 5, до 10)
// аргумент range - массив которым принимает начиная с какого ключа вырезать и по какой
function array_pullout($array, $range)
{
	return array_slice($array, $range[0], $range[1]);
	$t = [];
	foreach ($array as $key => $val) {
		if ($key >= $range[0]) {
			$t[] = $val;
		}
	}
	return $t;
}

/////////////////////////
///base
/////////////////////////

// русские папаметры
// псевдоним
function param_trans($param = false)
{
	return translate::param_name($param);
}

// русские папаметры "какой"
// псевдоним
function param_trans_what($param = false)
{
	return translate::param_name_what($param);
}

// основной бонус черепашки
function turtle_bonus($turtle)
{
	$t = [
		'leo' => 'power',
		'raf' => 'health',
		'miki' => 'agil',
		'doni' => 'intell'
	];
	return $t[$turtle];
}

// основной бонус черепашки в %
function turtle_bonus_num($turtle)
{
	$t = [
		'leo' => 10,
		'raf' => 10,
		'miki' => 10,
		'doni' => 10
	];
	return $t[$turtle];
}

// размер бонуса черепашки в процентах по её особенности
function turtle_bonus_num_by_feature($feature)
{
	$f = [
		'health' => 10,
		'power' => 10,
		'agil' => 10,
		'intell' => 10
	];
	return $f[$feature];
}

// начальные параметры
function start_param()
{
	return [
		'health' => 100,
		'power' => 100,
		'agil' => 100,
		'intell' => 100
	];
}


// здоровье игрока в соответствии с его характеристиками
// псевдоним
function get_user_combat_health($id_user)
{
	return uc::get_user_combat_health($id_user);
}

// урон игрока в соответствии с его характеристиками
// псевдоним
function get_user_combat_damage($id_user)
{
	return uc::get_user_combat_damage($id_user);
}

/////////////////////////
///users
/////////////////////////

// логин по id (синоним user::login_get())
function get_username_by_id($id_user = false)
{
	return user::login_get($id_user);
}

// пароль по id
function get_userpassword_by_id($id_user)
{
	$sql = 'select password from users where id = ? limit 1';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$id_user]);
	return $sth->fetch(PDO::FETCH_NUM)[0];
}

// баксы по id
// псевдоним user_currency_indrat::get_bucks()
function get_bucks_by_id($id_user = false)
{
	return ucuri::get_bucks($id_user);
}

// мутаген по id
// псевдоним user_currency_indrat::get_mutagen()
function get_mutagen_by_id($id_user = false)
{
	return ucuri::get_mutagen($id_user);
}

// метал по id
// псевдоним user_currency_indrat::get_metal()
function get_metal_by_id($id_user = false)
{
	return ucuri::get_metal($id_user);
}

// панцири по id
// псевдоним user_currency_indrat::get_pancers()
function get_pancers_by_id($id_user)
{
	return ucuri::get_pancers($id_user);
}

// добавить баксы игроку
// псевдоним user_currency::update_bucks()
function set_bucks($bucks, $id_user = false)
{
	user_currency::update_bucks($bucks, $id_user);
}

// добавить мутаген игроку
// псевдоним user_currency::update_mutagen()
function set_mutagen($mutagen, $id_user = false)
{
	user_currency::update_mutagen($mutagen, $id_user);
}

// добавить метал игроку
// псевдоним user_currency::update_metal()
function set_metal($metal, $id_user = false)
{
	user_currency::update_metal($metal, $id_user = false);
}

// добавить панцири игроку
// псевдоним user_currency::update_pancers()
function set_pancers($pancers, $id_user = false)
{
	user_currency::update_pancers($pancers, $id_user);
}

// узнать черепашку по id
function get_turtle_by_id($id_user)
{
	$sql = 'select hero from users where id = ? limit 1';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$id_user]);
	return $sth->fetch(PDO::FETCH_NUM)[0];
}

// записать время последнего обновления страницы пользователю
// псевдоним
function set_time_online($id_user, $time = false)
{
	user_online::time_set($time, $id_user);
}

// узнать бонус черепашки игрока
function get_user_turtle_bonus($id_user)
{
	$t = get_turtle_by_id($id_user);
	return turtle_bonus($t);
}



/////////////////////////
///dyn
/////////////////////////

// достать новые баксы
function get_new_bucks_by_id($id_user)
{
	$sql = 'select new_bucks from users_dyn where id_user = ? limit 1';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$id_user]);
	return $sth->fetch(PDO::FETCH_NUM)[0];
}

// достать новый мутаген
function get_new_mutagen_by_id($id_user)
{
	$sql = 'select new_mutagen from users_dyn where id_user = ? limit 1';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$id_user]);
	return $sth->fetch(PDO::FETCH_NUM)[0];
}

// достать новый метал
function get_new_metal_by_id($id_user)
{
	$sql = 'select new_metal from users_dyn where id_user = ? limit 1';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$id_user]);
	return $sth->fetch(PDO::FETCH_NUM)[0];
}

// достать новые панцири
function get_new_pancers_by_id($id_user)
{
	$sql = 'select new_pancers from users_dyn where id_user = ? limit 1';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$id_user]);
	return $sth->fetch(PDO::FETCH_NUM)[0];
}

// обнулить таблицу users_dyn
function set_to_zero_users_dyn($id_user)
{
	$field = "
		new_exp = default,
		new_bucks = default,
		new_mutagen = default,
		new_metal = default,
		new_pancers = default,
		new_health = default,
		new_power = default,
		new_agil = default,
		new_intell = default,
		result_sweeping = default,
		result_scramble = default,
		result_advent = default,
		scramble_caused_damage = default,
		scramble_received_damage = default,
		card_received = default,
		level_up = default
	";
	$sql = "update users_dyn set $field where id_user = ? limit 1";
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$id_user]);
	$field = "
		battle_result = default
	";
	$sql = "update users_sweeping set $field where id_user = ? limit 1";
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$id_user]);
}

// есть ли новые приглашения в клан
function dyn_is_clan_invite_new($id_user)
{
	$sql = 'select clan_invite from users_dyn where id_user = ? limit 1';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$id_user]);
	if ($sth->fetch(PDO::FETCH_NUM)[0] == 1) {
		return true;
	}
	return false;
}

function dyn_set_to_zero_clan_invite_new($id_user, $set)
{
	$sql = 'update users_dyn set clan_invite = ? where id_user = ? limit 1';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$set, $id_user]);
}

// получить id карточки с поле "получена новая карточка"
function dyn_card_received_get($user_id = false)
{
	user_id($user_id);
	$sql = 'select card_received from users_dyn where id_user = ? limit 1';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$user_id]);
	return $sth->fetch(PDO::FETCH_NUM)[0];
}

// установить id карточки в поле "получена новая карточка"
function dyn_card_received_set($card_id, $user_id = false)
{
	user_id($user_id);
	$sql = 'update users_dyn set card_received = ? where id_user = ? limit 1';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$card_id, $user_id]);
}



function seconds_format($seconds)
{
	$obj_seconds = new seconds($seconds);
	$times = $obj_seconds->format();
	$str = '';
	if ($times['years'] > 0) {
		$str = "$times[years]г.";
		if ($times['months'] > 0) {
			$str .= " $times[months]м.";
		}
		if ($times['days'] > 0) {
			$str .= " $times[days]д.";
		}
		return $str;
	}
	
	if ($times['months'] > 0) {
		$str = "$times[months]м.";
		if ($times['days'] > 0) {
			$str .= " $times[days]д.";
		}
		return $str;
	}
	
	if ($times['days'] > 0) {
		$str = "$times[days]д.";
		if ($times['hours'] > 0) {
			$str .= " $times[hours]ч.";
		}
		return $str;
	}
	
	if ($times['hours'] > 0) {
		$str = "$times[hours]ч.";
		if ($times['minutes'] > 0) {
			$str .= " $times[minutes]мин.";
		}
		return $str;
	}
	
	if ($times['minutes'] > 5) {
		$str = "$times[minutes]мин.";
		return $str;
	}
	elseif ($times['minutes'] > 0) {
		$str = "$times[minutes]мин.";
		if ($times['seconds'] > 0) {
			$str .= " $times[seconds]с.";
		}
		return $str;
	}
	
	if ($times['seconds'] > 0) {
		$str = "$times[seconds]с.";
	}
	return $str;
}

// возвращает id-игрока по-дефолту (т.е. id текущего игрока/запускающего скрипт), если в аргементе 1 указано значение false
function user_id(&$user_id)
{
	if ($user_id === false) {
		$user_id = ID;
	} return $user_id;
}