<?php

namespace model;

class ml2
{
	public function main()
	{
		$user_id = ID;
		$locs = $this->locations_get();
		foreach ($locs as $key => $loc) {
			$locs[$key]['is_open'] = true;
			$locs[$key]['opened_seconds'] = null;
			$locs[$key]['level_need'] = \db\_sewerage::level_need_get($loc['id']);
			$locs[$key]['cards'] = \db\_sewerage::reward_cards_unserialize_get($loc['id']);
			$locs[$key]['exp'] = \db\_sewerage::reward_exp_get($loc['id']);
			$locs[$key]['bucks'] = \db\_sewerage::reward_bucks_get($loc['id']);
			$locs[$key]['metal'] = \db\_sewerage::reward_metal_get($loc['id']);
			
			$temp = [];
			foreach ($locs[$key]['cards'] as $card_id) {
				$temp[] = [
					'id' => $card_id,
					'name' => \cards::card_name_get($card_id)
				];
			}
			$locs[$key]['cards'] = $temp;
			
			if ( ! \db\ml2_locations::is_open($user_id, $loc['id'])) {
				$locs[$key]['is_open'] = false;
				$locs[$key]['opened_seconds'] = \db\ml2_locations::recovery_seconds_left_get($user_id, $loc['id']);
			}
		}
		
		// array_push($locs, $locs[0]);
		
		$user_level = \user::level_get($user_id);
		
		$is_reward = \db\ml2_rewards::is_reward($user_id);
		$reward = null;
		$statsc = null;
		if ($is_reward) {
			$reward_id = \db\ml2_rewards::last_id_get($user_id);
			$reward['cards'] = \db\ml2_rewards::cards_unserialize_get($reward_id);
			$reward['exp'] = \db\ml2_rewards::exp_get($reward_id);
			$reward['bucks'] = \db\ml2_rewards::bucks_get($reward_id);
			$reward['metal'] = \db\ml2_rewards::metal_get($reward_id);
			if ($reward['cards']) {
				$temp = [];
				foreach ($reward['cards'] as $card_id) {
					$temp[] = [
						'id' => $card_id,
						'name' => \indrat\cards::card_name_get($card_id),
						'quality' => \indrat\cards::card_quality_get($card_id)
					];
				}
				$reward['cards'] = $temp;
			}
		}
		
		return [
			'locs' => $locs,
			'user_level' => $user_level,
			'is_reward' => $is_reward,
			'reward' => $reward,
			'statsc' => $statsc
		];
	}
	
	public function command($user_id)
	{
		$part = $this->command_part_get($user_id);
		$is_leader = \db\ml2_commands::is_leader($user_id);
		$command_id = \db\ml2_commands::command_id_get($user_id);
		$seats_num = \db\ml2_commands::seats_num_get($command_id);
		$seats_num_max = \ml2\command::PART_MAX;
		if (\db\ml2_commands::access_get($command_id) == \ml2\command::ACCESS_OPEN) {
			$is_open = true;
		}
		elseif (\db\ml2_commands::access_get($command_id) == \ml2\command::ACCESS_CLOSE) {
			$is_open = false;
		}
		$location_id = \db\ml2_commands::location_id_get($command_id);
		$location_name = \db\_sewerage::name_get($location_id);
		
		$chat = new \ml2\command_chat($command_id);
		$chat = $chat->get_messages();
		
		return [
			'user_id' => $user_id,
			'location_name' => $location_name,
			'part' => $part,
			'is_leader' => $is_leader,
			'seats_num' => $seats_num,
			'seats_num_max' => $seats_num_max,
			'is_open' => $is_open,
			'chat' => $chat
		];
	}
	
	public function battle($user_id)
	{
		$user_battle_id = \db\ml2_part::user_battle_id_by_real_user_id_get($user_id);

		$command_id = \db\ml2_commands::command_id_get($user_id);
		$users = \db\ml2_commands::parts_id_get($command_id);
		$temp = [];
		foreach ($users as $key => $val) {
			$temp[$key]['id'] = $val;
			$temp[$key]['name'] = \user::login_get($val);
			$temp[$key]['health'] = \db\ml2_part::health_get(\db\ml2_part::user_battle_id_by_real_user_id_get($val));
			$temp[$key]['health_max'] = \uc::get_user_combat_health($val);
			$temp[$key]['damage'] = \uc::get_user_combat_damage($val);
		} $users = $temp;
		
		$battle_id = \db\ml2_commands::battle_id_get($command_id);
		$this->enemies_group_get($battle_id);
		
		$target_id = \db\ml2_part::target_get($user_battle_id);
		$enemy_id = \db\ml2_part::part_id_get($target_id);
		$panel_battle = new panel_battle;
		$panel_battle->target_name = \db\_sewerage_enemies::name_get($enemy_id);
		$panel_battle->target_health = \db\ml2_part::health_get($target_id);
		$panel_battle->target_health_max = \db\_sewerage_enemies::health_get($enemy_id);
		$panel_battle->target_damage = \db\ml2_part::damage_get($target_id);
		$panel_battle->user_damage_applied = \db\ml2_part::damage_applied_get($user_battle_id);
		// $panel_battle->hit_access = \battle\action::av_hit($user_id);
		$panel_battle->hit_access = true;
		$panel_battle->dodge_access = \battle\action::av_dodge($user_id);
		$panel_battle->dodge_seconds_left = \battle\action::dodge_recovery_seconds_left($user_id);
		// $panel_battle->change_access = \battle\action::av_change($user_id);
		$panel_battle->change_access = true;
		
		$user_damage_received = \db\ml2_part::damage_received_get($user_battle_id);
		return [
			'user_id' => $user_id,
			'panel_battle' => $panel_battle->get(),
			'users' => $users,
			'enemies' => $this->enemies_group_get($battle_id),
			'user_damage_received' => $user_damage_received
		];
	}
	
	private function locations_get()
	{
		$sql = 'select id, name from _sewerage';
		$sth = \db::$pdo->query($sql);
		return $sth->fetchAll(\PDO::FETCH_ASSOC);
	}
	
	private function command_part_get($user_id)
	{
		$part = \db\ml2_commands::parts_id_get(\db\ml2_commands::command_id_get($user_id));
		$temp = [];
		foreach ($part as $key => $val) {
			$temp[$key]['id'] = $val;
			$temp[$key]['name'] = \user::login_get($val);
			$temp[$key]['health'] = \uc::get_user_combat_health($val);
			$temp[$key]['damage'] = \uc::get_user_combat_damage($val);
		}
		return $temp;
	}
	
	private function enemies_group_get($battle_id)
	{
		$sql = 'select id_part as id_enemy, count(id_part) as num from ml2_part where id_battle = ? and part_type = ? group by id_part';
		$sth = \db::$pdo->prepare($sql);
		$sth->execute([$battle_id, \ml2\battle::PART_TYPE_BOT]);
		$enemies = $sth->fetchAll(\PDO::FETCH_ASSOC);
		foreach ($enemies as $key => $val) {
			$enemies[$key]['name'] = \db\_sewerage_enemies::name_get($val['id_enemy']);
		}
		return $enemies;
	}
}