<?php

function http_host($url = false)
{
	if ($url === false) {
		$url = $_SERVER['HTTP_HOST'];
	}
	$w3 = mb_substr($url, 0, 4);
	if ($w3 == 'www.') {
		return $url;
	}
	return "www.$url";
}

function base_url($add = '', $format = '')
{
	if ( ! empty($format)) {
		$add .= ".$format";
	}
	return 'http://' . http_host() . "/$add";
}

function public_url($add = '', $format = '')
{
	return base_url("public/$add", $format);
}

function redirect($url)
{
	header("Location: $url");
	exit;
}

function subord_url($page = false, $add = '')
{
	if ($page === false) {
		$page = PAGE_DEFAULT;
	}
	if ( ! empty($add)) {
		$add = "&$add";
	}
	return 'http://' . http_host() . "/index.php?page=$page$add";
}

function script_name()
{
	return mb_substr($_SERVER['SCRIPT_NAME'], 1);
}

function get_url()
{
	return 'http://' . http_host() . $_SERVER['REQUEST_URI'];
}

function page_name($url = false)
{
	if ($url) {
		return url_array($url)['page'];
	}
	
	if ( ! empty($_GET['page'])) {
		return $_GET['page'];
	}
	return PAGE_DEFAULT;
}

function ruler_url($edit = false, $cut = false)
{		
	$all_fragments = url_array_cache();
	
	if ($edit !== false) {
		foreach ($edit as $key => $val) {
			$all_fragments[$key] = $val;	
		}
	}
	
	if ($cut !== false) {
		if ( ! is_array($cut)) {
			$cut = func_get_args();
			unset($cut[0]);
		}
		foreach ($cut as $val) {
			unset($all_fragments[$val]);
		}
	}
	
	$ready = implode_url($all_fragments);
	
	$url = 'http://' . http_host() . '/' . script_name();
	if ( ! empty($ready)) {
		$ready = substr($ready, 1);
		$url	.= "?$ready"; 
	}
	return $url;
}

function ruler_url_edit($edit)
{
	$all_fragments = url_array_cache();
	foreach ($edit as $key => $val) {
		$all_fragments[$key] = $val;	
	}
	$ready = implode_url($all_fragments);
	$url = script_name();
	if ( ! empty($ready)) {
		$ready = substr($ready, 1);
		$url	.= "?$ready"; 
	}
	return $url;
}

function ruler_url_cut($cut)
{
	if ( ! is_array($cut)) {
		$cut = func_get_args();
	}
	$all_fragments = url_array_cache();
	// v($all_fragments);
	foreach ($cut as $val) {
		unset($all_fragments[$val]);
	}
	$ready = implode_url($all_fragments);
	$url = script_name();
	if ( ! empty($ready)) {
		$ready = substr($ready, 1);
		$url	.= "?$ready";
	}
	return $url;
}

function implode_url($url_array)
{
	if ( ! is_array($url_array)) {
		return '';
	}
	$ready = '';
	foreach ($url_array as $key => $val) {
		$ready .= "&$key=$val";
	}
	return $ready;
}

function url_array($query_string = false)
{
	if ($query_string !== false) {
		$qs = $query_string;
	}
	else {
		$qs = $_SERVER['QUERY_STRING'];
	}
	if ( ! empty($qs)) {
		// Если адресная строка не пуста
		$parse		= parse_url($qs);
		if (empty($parse['query'])) {
			$query = $parse['path'];
		}
		else {
			$query = $parse['query'];
		}
		
		$fragments	= explode('&', $query);
		
		foreach ($fragments as $fragment) {
			$elements = explode('=', $fragment);
			
			$key		 = array_shift($elements);
			$val		 = array_shift($elements);

			$ready[$key] = $val;
		}
		
		return $ready;
	}
	
	return false;
}

/**
 * То же что и url_array, но только с кешированием
 */
function url_array_cache()
{
	// Если массива с фрагментами в суперглобальном массиве не существует
	if ( ! isset($GLOBALS['all_fragments_url_cache']) ) {
		$all_fragments = url_array();
		// Создаем этот массив
		$GLOBALS['all_fragments_url_cache'] = $all_fragments;
	}
	
	return $GLOBALS['all_fragments_url_cache'];
}

class redirects
{
	/**
	 * особое перенаправление с возможностью указания контроллера, действия и дополнительх фрагментов url
	 * параметры: контроллер, действие, дополнительный url (всё что после знака &) соответственно
	 */
	public function subord($page, $add = '')
	{
		$redirect = subord_url($page, $add);
		{
			redirect($redirect);
		}
	}
	
	/**
	 * перенаправление с добавлением, изменением или удалением фрагментов url
	 * первый параметр принимает либо false (по умолачнию, если не нужно ничего добавлять или менять), либо массив с новыми фрагментами
	 * пример ruler(['new_fragment' => 'value', 'new_fragment2' => 'value2'])
	 * второй параметр принимает фрагменты которые должны быть вырезаны, причем есть два способа:
	 * первый, послать массив с фрагментами: ruler(false, ['cut_this_fragment', 'cut_this_fragment2'])
	 * второй, послать переменное число аргументов, которое будет обработано функцией func_get_args(): ruler(false, 'cut_this_fragment', 'cut_this_fragment2')
	 */
	public function ruler($edit = false, $cut = false)
	{
		if ( ! is_array($cut)) {
			$cut = func_get_args();
			unset($cut[0]);
		}
		$redirect = ruler_url($edit, $cut);
		{
			redirect($redirect);
		}
	}
	
	/**
	 * только вырезка фрагментов
	 * принимает либо массив, либо переменное число аргументов
	 */
	public function ruler_cut($cut)
	{
		if ( ! is_array($cut)) {
			$cut = func_get_args();
		}
		$redirect = ruler_url_cut($cut);
		{
			redirect($redirect);
		}
	}
	
	/**
	 * только добавление либо изменение фрагментов
	 * принимает исключительно массив
	 */
	public function ruler_edit($edit)
	{
		$redirect = ruler_url_edit($edit);
		{
			redirect($redirect);
		}
	}
	
	/**
	 * редирект без каких-либо обусловленностей
	 */
	public function here($url)
	{
		redirect($here);
	}
}

class redirect
{
	public static function go()
	{
		return new redirects;
	}
}