<?php

require ROOT . 'project/internal/core.php';
require ROOT . 'project/internal/box/admin_panel/admin_panel.class.php';
require ROOT . 'project/internal/class/compensation.class.php';

$user_id = ID;
$user_position = user::position_get($user_id);
if ($user_position < 3) {
	redirect_return();
}


$admin_panel_entrance = new admin_panel\admin_panel_entrance($user_id);

/* вход в панель */
$key = filter_input(INPUT_POST, 'key');
if ( ! empty($key)) {
	$admin_panel_entrance->key_enter($key);
}
$admin_panel_entrance->to_com_in();

/* выход с панели */
$is_go_out = filter_input(INPUT_GET, 'go_out');
if ( ! empty($is_go_out)) {
	$admin_panel_entrance->go_out();
	redirect::go()->ruler_cut(['go_out']);
}

$is_page_stock = (bool) filter_input(INPUT_GET, 'stock');
$is_page_compns = (bool) filter_input(INPUT_GET, 'comps');

/* запуск акции */
$id_stock = filter_input(INPUT_POST, 'id_stock');
$modifier = filter_input(INPUT_POST, 'modifier');
$term = (int) filter_input(INPUT_POST, 'term');
if ( ! is_null($id_stock)) {
	$stock = new stock\stock();
	$stock->start($id_stock, $modifier, $term);
	redirect::go()->ruler();
}

/* завершение акции */
$is_stock_finish = (bool) filter_input(INPUT_GET, 'finish');
if ($is_stock_finish) {
	$stock = new stock\stock();
	$stock->finish();
	redirect::go()->ruler_cut(['finish']);
}

/* компенсация */
$comps_type = filter_input(INPUT_POST, 'comps_type');
$comps_type_perhaps = ['user', 'all'];
if (in_array($comps_type, $comps_type_perhaps)) {
	$comps_num = filter_input(INPUT_POST, 'comps_num', FILTER_VALIDATE_INT);
	if ($comps_num < 1) {
		notf::set_notf('Число валюты слишком маленькое.', 'error');
		redirect::go()->ruler();
	}
	
	if ($comps_type == 'user') {
		// проверить id игрока
		$comps_user_id = filter_input(INPUT_POST, 'comps_user_id', FILTER_VALIDATE_INT);
		if ( ! $comps_user_id) {
			notf::set_notf('Неверный ID игрока.', 'error');
			redirect::go()->ruler();
		}
		if ( ! user::is_user($comps_user_id)) {
			notf::set_notf('Игрока с таким ID не существует.', 'error');
			redirect::go()->ruler();
		}
		
		$comps_currency_type = filter_input(INPUT_POST, 'comps_currency_type');
		$comp = new compensation($user_id, $comps_currency_type, $comps_num);
		$comp->send_user($comps_user_id);
	}
	elseif ($comps_type == 'all') {
		$comps_title = filter_input(INPUT_POST, 'comps_title');
		$comp = new compensation($user_id, 'mutagen', $comps_num);
		$comp->send($comps_title);
	}
	
	redirect::go()->ruler();
}

/* удаление компенсаций */
$comps_delete = filter_input(INPUT_GET, 'comps_delete');
$comps_delete_confirm = ($comps_delete == 'confirm') ? true : false;
if ($comps_delete == 'yes') {
	$compensation_delete = new compensation_delete($user_id);
	$compensation_delete->delete();
	redirect::go()->ruler_cut(['comps_delete']);
}

$is_entered = $admin_panel_entrance->is_entered();
$data = [];

view('tpl/cap');
view('tpl/header');
view('tpl/header-enter');
if ($is_entered) {
	if ($is_page_stock) {
		$stock_list = (new stock\stock_collect)->get_all();
		$data = [
			'stock_list' => $stock_list
		];
		view('admin_panel/admin_panel_stock', $data);
	}
	elseif ($is_page_compns) {
		$data = [
			'comps_delete_confirm' => $comps_delete_confirm
		];
		view('admin_panel/admin_panel_comps', $data);
	} else {
		view('admin_panel/admin_panel', $data);
	}
} else {
	view('admin_panel/admin_panel_entrance', $data);
}
view('tpl/footer-enter');
view('tpl/footer');