<?php

require ROOT . 'project/internal/core.php';

$id_user = filter_input(INPUT_GET, 'id_user', FILTER_VALIDATE_INT);
if ( ! $id_user ||  ! user::is_user($id_user) || user::position_get(ID) < 2) {
	redirect_return();
}

$ban_issue = true;
if ( ! is_null(filter_input(INPUT_POST, 'submit'))) {
	$ban_type_perhaps = [1, 2];
	$ban_time_perhaps = package('ban-time');
	
	$ban_type = filter_input(INPUT_POST, 'ban_type');
	if ( ! in_array($ban_type, $ban_type_perhaps)) {
		$ban_issue = false;
	}
	
	$ban_time = filter_input(INPUT_POST, 'time');
	if (is_string($ban_time) || is_integer($ban_time)) {
		if (array_key_exists($ban_time, $ban_time_perhaps)) {
			$ban_seconds = $ban_time_perhaps[$ban_time];
		}
		else {
			$ban_issue = false;
		}
	}
	else {
		$ban_issue = false;
	}
	
	$ban_my_time = filter_input(INPUT_POST, 'my_time', FILTER_VALIDATE_INT);
	if ($ban_my_time) {
		$ban_issue = true;
		$ban_seconds = $ban_my_time;
	}
	
	$ban_cause = filter_input(INPUT_POST, 'ban_cause');
	if (empty($ban_cause)) {
		$ban_issue = false;
	}
}
else {
	$ban_issue = false;
}

if ($ban_issue) {
	ban::issue($id_user, ['ban_type' => $ban_type, 'ban_time' => $ban_seconds, 'ban_cause' => $ban_cause, 'id_user_imposed' => ID]);
	redirect::go()->subord('profile', "id_user=$id_user");
}

view('tpl/cap');
view('tpl/header');
view('tpl/header-enter');
view('ban-issue', (new ban_model)->ban_issue($id_user));
view('tpl/footer-enter');
view('tpl/footer');