<?php

require ROOT . 'project/internal/core.php';

$user_id = ID;
$config = (object) require ROOT . 'project/internal/config/worldkassa.config.php';
$price_mutagen = $config->price_mutagen;
$id_shop = $config->id_shop;
$hash = $config->hash;
$mutagen_min = $config->min_mutagen;
$mutagen_max = $config->max_mutagen;
$error = '';
$mutagen_sum = filter_input(INPUT_POST, 'sum', FILTER_VALIDATE_FLOAT);
if ( ! is_null($mutagen_sum)) {
	if ($mutagen_sum < $mutagen_min || $mutagen_sum > $mutagen_max) {
		notf::set_notf('Неверная сумма.', 'error');
		redirect::go()->subord('bank');
	} else {
		$ruble_sum = (int) round($mutagen_sum * $price_mutagen);
		$data = file_get_contents("http://worldkassa.ru/user/oplata.php?id_shop=$id_shop&summa=$ruble_sum&hash=$hash");
		if (is_numeric($data)) {
			$id_bill = $data;
			// записать платеж в базу
			$sql = 'insert into users_donat set id_user = ?, id_bill = ?, mutagen_sum = ?, ruble_sum = ?, created_timestamp = ?';
			$sth = \db::$pdo->prepare($sql);
			$sth->execute([$user_id, $id_bill, $mutagen_sum, $ruble_sum, time()]);
			header("Location: http://worldkassa.ru/user/oplata.php?uniq=$id_bill");
			exit();
		}
		else {
			$error = $data;
		}
	}
}



$data = [
	'mutagen_min' => $mutagen_min,
	'mutagen_max' => $mutagen_max,
	'price_mutagen' => $price_mutagen,
	'error' => $error
];

view('tpl/cap');
view('tpl/header');
view('tpl/header-enter');
view('bank', $data);
view('tpl/footer-enter');
view('tpl/footer');