<?php

require ROOT . 'project/internal/core.php';
require ROOT . 'project/internal/box/referral.box.php';

if (isset($_POST['id_shop']) && is_numeric($_POST['id_shop']) && isset($_POST['id_bill']) && is_numeric(
$_POST['id_bill']) && isset($_POST['summa']) && is_numeric($_POST['summa']) && isset($_POST['hash']))
{
	$config = (object) require ROOT . 'project/internal/config/worldkassa.config.php';
	
	$sql = 'select * from users_donat where id_bill = ? limit 1';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$_POST['id_bill']]);
	$data = $sth->fetch(PDO::FETCH_OBJ);
	
	// проверить существует ли запись в базе с таким id платежа
	// и не оплачена ли она уже
	if ($row && $row['completed'] == 0)
	{
		if ($_POST['summa'] != $data->ruble_sum)
		{
			// можно поставить уведомление о подмене суммы пополнения
		}
		elseif($_POST['hash'] != md5($config->hash.$config->id_shop.$_POST['id_bill'].$_POST['summa']))
		{
			// можно поставить уведомление, что не совпал хеш
		}
		else
		{ // успешно
			$mutagen = (int) round($_POST['summa'] * $config->price_mutagen);
			
			// бонус от акций
			$stock = new \stock\stock();
			$bonus_mutagen_percent = $stock->get_discount_mutagen_purchase();
			$mutagen += (int) floor(percentage($mutagen, $bonus_mutagen_percent));
			
			$currency = new currency($data->id_user);
			$currency->bonuses = false;
			$currency->base = $mutagen;
			$currency->mutagen_add();
			
			// бонус пригласившему (реф. система)
			$referral_bonus = new referral_bonus($data->id_user, $mutagen);
			$referral_bonus->overcharging();
			
			// добавление в статистику
			$user_statistic = new \user_statistic($data->user_id);
			$user_statistic->increase_statistic('mutagen_bought', $mutagen);
		}
		
		// отметить платеж как завершенный
		$sql = 'update users_donat set payment_timestamp = ?, completed = ? where id = ? limit 1';
		$sth = db::$pdo->prepare($sql);
		$sth->execute([time(), 1, $data->id]);
	}
}