<?php

require_once(ROOT . 'project/internal/core.php');
require ROOT . 'project/internal/class/compensation.class.php';

$id_invited = filter_input(INPUT_GET, 'r', FILTER_VALIDATE_INT);
$hero = filter_input(INPUT_GET, 'hero');
$perhaps = [
	'leo', 'raf', 'miki', 'doni'
];
if (in_array($hero, $perhaps)) {
	/* нельзя допустить чтоб можно было слишком часто создавать новых персонажей, это очень смахивает на дос атаку
	чтоб предотвратить дос атаку нужно делать паузу между регистрациями персов */
	
	// получить количество игроков зарегестрированных за последних 60 секунд
	$last_sec = time() - 60;
	$sql = "select count(*) from users where reg_timestamp >= $last_sec limit 1";
	$sth = db::$pdo->query($sql);
	if ($sth->fetchColumn() > 10) { // если за последние 60 секунд зарегестрировалось больше 10 игроков
		redirect::go()->subord('start');
	}
	
	$feature = turtle_bonus($hero); // особенность черепашки
	$time = time();
	$config = require ROOT . 'project/internal/config/main.config.php';
	
	if ($id_invited) {
		if ( ! user::is_user($id_invited)) { // если такой игрок не существует
			$id_invited = null;
		}
	}
	
	// зарегестрировать нового перса users
	$sql =  'insert into users set hero = ?, id_invited = ?';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$hero, $id_invited]);
	$last_id = db::$pdo->lastInsertId();
	$_SESSION['id'] = $last_id;
	auto_authn($last_id);
	
	// users
	$new_login = "#turtle$last_id";
	$position = ($last_id == 1) ? 3 : 1;
	$news_last_id = news::get_news_last_id();
	$news_last_id = ($news_last_id) ? $news_last_id : null;
	$compensation_last = \compensation::get_last();
	$compensation_last_id = (is_object($compensation_last)) ? $compensation_last->id : false;
	$compensation_last_id = (is_numeric($compensation_last_id)) ? $compensation_last_id : null;
	$sql = 'update users set login = ?, position = ?, id_news_last = ?, id_compensation_last = ?, reg_timestamp = ? where id = ? limit 1';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$new_login, $position, $news_last_id, $compensation_last_id, $time, $last_id]);
	if ($id_invited) {
		$jtext = '%s прибыл(/а) по вашему приглашению';
		$new_user_link = subord_url('profile', "id_user=$last_id");
		$jtext = sprintf($jtext, "<a href='$new_user_link'>$new_login</a>");
		journal::record_add(['title' => 'Система Рефералов', 'text' => $jtext], $id_invited);
	}
	
	// users_combat
	$start = $config['user_start_param'];
	
	$sql = 'insert into users_combat set id_user = ?, health = ?, power = ?, agil = ?, intell = ?';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$last_id, $start['health'], $start['power'], $start['agil'], $start['intell']]);
	
	// users_dyn
	$sql = 'insert into users_dyn set id_user = ?';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$last_id]);
	
	// users_online
	$sql = 'insert into users_online set id_user = ?, time = ?, time_day = ?';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$last_id, $time, $time]);
	
	// users_sweeping
	$sql = 'insert into users_sweeping set id_user = ?, enemies_num = ?, enemies_num_timestamp = ?, enemies_num_bought_timestamp = ?';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$last_id, sweeping_users::ENEMIES_NUM_DEFAULT, null, $time]);
	
	// users_scramble_detal
	$num_enemies = scramble_enemies::ENEMIES_NUM_MAX;
	$sql = 'insert into users_scramble_detal set id_user = ?, enemies = ?, enemies_timestamp = ?';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$last_id, $num_enemies, null]);
	
	// users_advent
	$sql = 'insert into users_advent set id_user = ?, mutagen_collected_timestamp = ?';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$last_id, $time]);
	
	// users_training
	$sql = 'insert into users_training set id_user = ?';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$last_id]);
	
	// users_lab
	$sql = 'insert into users_lab set id_user = ?, mutagen = ?';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$last_id, 5]);
	
	// users_dump
	$sql = 'insert into users_dump set id_user = ?';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$last_id]);
	
	// cl1_users
	$sql = 'insert into cl1_users set id_user = ?, battles = ?';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$last_id, cl1::USER_BATTLES_DEFAULT]);
	
	// users_cards
	$sql = 'insert into users_cards set id_user = ?, cards = ?';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$last_id, '']);
	
	// users_weapon
	$sql = 'insert into users_weapon set id_user = ?';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$last_id]);
	
	// ml1_reward
	$sql = 'insert into ml1_reward set id_user = ?';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$last_id]);
	
	// users_robbery
	$sql = 'insert into users_robbery set id_user = ?';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$last_id]);
	
	// users_battle
	$sql = 'insert into users_battle set id_user = ?';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$last_id]);
	
	// users_premium
	$sql = 'insert into users_premium set id_user = ?';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$last_id]);
	
	// users_bonuses
	$sql = 'insert into users_bonuses set id_user = ?';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$last_id]);
	
	// users_statistic
	$sql = 'insert into users_statistic set id_user = ?';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$last_id]);
	
	redirect::go()->subord('home');
}

view('tpl/cap');
view('tpl/header');
view('choice-hero');
view('tpl/footer');