<?php

require(ROOT . 'project/internal/core.php');

$user_id = ID;

if ( ! clan::is_user_clan(ID)) { // если игрок не состоит в клане
	redirect_return(false, 'clan');
}
$id_clan = clan::get_id_clan_by_id_user(ID);
$args = [
	'bucks_refill' => FILTER_VALIDATE_INT,
	'mutagen_refill' => FILTER_VALIDATE_INT,
	'pancers_refill' => FILTER_VALIDATE_INT,
	'metal_refill' => FILTER_VALIDATE_INT
];
$refill = filter_input_array(INPUT_POST, $args);
$user_login = user::login_get(ID);
$user_link = '<a href="%s">%s</a>';
$user_link = sprintf($user_link, subord_url('profile', "id_user=$user_id"), $user_login);
$text_prep = "$user_link отправил(/а) в казну %s";
if ($refill['bucks_refill'] > 0) {
	if (get_bucks_by_id(ID) >= $refill['bucks_refill']) { // у игрока баксов достаточно
		clan_coffers::bucks_refill($id_clan, $refill['bucks_refill']);
		clan::clan_part_bucks_set(ID, $refill['bucks_refill']);
		
		$currency = new currency($user_id);
		$currency->bonuses = false;
		$currency->base = -$refill['bucks_refill'];
		$currency->bucks_add();
		
		$text = sprintf($text_prep, "<span class='bucks-color'>баксы x" . number_format($refill['bucks_refill']) . " </span>");
		clan_journal::record_add($text, $id_clan);
		
		$user_statistic = new \user_statistic(ID);
		$user_statistic->increase_statistic('clan_bucks', $refill['bucks_refill']);
	}
}
if ($refill['mutagen_refill'] > 0) {
	if (get_mutagen_by_id(ID) >= $refill['mutagen_refill']) { // у игрока мутагена достаточно
		clan_coffers::mutagen_refill($id_clan, $refill['mutagen_refill']);
		clan::clan_part_mutagen_set(ID, $refill['mutagen_refill']);
		
		$currency = new currency($user_id);
		$currency->bonuses = false;
		$currency->base = -$refill['mutagen_refill'];
		$currency->mutagen_add();
		
		$text = sprintf($text_prep, "<span class='mutagen-color'>мутаген x" . number_format($refill['mutagen_refill']) . "</span>");
		clan_journal::record_add($text, $id_clan);
		
		$user_statistic = new \user_statistic(ID);
		$user_statistic->increase_statistic('clan_mutagen', $refill['mutagen_refill']);
	}
}
if ($refill['pancers_refill'] > 0) {
	if (get_pancers_by_id(ID) >= $refill['pancers_refill']) { // у игрока панцирей достаточно
		clan_coffers::pancers_refill($id_clan, $refill['pancers_refill']);
		clan::clan_part_pancers_set(ID, $refill['pancers_refill']);
		
		$currency = new currency($user_id);
		$currency->bonuses = false;
		$currency->base = -$refill['pancers_refill'];
		$currency->pancers_add();
		
		$text = sprintf($text_prep, "<span class='pancers-color'>панцири x" . number_format($refill['pancers_refill']) . "</span>");
		clan_journal::record_add($text, $id_clan);
		
		$user_statistic = new \user_statistic(ID);
		$user_statistic->increase_statistic('clan_pancers', $refill['pancers_refill']);
	}
}
if ($refill['metal_refill'] > 0) {
	if (get_metal_by_id(ID) >= $refill['metal_refill']) { // у игрока металлолома достаточно
		clan_coffers::metal_refill($id_clan, $refill['metal_refill']);
		clan::clan_part_metal_set(ID, $refill['metal_refill']);
		
		$currency = new currency($user_id);
		$currency->bonuses = false;
		$currency->base = -$refill['metal_refill'];
		$currency->metal_add();
		
		$text = sprintf($text_prep, "<span class='metal-color'>металлолом x" . number_format($refill['metal_refill']) . "</span>");
		clan_journal::record_add($text, $id_clan);
		
		$user_statistic = new \user_statistic(ID);
		$user_statistic->increase_statistic('clan_metal', $refill['metal_refill']);
	}
}
if ( ! is_null($refill)) {
	redirect::go()->subord('clan_coffers');
}

view('tpl/cap');
view('tpl/header');
view('tpl/header-enter');
view('clan/clan-coffers', (new clan_model)->clan_coffers($id_clan));
view('tpl/footer-enter');
view('tpl/footer');