<?php

require ROOT . 'project/internal/core.php';

$user_id = ID;
$interlocutor_id = filter_input(INPUT_GET, 'id_interlocutor', FILTER_VALIDATE_INT);
if ($interlocutor_id) {
	if ($interlocutor_id == $user_id) {
		redirect::go()->subord('mail');
	}
	if (user::is_user($interlocutor_id)) {
		$text = filter_input(INPUT_POST, 'text');
		if (is_string($text)) {
			$text = trim($text);
			if ($text) {
				$mail = new mail;
				$mail->user_id = $user_id;
				$mail->interlocutor_id = $interlocutor_id;
				$mail->sender_id = $user_id;
				$mail->recipient_id = $interlocutor_id;
				$mail->text = $text;
				$mail->timestamp = time();
				$mail->message_add();
			}
		}
		if ( ! is_null($text)) {
			redirect::go()->subord('mail', "id_interlocutor=$interlocutor_id");
		}
		
		$correspondence_delete_confirm = false;
		if ( ! is_null($correspondence_delete = filter_input(INPUT_GET, 'correspondence_delete'))) {
			$correspondence_delete_confirm = true;
			if ($correspondence_delete == 1) {
				$mail = new mail;
				$mail->user_id = ID;
				$mail->interlocutor_id = $interlocutor_id;
				$mail->correspondence_delete();
				redirect::go()->subord('mail');
			}
		}

		
		$data = [
			'user_id' => $user_id,
			'interlocutor_id' => $interlocutor_id,
			'correspondence_delete_confirm' => $correspondence_delete_confirm
		];
		
		view('tpl/cap');
		view('tpl/header');
		view('tpl/header-enter');
		view('mail-correspondence', (new mail_model)->correspondence($data));
		view('tpl/footer-enter');
		view('tpl/footer');
		db\users_mail::messages_mark_as_read($user_id, $interlocutor_id);
		return;
	}
}

$clean_confirm = false;
if ( ! is_null($clean = filter_input(INPUT_GET, 'clean'))) {
	$clean_confirm = true;
	if ($clean == 1) {
		$mail = new mail;
		$mail->user_id = ID;
		$mail->clean();
		redirect::go()->subord('mail');
	}
}

$data = [
	'user_id' => $user_id,
	'clean_confirm' => $clean_confirm
];

view('tpl/cap');
view('tpl/header');
view('tpl/header-enter');
view('mail', (new mail_model)->mail($data));
view('tpl/footer-enter');
view('tpl/footer');