<?php

require ROOT . 'project/internal/core.php';
require ROOT . 'project/internal/box/ml1/ml1_pending.class.php';

$status = ml1::status_get();
if ($status == 1) { // подготовка
	$pending = new ml1\pending();
	$pending->start();
	if ( ! is_null(filter_input(INPUT_GET, 'reward'))) {
		ml1_reward::reward_gather_ctrl();
		redirect::go()->subord('ml1');
	}
	
	$sql = 'select * from ml1_pending order by timestamp desc limit 5';
	$sth = db::$pdo->query($sql);	
	$players = $sth->fetchAll(\PDO::FETCH_OBJ);
	
	$sql = 'select count(*) from ml1_pending limit 1';
	$sth = db::$pdo->query($sql);
	$players_num = $sth->fetchColumn();
	$players_max = 5;
	
	$pending = (object) [
		'players' => $players,
		'players_num' => $players_num,
		'players_max' => $players_max
	];
	
	$expect = (new ml1_model)->expect();
	$expect['pending'] = $pending;
	view('tpl/cap');
	view('tpl/header');
	view('tpl/header-enter');
	view('ml1/ml1-expect', $expect);
	view('tpl/footer-enter');
	view('tpl/footer');
}
elseif ($status == 3) { // бой
	ml1_part::part_create_ctrl();
	ml1_statistic::user_statistic_ctrl(); // контроллер статистики
	ml1_part::user_target_ctrl(); // поиск цели
	ml1_part::user_rose_ctrl(); // возвращение в бой после ранения
	ml1_part::user_dodge_recovery_ctrl(); // востановление уворота
	ml1_part::user_hit_delay_recovery_ctrl(); // востановление удара
	if ( ! is_null(filter_input(INPUT_GET, 'hit'))) { // удар
		ml1_part::user_hit_ctrl();
		redirect::go()->subord('ml1');
	}
	if ( ! is_null(filter_input(INPUT_GET, 'dodge'))) { // уворот
		ml1_part::user_dodge_ctrl();
		redirect::go()->subord('ml1');
	}
	if ( ! is_null(filter_input(INPUT_GET, 'change'))) { // смена цели
		ml1_part::user_change_ctrl();
		redirect::go()->subord('ml1');
	}
	view('tpl/cap');
	view('tpl/header');
	view('ml1/ml1-battle', (new ml1_model)->battle());
	view('tpl/footer');
	
	ml1_part::part_damage_applied_reset(ID);
	ml1_part::part_damage_received_reset(ID);
}