<?php

require ROOT . 'project/internal/core.php';
require ROOT . 'project/internal/model/ml2.mdl.php';

if ( ! db\ml2_commands::in_command(ID)) {
	redirect::go()->subord('ml2');
}
$command_id = db\ml2_commands::command_id_get(ID);
if (db\ml2_commands::status_get($command_id) != ml2\command::STATUS_BATTLE) {
	redirect::go()->subord('ml2');
}

if ( ! is_null(filter_input(INPUT_GET, 'leave'))) {
	$command_leave = new ml2\command_leave;
	$command_leave->user_id = ID;
	$command_leave->tap();
	redirect::go()->subord('ml2');
}

\battle\action::hit_recovery(ID);
\battle\action::dodge_recovery(ID);
\battle\action::change_recovery(ID);


$status_end = null;
$command_id = \db\ml2_commands::command_id_get(ID);
$battle_id = \db\ml2_commands::battle_id_get($command_id);
if ( ! \db\ml2_part::is_live($battle_id)) { // никто не жив
	$status_end = ml2\user_command::STATUS_LOST;
}
$location_id = \db\ml2_commands::location_id_get($command_id);
$wave = \db\ml2_commands::wave_get($command_id);
$wave_max = \db\_sewerage::wave_max_get($location_id);
if ($wave >= $wave_max && ! \db\ml2_part::is_enemies($battle_id)) {
	$status_end = ml2\user_command::STATUS_VICTORY;
}

if ( ! is_null($status_end)) {
	if ($status_end == ml2\user_command::STATUS_VICTORY) {
		$reward_percent = 100;
	}
	elseif ($status_end == ml2\user_command::STATUS_LOST) {
		$reward_percent = (int) floor(compercent(($wave - 1), $wave_max));
		$reward_percent = ($reward_percent < 0) ? 0 : $reward_percent;
	}
	// $cards = \db\_sewerage::reward_cards_unserialize_get($location_id);
	$expr = (int) floor(percentage(\db\_sewerage::reward_exp_get($location_id), $reward_percent));
	$bucks = (int) floor(percentage(\db\_sewerage::reward_bucks_get($location_id), $reward_percent));
	$metal = (int) floor(percentage(\db\_sewerage::reward_metal_get($location_id), $reward_percent));
	
	$ids = db\ml2_commands::parts_id_get($command_id);
	foreach ($ids as $id) {
		$user_damage_percent = \db\ml2_statistic::user_damage_percent_get($id, $battle_id);
		
		$reward_cards = null;
		if ($status_end == ml2\user_command::STATUS_VICTORY) {
			if ($user_damage_percent > 0) {
				$card_id = db\_sewerage::card_random_id($location_id);
				// $card_chance = ml2\reward::card_chance_generate($card_id, $id);
				$reward_cards[] = $card_id;
			}
			
			$user_statistic = new \user_statistic($id);
			$user_statistic->increase_statistic('sewerage_passed', 1);
		}
		$reward_expr = percentage($expr, $user_damage_percent);
		$reward_bucks = percentage($bucks, $user_damage_percent);
		$reward_metal = percentage($metal, $user_damage_percent);
		if ( ! $reward_cards && ! $reward_expr && ! $reward_bucks && ! $reward_metal) {
			break;
		}
		
		$reward_a = new ml2\reward_add;
		$reward_a->user_id = $id;
		$reward_a->statistic_id = db\ml2_statistic::id_get($id, $battle_id);
		$reward_a->battle_id = $battle_id;
		
		$currency = new currency;
		$currency->user_id = $id;
		$currency->base = $reward_bucks;
		$reward_a->bucks = $currency->bucks_generate();
		$currency->base = $reward_metal;
		$reward_a->metal = $currency->metal_generate();
		
		$reward_a->cards = $reward_cards;
		
		$obj_expr = new expr;
		$obj_expr->user_id = $id;
		$obj_expr->base = $reward_expr;
		$reward_a->expr = $obj_expr->private_generate();
		$reward_a->tap();
		
		$lclose = new ml2\location_close;
		$lclose->user_id = $id;
		$lclose->location_id = $location_id;
		$lclose->tap();
	}
	
	$command_destroy = new ml2\command_destroy;
	$command_destroy->command_id = $command_id;
	$command_destroy->execute();
	redirect::go()->subord('ml2');
}






if ( ! is_null(filter_input(INPUT_GET, 'dodge'))) {
	ml2\battle::dodge(ID);
	redirect::go()->subord('ml2_battle');
}
(new ml2\battle)->wave(ID);
(new ml2\battle)->target(ID);
(new ml2\battle)->enemies(db\ml2_commands::battle_id_get($command_id));
if ( ! is_null(filter_input(INPUT_GET, 'hit'))) {
	ml2\battle::hit(ID);
	redirect::go()->subord('ml2_battle');
}
if ( ! is_null(filter_input(INPUT_GET, 'change'))) {
	ml2\battle::change(ID);
	redirect::go()->subord('ml2_battle');
}

view('tpl/cap');
view('tpl/header');
view('ml2/ml2_battle', (new model\ml2)->battle(ID));
view('tpl/footer');

// получить боевой id, текущего игрока
$user_battle_id = db\ml2_part::user_battle_id_by_real_user_id_get(ID);
db\ml2_part::damage_received_reset($user_battle_id);
db\ml2_part::damage_applied_reset($user_battle_id);