<?php

require ROOT . 'project/internal/core.php';
require ROOT . 'project/internal/model/ml2.mdl.php';

$user_id = ID;

if ( ! db\ml2_commands::in_command(ID)) {
	redirect::go()->subord('ml2');
}
$command_id = db\ml2_commands::command_id_get(ID);
if (db\ml2_commands::status_get($command_id) == ml2\command::STATUS_BATTLE) {
	redirect::go()->subord('ml2_battle');
}

$command = new ml2\user_command;
if ( ! is_null(filter_input(INPUT_GET, 'start'))) {
	$command->start(ID);
	redirect::go()->subord('ml2_battle');
}

if ( ! is_null(filter_input(INPUT_GET, 'leave'))) {
	$command_leave = new ml2\command_leave;
	$command_leave->user_id = ID;
	$command_leave->tap();
	redirect::go()->subord('ml2');
}

if ( ! is_null(filter_input(INPUT_GET, 'dissolve'))) {
	$command_dissolve = new ml2\command_dissolve;
	$command_dissolve->user_id = ID;
	$command_dissolve->tap();
	redirect::go()->subord('ml2');
}

$expel_user_id = filter_input(INPUT_GET, 'expel', FILTER_VALIDATE_INT);
if ($expel_user_id) {
	$command_deleted = new ml2\command_deleted;
	$command_deleted->who_user_id = ID;
	$command_deleted->whom_user_id = $expel_user_id;
	$command_deleted->execute();
	redirect::go()->subord('ml2_command');
}

if ( ! is_null(filter_input(INPUT_GET, 'access'))) {
	$command_access = new ml2\command_access;
	$command_access->user_id = ID;
	$command_access->execute();
	redirect::go()->subord('ml2_command');
}

$message = filter_input(INPUT_POST, 'message');
if ( ! is_null($message)) {
	$message_len = mb_strlen($message);
	if ($message_len < 1 || $message_len > 500) {
		notf::set_notf('Сообщение не соответствующей длины.', 'error');
	} else {
		$message = htmlspecialchars($message);
		$chat = new ml2\command_chat($command_id);
		$chat->add_message($user_id, $message);
	}
	redirect::go()->subord('ml2_command');
}


view('tpl/cap');
view('tpl/header');
view('tpl/header-enter');
view('ml2/ml2_command', (new model\ml2)->command(ID));
view('tpl/footer-enter');
view('tpl/footer');