<?php

require ROOT . 'project/internal/core.php';

$news_id = filter_input(INPUT_GET, 'id', FILTER_VALIDATE_INT);
if ( ! news::filter_news_id($news_id)) {
	redirect::go()->subord('news');
}

if ( ! is_null(filter_input(INPUT_GET, 'delete'))) {
	$news = new news;
	$news->user_id = ID;
	$news->delete($news_id);
	redirect::go()->subord('news');
}

news::update_news_user_last_id(ID);

$comment_text = filter_input(INPUT_POST, 'comment');
$comment_id_delete = filter_input(INPUT_GET, 'comment_delete', FILTER_VALIDATE_INT);
$recipient_id = filter_input(INPUT_GET, 'recipient_id', FILTER_VALIDATE_INT);
if ( ! user::is_user($recipient_id)) {
	$recipient_id = false;
}

$obj_news_comments = new news_comments($news_id);
$obj_news_comments->user_id = ID;
$obj_news_comments->recipient_id = $recipient_id;
$obj_news_comments->comment_id = $comment_id_delete;
$obj_news_comments->comment_text = $comment_text;

$obj_news_comments->add_comment();
$obj_news_comments->delete_comment();
if ( ! is_null($comment_text)) {
	redirect::go()->subord('news_detail', "id=$news_id");
}
if ( ! is_null($comment_id_delete)) {
	redirect::go()->subord('news_detail', "id=$news_id");
}

$news = (object) news::get_news($news_id);
$is_privilege_news_edit = news::is_privilege_news_edit(ID);
$is_privilege_news_delete = news::is_privilege_news_delete(ID);

$comments = $obj_news_comments->get_last_comments(10);
$comments_pag = $comments['pag'];
$comments = $comments['comments'];
$comments_num = news_comments::count_comments($news_id);
$is_privilege_comment_delete = news_comments::is_privilege_comment_delete(ID);

$data = [
	'user_id' => ID,
	'recipient_id' => $recipient_id,
	'news' => $news,
	'is_privilege_news_edit' => $is_privilege_news_edit,
	'is_privilege_news_delete' => $is_privilege_news_delete,
	'comments' => $comments,
	'comments_pag' => $comments_pag,
	'comments_num' => $comments_num,
	'is_privilege_comment_delete' => $is_privilege_comment_delete
];

view('tpl/cap');
view('tpl/header');
view('tpl/header-enter');
view('news-detail', $data);
view('tpl/footer-enter');
view('tpl/footer');