<?php

require ROOT . 'project/internal/core.php';

$privilege_news_edit = news::is_privilege_news_edit(ID);
if ( ! $privilege_news_edit) {
	redirect_return();
}

$news_id = filter_input(INPUT_GET, 'id', FILTER_VALIDATE_INT);
if ( ! news::filter_news_id($news_id)) {
	redirect::go()->subord('news');
}

$news = (object) news::get_news($news_id);

$title = filter_input(INPUT_POST, 'title');
$text = filter_input(INPUT_POST, 'text');
if ( ! is_null($title) && ! is_null($text)) {
	$news = new news;
	$news->user_id = ID;
	$news->title = $title;
	$news->text = $text;
	$result = $news->edit($news_id);
	if ($result === false) {
		redirect::go()->subord('news_edit', "id=$news_id");
	}
	redirect::go()->subord('news_detail', "id=$news_id");
}

$data = [
	'title_top_text' => 'Редактировать Новость',
	'submit_text' => 'Изменить',
	'title_text' => $news->title,
	'textarea_text' => $news->text
];

view('tpl/cap');
view('tpl/header');
view('tpl/header-enter');
view('news-create', $data);
view('tpl/footer-enter');
view('tpl/footer');