<?php

require ROOT . 'project/internal/core.php';
require ROOT . 'project/internal/box/referral.box.php';

url_in_session::$ban = true;
// если уже сохранен
if ( ! is_null(get_userpassword_by_id(ID))) {
	redirect_return();
}

if (isset($_POST['submit'])) {
	$login = $_POST['login'];
	$password = $_POST['password'];
	$login_check = filter::login_check($login);
	$password_check = filter::password_check($password);
	if ($login_check == 2 || $password_check == 2) {
		notf::set_notf('Оба поля обязательны для заполнения', 'error');
		redirect::go()->subord('save');
	}
	elseif ($login_check == 4) {
		notf::set_notf('Логин не соответствующей длины', 'error');
		redirect::go()->subord('save');
	}
	elseif ($login_check == 8) {
		notf::set_notf('В логине содержатся ошибки', 'error');
		redirect::go()->subord('save');
	}
	
	if ($password_check == 4) {
		notf::set_notf('Пароль не соответствующей длины', 'error');
		redirect::go()->subord('save');
	}
	
	$gender = filter_input(INPUT_POST, 'gender');
	$gender_perhaps = [0, 1, 2];
	if ( ! in_array($gender, $gender_perhaps)) {
		$gender = 0;
	}
	
	// проверить не занят ли логин
	$sql = 'select count(*) from users where login = ? limit 1';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$login]);
	if ($sth->fetch(PDO::FETCH_NUM)[0] == 1) {
		notf::set_notf('Такой логин уже занят', 'error');
		redirect::go()->subord('save');
	}
	
	$old_login = user::login_get(ID);
	$password = encrypt_user_password($password);
	$sql = 'update users set login = ?, password = ?, gender = ? where id = ? limit 1';
	$sth = db::$pdo->prepare($sql);
	$sth->execute([$login, $password, $gender, ID]);
	
	$currency = new currency(ID);
	$currency->bonuses = false;
	$currency->base = game::SAVE_MUTAGEN_NUM;
	$currency->mutagen_add();
	
	$referral = new referral();
	$id_invited = $referral->who_invited(ID);
	if ($id_invited) {
		$user_id = ID;
		$jtitle = 'Система Рефералов';
		$jtext = 'Ваш реферал выбрал себе никнейм: %s -> %s';
		$new_user_link = subord_url('profile', "id_user=$user_id");
		$jtext = sprintf($jtext, $old_login, "<a href='$new_user_link'>$login</a>");
		journal::record_add(['title' => $jtitle, 'text' => $jtext], $id_invited);
	}
	
	redirect_return();
}

$data = [
	'save_mutagen_num' => game::SAVE_MUTAGEN_NUM
];

view('tpl/cap');
view('tpl/header');
view('tpl/header-enter');
view('save', $data);
view('tpl/footer-enter');
view('tpl/footer');