<?php

require ROOT . 'project/internal/core.php';
require ROOT . 'project/internal/box/referral.box.php';

$gender_change = filter_input(INPUT_GET, 'gender_change');
if ( ! is_null($gender_change)) {
	$gender = filter_input(INPUT_GET, 'gender');
	$gender_perhaps = [0, 1, 2];
	if ( ! is_null($gender) && in_array($gender, $gender_perhaps)) {
		setting::gender_change(ID, $gender);
		redirect::go()->subord('setting', 'gender_change');
	}
}

$login_change = filter_input(INPUT_GET, 'login_change');
if ( ! is_null($login_change)) {
	$login = filter_input(INPUT_POST, 'login');
	if ( ! is_null($login)) {
		$login_check = filter::login_check($login);
		if ($login_check == 2) {
			notf::set_notf('Логин не должен быть пустым', 'error');
		}
		elseif ($login_check == 4) {
			notf::set_notf('Логин не соответствующей длины', 'error');
		}
		elseif ($login_check == 8) {
			notf::set_notf('В логине содержатся ошибки', 'error');
		}
		elseif ($login_check == 2020) {
			setting::login_change(ID, $login);
		}
		redirect::go()->subord('setting', 'login_change');
	}
}

$password_change = filter_input(INPUT_GET, 'password_change');
if ( ! is_null($password_change)) {
	$password_old = filter_input(INPUT_POST, 'password_old');
	$password_new = filter_input(INPUT_POST, 'password_new');
	if ( ! is_null($password_new)) {
		$password_check = filter::password_check($password_new);
		if ($password_check == 2) {
			notf::set_notf('Пароль не должен быть пустым', 'error');
		}
		elseif ($password_check == 4) {
			notf::set_notf('Пароль не соответствующей длины', 'error');
		}
		elseif ($password_check == 2020) {
			setting::password_change(ID, $password_old, $password_new);
		}
		redirect::go()->subord('setting', 'password_change');
	}
}

$character_change = filter_input(INPUT_GET, 'character_change');
if ( ! is_null($character_change)) {
	$character = filter_input(INPUT_GET, 'character');
	$character_perhaps = ['leo', 'raf', 'doni', 'miki'];
	if ( ! in_array($character, $character_perhaps)) {
		$character = null;
	}
	else {
		if ( ! is_null(filter_input(INPUT_GET, 'change_character'))) {
			setting::character_change(ID, $character);
			redirect::go()->subord('setting', 'character_change');
		}
	}
}

$email_change = filter_input(INPUT_GET, 'change_email');
if ( ! is_null($email_change)) {
	$user = new user(ID);
	if ($user->is_confirm_email()) {
		redirect::go()->subord('setting');
	}
	
	if ( ! is_null(filter_input(INPUT_GET, 'reset'))) {
		setting::reset_email(ID);
		redirect::go()->subord('setting', 'change_email');
	}
	
	$email_confirm_code = $user->get_email_confirm_code();
	
	$email = filter_input(INPUT_POST, 'email');
	$code = filter_input(INPUT_POST, 'code');
	if ( ! is_null($email) && is_null($email_confirm_code)) {
		$email_check = filter::email_check($email);
		if ($email_check == 2) {
			notf::set_notf('Некорректный email.', 'error');
		}
		elseif ($email_check == 2020) {
			setting::email_attached(ID, $email);
		}
		redirect::go()->subord('setting', 'change_email');
	}
	elseif ( ! is_null($code) && ! is_null($email_confirm_code)) {
		$result = setting::confirm_email(ID, $code);
		if ($result) {
			redirect::go()->subord('profile');
		} else {
			redirect::go()->subord('setting', 'change_email');
		}
	}
}

view('tpl/cap');
view('tpl/header');
view('tpl/header-enter');
if ( ! is_null($gender_change)) {
	$data = [
		'gender' => user::gender_get(ID)
	];
	view('change-gender', $data);
}
elseif ( ! is_null($login_change)) {
	$data = [
		'login_change_price_mutagen' => game::LOGIN_CHANGE_PRICE_MUTAGEN
	];
	view('change-login', $data);
}
elseif ( ! is_null($password_change)) {
	$data = [
		
	];
	view('change-password', $data);
}
elseif ( ! is_null($email_change)) {
	$user = new user(ID);
	$email_confirm_code = $user->get_email_confirm_code();
	if (is_null($email_confirm_code)) {
		$data = [
			'save_mutagen_num' => game::SAVE_MUTAGEN_NUM
		];
		view('change-email', $data);
	} else {
		$data = [
			'email' => $user->get_email()
		];
		view('confirm-code', $data);
	}
	
}
elseif ( ! is_null($character_change)) {
	$turtle = user::turtle_get(ID);
	$character = is_null($character) ? $turtle : $character;
	$data = [
		'character_change_price_mutagen' => game::CHARACTER_CHANGE_PRICE_MUTAGEN,
		'turtle' => $turtle,
		'character' => $character
	];
	view('change-character', $data);
}
else {
	$user_id = ID;
	$user = new user($user_id);
	$user_position = user::position_get($user_id);
	$is_admin_panel = ($user_position > 2) ? true : false;
	$data = [
		'user_id' => $user_id,
		'is_admin_panel' => $is_admin_panel,
		'is_confirm_email' => $user->is_confirm_email(),
		'attached_email_mutagen_num' => game::ATTACHED_EMAIL_MUTAGEN_NUM,
		'referral_percent' => referral::get_bonus(),
		'is_confirm_email' => $user->is_confirm_email()
	];
	view('setting', $data);
}
view('tpl/footer-enter');
view('tpl/footer');