<?php
require ROOT . 'project/internal/core.php';

$app_id = filter_input(INPUT_GET, 'id', FILTER_VALIDATE_INT);
if ( ! support_filter::app_id($app_id)) {
	redirect_return(); // вернуть на страницу с которой пользователь пришёл
}

$user_position = user::position_get(ID);
$support = new support(ID);
$support->app_id = $app_id;
$app = $support->get_app();


// если это обычный пользователь (только модер и админ может смотреть любую заявку, обычный пользоватеь может смотреть только свою)
// и если запись не пренадлежит этому пользователю
if ($user_position < 2 and ($app->id_user != ID)) {
	redirect_return(); // вернуть на страницу с которой пользователь пришёл
}

$open = filter_input(INPUT_GET, 'open');
$close = filter_input(INPUT_GET, 'close');
if ( ! is_null($open)) {
	$support->open_app();
	redirect::go()->subord('support_detail', "id=$app_id");
}
elseif ( ! is_null($close)) {
	$support->close_app();
	redirect::go()->subord('support_detail', "id=$app_id");
}

$comment_text = filter_input(INPUT_POST, 'comment_text');
$comment_result = $support->add_comment($comment_text);
if ( ! is_null($comment_text) || $comment_result) {
	redirect::go()->subord('support_detail', "id=$app_id");
}

$app_comments = $support->get_last_app_comments();

$data = [
	'user_position' => $user_position,
	'app' => $app,
	'app_comments' => $app_comments['app_comments'],
	'pag' => $app_comments['pag']
];

view('tpl/cap');
view('tpl/header');
view('tpl/header-enter');
view('support-detail', $data);
view('tpl/footer-enter');
view('tpl/footer');

if ($user_position > 1) {
	$support->reset_counter_for_admin();
} else {
	$support->reset_counter_for_user();
}